Fri Sep  3 01:28:33 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* objc/objc-act.c (objc_tree_code_type, objc_tree_code_length,
	objc_tree_code_name, synth_id_with_class_suffix, warn_with_method,
	error_with_ivar, gen_declarator, create_builtin_decl,
	my_build_string, generate_descriptor_table, generate_ivars_list,
	generate_dispatch_table, check_protocols, TAG_GETCLASS,
	TAG_GETMETACLASS, TAG_MSGSEND, TAG_MSGSENDSUPER, TAG_EXECCLASS,
	dump_base_name, lang_decode_option, build_encode_expr,
	start_class, finish_class, encode_pointer, really_start_method,
	gen_declaration, dump_interface, handle_class_ref, handle_impent):
	Constify.
	(objc_demangle, objc_printable_name, generate_struct_by_value_array):
	Add static prototypes.
	(build_objc_string_decl, build_selector_reference_decl,
	encode_bitfield, build_class_reference_decl): Remove unused
	parameter, all callers changed.
	(maybe_objc_method_name): Mark with ATTRIBUTE_UNUSED.
	(objc_printable_name): Likewise.  Change second parameter to type int.
	(init_objc): Use memcpy, not bcopy, to avoid casts.

Thu Sep  2 21:49:52 1999  Richard Henderson  <rth@cygnus.com>

	* reload1.c (eliminate_regs_in_insn): Avoid eliminating the
	reg notes on a deleted insn.
	* gcse.c (hash_expr_1): Use XWINT on a CONST_DOUBLE.

Thu Sep  2 20:18:12 1999  Jeffrey A Law  (law@cygnus.com)

	* i386.c (ix86_attr_length_default): Handle TYPE_FXCH.

Thu Sep  2 22:00:08 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* stmt.c (expand_asm_operands): Fix index into inout_mode when
	reading it.

Thu Sep  2 13:00:48 1999  Richard Henderson  <rth@cygnus.com>

	* stmt.c (expand_asm_operands): Invoke MD_ASM_CLOBBERS if present.
	* tm.texi (MD_ASM_CLOBBERS): Document it.

Thu Sep  2 10:22:40 1999  Richard Henderson  <rth@cygnus.com>

	* dwarf2out.c (dwarf2out_line): Constify `lastfile'.
	* except.c (expand_rethrow): Remove unused variable.
	* expr.c (do_jump_by_parts_greater_rtx): Likewise.
	* flow.c (replace_insns): Likewise.
	(create_edge_list, verify_edge_list): Likewise.
	* gcse.c (cprop_cc0_jump): Protect declaration with HAVE_cc0.

	* genemit.c (gen_expand): Only emit `operands[N]' decl if there
	is special code to run.
	(main): Don't define operands to emit_operand.
	* genrecog.c (main): Don't emit an empty peephole2_insn function.

	* rtl.h (NOTE_BASIC_BLOCK): Use X0BBDEF.

	* alpha/alpha.h (normal_memory_operand): Declare.
	(reg_no_subreg_operand): Declare.
	* alpha/elf.h (ASM_DECLARE_OBJECT_NAME): Use HOST_WIDE_INT_PRINT_DEC.

Thu Sep  2 10:19:20 1999  Richard Henderson  <rth@cygnus.com>

	* c-parse.in (compstmt_primary_start): New, broken out of first
	part of compstmt handling in primary.
	(primary): Use it.  Add an error clause.
	(compstmt_nostart): Renamed from compstmt; remove all
	initial invocations of compstmt_start.
	(compstmt): New.

Thu Sep  2 01:35:50 1999  Marc Espie <espie@cvs.openbsd.org>

	* protoize.c (gen_aux_info_file):  Let pexecute call choose_temp_base if
	needed.

Thu Sep  2 00:43:59 1999  Finn Hakansson  <finn@axis.com>

	* combine.c (simplify_shift_const): Remove extra semicolon.
	* dwarf2out.c (remove_AT): Likewise.
	* expmed.c (expand_mult): Likewise.
	* gcov.c (create_program_flow_graph): Likewise.
	* reorg.c (mostly_true_jump): Likewise.

Thu Sep  2 00:06:43 1999  Jeffrey A Law  (law@cygnus.com)

	* fold-const.c (fold_range_test): Do not try to fold the range
	test if the rhs or lhs has side effects.

	* combine.c (simplify_rtx): Recognize another case of a synthesized
	sign extension.

	* varasm.c (mark_constant_pool): When marking indirect references,
	only look at SYMBOL_REFs.

	* except.c (expand_fixup_region_end): Do not peek at
	INSN_UID (node->entry->outer_context) for flag_new_exceptions.

Thu Sep  2 13:52:53 1999  Geoffrey Keating  <geoffk@cygnus.com>

	* flags.h: New variables align_loops, align_loops_log,
	align_jumps, align_jumps_log, align_labels, align_labels_log,
	align_functions, align_functions_log.
	* toplev.c: Define them.
	(f_options): Handle -falign-* when they have no argument.
	(main): Add logic to set variables for -falign-functions,
 	-falign-jumps, -falign-labels, -falign-loops.
	Make it -fsched-verbose=<n> and -finline-limit=<n>.
	(display_help): Change help to match options.
	* final.c (LABEL_ALIGN): Default to align_labels_log.
	(LABEL_ALIGN_MAX_SKIP): Default to align_labels-1.
	(LOOP_ALIGN): Default to align_loops_log.
	(LOOP_ALIGN_MAX_SKIP): Default to align_loops-1.
	(LABEL_ALIGN_AFTER_BARRIER): Default to align_jumps_log.
	(LABEL_ALIGN_AFTER_BARRIER_MAX_SKIP): Default to align_jumps-1.
	* varasm.c (assemble_start_function): Handle align_functions.

	* config/sparc/sparc.h: Don't declare sparc_align_*.
	Don't provide LABEL_ALIGN_AFTER_BARRIER or LOOP_ALIGN.
	(DEFAULT_SPARC_ALIGN_FUNCS): Delete; take functionality into
 	sparc.c.
	(FUNCTION_BOUNDARY): Fix incorrect use---it's not just a request,
	it's a promise.
	* config/sparc/sparc.c: Delete sparc_align_loops,
 	sparc_align_jumps, sparc_align_funcs and the corresponding string
	variables.
	(sparc_override_options): Default align_functions on ultrasparc.
	Delete -malign-* handling.

	* config/mips/mips.c (override_options):  On 64-bit targets,
	try to align code to 64-bit boundaries.
	(print_operand): New substitution, %~,
	which aligns labels to align_labels_log.
	* config/mips/mips.md (div_trap_normal): Use %~.
	(div_trap_mips16): Likewise.
	(abssi): Likewise.
	(absdi2): Likewise.
	(ffssi2): Likewise.
	(ffsdi2): Likewise.
	(ashldi3_internal): Likewise.
	(ashrdi3_internal): Likewise.
	(lshrdi3_internal): Likewise.
	(casesi_internal): Likewise.

Wed Sep  1 21:13:48 1999  Richard Henderson  <rth@cygnus.com>

	Merge new ia32 backend from the branch!

	* i386.h, i386.c, i386.md, reg-stack.c, i386/unix.h: Many changes.
	See ChangeLog.P2 on new_ia32_branch for details.

	* rtl.h (stack_regs_mentioned_p): Delete prototype.
	* i386/cygwin.h (SUBTARGET_PROLOGUE): No more do_rtl.
	* i386/win32.h (SUBTARGET_PROLOGUE): Likewise.
	* i386/gas.h (ASM_FILE_START): Define.
	* i386/winnt.c (i386_pe_valid_decl_attribute_p): Update
	for name change of ix86_valid_decl_attribute_p.
	(i386_pe_valid_type_attribute_p): Similarly.

Wed Sep  1 18:21:23 1999  Richard Henderson  <rth@cygnus.com>

	* emit-rtl.c (init_emit_once): Don't use GET_MODE_WIDER_MODE
	to step through CC modes.

Wed Sep  1 20:18:06 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* regmove.c (fixup_match_1): Don't move INSN in front of P if
	it would end up in the shadow of a live flags regsiter.

Wed Sep  1 11:32:00 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* reload1.c: Fix many indentation problems.
	* reload.c: Likewise.

Tue Aug 31 22:08:03 1999  Marc Espie <espie@cvs.openbsd.org>

	* alias.c (non_local_reference_p): Constify fmt.

Tue Aug 31 23:19:35 1999  Michael Meissner  <meissner@cygnus.com>

	* config/i386/xm-cygwin.h (HAVE_DOS_BASED_FILE_SYSTEM): Define.

Tue Aug 31 16:44:52 1999  Jeffrey A Law  (law@cygnus.com)

	* cse.c (delete_trivially_dead_insns): Do not delete stores to
	the internal_arg_pointer.

Tue Aug 31 13:35:42 1999  Richard Henderson  <rth@cygnus.com>

	Merge peephole2 from new_ia32_branch:
	* Makefile.in (STAGESTUFF): Add *.peephole2.
	(mostlyclean): Likewise.
	(recog.o): Depend on resource.h.

	* final.c (peephole): Conditionalize decl on HAVE_peephole.
	(final_scan_insn): Likewise for the invocation of peephole.
	* genconfig.c (main): Look for peephole and peephole2 patterns.
	Emit HAVE_peephole* accordingly.
	* genpeep.c (main): Conditionalize entire output on HAVE_peephole.
	* flags.h (flag_peephole2): Declare.
	* toplev.c: New pass peephole2.  New flag -fpeephole2.
 
	* genattrtab.c (main): Count DEFINE_PEEPHOLE2.
	* gencodes.c (main): Likewise.
	* genextract.c (main): Likewise.
	* genoutput.c (main): Likewise.
	* genemit.c (max_operand_1): Look for the max scratch operand.
	(gen_rtx_scratch): New.
	(gen_exp): Use it, and pass on new arg subroutine_type.
	(gen_expand): Take max scratch into account.
	(gen_split): Emit peephole2 functions.
	(output_peephole2_scratch): New.
	(main): Include hard-reg-set.h and resource.h.  Handle peephole2.
	* genrecog.c (routine_type): Add PEEPHOLE2.
	(IS_SPLIT): New.
	(make_insn_sequence): Match outer parallel for peep2.  Discard
	top level scratches and dups.
	(add_to_sequence): New args insn_type and top.  Update all callers.
	Handle toplevel peep2 matching insns.
	(write_subroutine): Handle peep2.
	(write_tree_1): Likewise.
	(write_tree): Likewise.
	(main): Likewise.
	(change_state): New arg afterward.  Update all callers.
	Handle matching separate insns.
	* recog.c (recog_next_insn): New.
	(peephole2_optimize): New.
	* rtl.def (DEFINE_PEEPHOLE2): New.
	* resource.c (find_free_register): New argument last_insn.  Use it
	to find a register available through the entire span.
	* resource.h (find_free_register): Update prototype.

Tue Aug 31 11:51:06 1999  Jim Kingdon  <http://developer.redhat.com>

	* i386.c (output_strlen_unroll): Don't write xops[7]
	label if it wasn't set.

1999-08-31 12:44 -0700  Zack Weinberg  <zack@bitmover.com>

	* cpplib.c (struct directive): Const-ify name pointer and
	function pointer prototype.
	(validate_else, do_define, do_line, do_include, do_undef,
	do_error, do_pragma, do_ident, do_if, do_xifdef, do_else,
	do_elif, do_endif, do_sccs, do_assert, do_unassert,
	do_warning): Const-ify second arg.
	(directive_table): Mark const.  Reorder entries by frequency
	of usage, record statistics.

1999-08-31 12:20 -0700 Zack Weinberg <zack@bitmover.com>

	* rtl.h (RTL_CHECK1, RTL_CHECK2): New macros which type- and
	bounds- check RTL accesses if --enable-checking.
	(RTVEC_ELT): Bounds check if --enable-checking.
	(XWINT, XINT, XSTR, XEXP, XVEC, XMODE, XBITMAP, XTREE,
	XBBDEF): Use RTL_CHECK1/RTL_CHECK2 as appropriate.
	(XVECEXP, XVECLEN): Define in terms of XVEC, RTVEC_ELT, and
	GET_NUM_ELEM.
	(X0WINT, X0INT, X0STR, X0EXP, X0VEC, X0MODE, X0BITMAP, X0TREE,
	X0BBDEF, X0ADVFLAGS):  New macros for accessing '0' slots of RTXes.

	(ADDR_DIFF_VEC_FLAGS): Use X0ADVFLAGS.
	(NOTE_SOURCE_FILE): Use X0STR.
	(NOTE_BLOCK_NUMBER, NOTE_EH_HANDLER, LABEL_NUSES,
	MEM_ALIAS_SET): Use X0INT.
	(NOTE_RANGE_INFO, NOTE_LIVE_INFO, NOTE_BASIC_BLOCK,
	JUMP_LABEL, LABEL_REFS, LABEL_NEXTREF, CONTAINING_INSN):
	Use X0EXP.
	* real.h (CONST_DOUBLE_CHAIN): Use X0EXP.
	* rtl.c (copy_rtx, copy_most_rtx): Copy '0' slots with X0WINT.
	(rtl_check_failed_bounds, rtl_check_failed_type1,
	rtl_check_failed_type2, rtvec_check_failed_bounds): New
	functions.
	(fancy_abort): Fix comment.

	* cse.c (canon_hash): Read CONST_DOUBLE data slots with XWINT.
	(cse_insn): Decrement LABEL_NUSES for jump target before
	deleting jump insn.
	* emit-rtl.c (gen_rtx_CONST_DOUBLE): Use X0EXP for slot 1.
	* final.c (alter_subreg): Compute regno before changing x to
	REG; set REGNO(x) after changing it.
	* flow.c (count_basic_blocks): Use XWINT to inspect EH_REGION
	notes containing CONST_INTs.
	(delete_eh_regions): Use NOTE_EH_HANDLER.
	* function.c (put_reg_into_stack): Make reg a MEM before
	initializing it.
	(fixup_var_refs_insns):  Save REG_NOTES (insn) in case we
	delete insn.
	(gen_mem_addressof): Make reg a MEM before initializing it.
	* integrate.c (copy_rtx_and_substitute): Copy '0' slots with
	X0WINT.
	* local-alloc.c (update_equiv_regs): Zap REG_NOTES before
	deleting an insn, not after.
	(block_alloc): Only look at PATTERN(insn) if we have to, and
	only if it's format class 'i'.
	* loop.c (check_dbra_loop): Check bl->biv->add_val is a
	CONST_INT before using its INTVAL.
	* print-rtl.c (print_rtx): Use X0STR.
	* regmove.c (fixup_match_1): Don't look at PATTERN of
	non-class-'i' insn chain elements.
	* reload.c (loc_mentioned_in_p): Take address of
	in->fld[1].rtx directly.
	* reload1.c (reload): Change reg to a MEM before initializing
	it.
	* varasm.c (mark_constant_pool): Skip CONST_DOUBLES, which
	have no names.
	* config/i386/i386.md (decrement_and_branch_if_zero): Fix typo.

Fri Aug 20 13:43:41 1999  Andrew Haley  <aph@cygnus.com>

	* config/mips/mips.c (machine_dependent_reorg): Force a
	barrier to output the local constant pool if a barrier hasn't
	been found at a natural point in the instruction stream.

Mon Aug 30 22:04:36 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-parse.in (language_string): Constify.

	* dwarf2out.c (language_string): Remove declaration.

	* dwarfout.c (language_string): Likewise.

	* toplev.c (language_string, init_parse, finish_parse): Likewise.

	* tree.h (language_string, init_parse, finish_parse): Declare.

	* i386/sun386.h (language_string): Remove declaration.

	* mips.h (language_string): Likewise.

	* nextstep.h (language_string): Likewise.

	* nextstep21.h (language_string): Likewise.

	* rs6000.c (language_string): Likewise.

Mon Aug 30 20:56:08 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (OBJS, PROTO_OBJS): Remove getpwd.o.
	(getpwd.o): Remove target.

	* getpwd.c: Delete file.  Its in libiberty now.

	* dbxout.c (getpwd): Don't prototype.
	* dwarf2out.c (getpwd): Likewise
	* dwarfout.c (getpwd): Likewise
	* final.c (getpwd): Likewise.
	* protoize.c (getpwd): Likewise.

Mon Aug 30 20:21:34 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* cse.c: (fold_rtx): Cast to HOST_WIDE_INT in left shift.

Mon Aug 30 16:07:49 1999  Richard Henderson  <rth@cygnus.com>

	* flow.c (new_insn_dead_notes): Use sets_reg_or_subreg not
	mark_set_resources.

Mon Aug 30 12:23:53 1999  Jim Wilson  <wilson@cygnus.com>

	* fixinc/Makefile.in (subdir): New.
	(fixincl.x, inclhack.sh, fixincl.sh): Use cp instead of $(CP).
	(Makefile): New.

Mon Aug 30 01:02:09 1999  Jeffrey A Law  (law@cygnus.com)

	* emit-rtl.c (copy_rtx_if_shared): A MEM which references
	virtual_stack_vars_rtx or virtual_incoming_args_rtx can not
	be shared.

	* invoke.texi: Fix typo.

	* dwarf2out.c (mem_loc_descriptor): New argument MODE.  All callers
	changed.  Handle autoincrement addressing modes.

	* integrate.c (copy_rtx_and_substitute): Handle internal_arg_pointer
	just like we would the virtual incoming args register when
	integrating.

Sun Aug 29 23:17:54 1999  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.h (ASM_FILE_START): Specify complete filename, including
	path, in .file directive.

Sun Aug 29 05:06:43 1999  Russ Allbery  <rra@stanford.edu>

	* gcc.texi (External Bugs): Remove obsolete note about Perl on
	SunOS.

1999-08-29 08:38 -0700  Zack Weinberg  <zack@bitmover.com>

	* stdbool.h: Make the typedef name _Bool, with bool a #defined
	alias.

Sun Aug 29 09:36:50 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* tree.c (tree_code_name): Constify a char*.

	* tree.h (tree_code_name, decl_printable_name): Likewise.

	* function.h (struct function): Likewise.

	* toplev.c (decl_name, decl_printable_name): Likewise.

	* vax/vms.h (MAYBE_VMS_FUNCTION_PROLOGUE): Likewise.

	* objc/objc-act.c (decl_printable_name): Remove redundant prototype.
	(init_objc): Remove function pointer cast.

Sun Aug 29 05:01:17 1999  John David Anglin <dave@hiauly1.hia.nrc.ca>

	* pa.md (interspace_jump): New pattern.
	(builtin_longjmp): New expander.

1999-08-29  Bernd Schmidt  <bernds@cygnus.co.uk>

	* fp-bit.c (add, sub, multiply, divide, compare, _eq_f2, _ne_f2,
	_gt_f2, _ge_f2, _lt_f2, _le_f2, float_to_si, float_to_usi, negate,
	sf_to_df, df_to_sf): Fix potential problem with alias analysis.

Sun Aug 29 04:30:52 1999  John Wehle  (john@feith.com)

	* jump.c (delete_prior_computation): Also check calls
	to constant functions.  Don't bother checking for a
	REG_UNUSED note before adding it.
	(delete_computation): Handle multi-word hard registers
	when synthesizing missing REG_DEAD notes for a register
	which is both set and used by an insn.

1999-08-29  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* loop.c (this_loop_info): New variable.
	(loop_has_call, loop_has_volatile, loop_has_tablejump,
	loop_continue, loops_enclosed): Replace with fields in this_loop_info.
	All uses updated.
	(prescan_loop, strength_reduce): New argument loop_info.  All callers
	updated.
	(scan_loop): New variable loop_info, initialise to address of
	this_loop_info.
	(prescan_loop): Set loop_info->vtop if find NOTE_INSN_LOOP_VTOP.
	Delete variable loop_has_multiple_exit targets and replace with
	field in this_loop_info.
	(find_and_verify_loops): Rename this_loop to this_loop_num.
	(strength_reduce): Delete loop_iteration_info.  Replace variable
	loop_info with function argument of same name.
	(insert_bct): Rework test for loop being completely unrolled.

	* loop.h (struct loop_info): New fields num, loops_enclosed,
	has_call, has_volatile, has_tablejump, has_multiple_exit_targets,
	has_indirect_jump, and cont.  Redefine use of unroll_number.
	(loop_unroll_number): Delete.

	* unroll.c (unroll_loop): Store loop unroll count in unroll_number
	field of loop_info.
	(loop_iterations): Delete variable vtop and instead use
	loop_info->vtop computed in prescan_loop.

Sun Aug 29 03:27:23 1999  Scott Weikart <scott@igc.apc.org>

	* fix-header.c (main): Do not pass a null pointer to strcmp.

Sun Aug 29 03:18:48 1999  William Bader  (william@nscs.fast.net)

	* configure.in (i[34567]86-*-sco3.2v4*): Target does not truncate
	filenames.
	* configure: Rebuilt.

Sat Aug 28 19:36:05 1999  Jeffrey A Law  (law@cygnus.com)

	* jump.c (jump_optimize_1): Do not delete assignments to
	internal_arg_pointer.
	* cse.c (delete_trivially_dead_insns): Always consider a set of
	the internal_arg_pointer live.

Sat Aug 28 16:24:31 1999  Richard Henderson  <rth@cygnus.com>

	* flow.c (flow_delete_insn_chain): Rename from delete_insn_chain.
	(update_life_info) [REG_WAS_0]: Search the original insns rather
	than the new insns for the note.  Fix typos finding note_dest.
	If no dest found, discard the note rather than abort.
	[REG_NOALIAS]: Handle as REG_NO_CONFLICT.
	(replace_insns): Remove the old insn list after update_life_info
	not before.

Sat Aug 28 16:20:12 1999  Richard Henderson  <rth@cygnus.com>

        * haifa-sched.c (sched_analyze): Clear LOG_LINKS before calling
        sched_analyze_insn.
        (sched_analyze_1): Let add_dependence care for not adding dups.
        (sched_analyze_2): Likewise.
        (add_branch_dependences): Likewise.

Sat Aug 28 15:58:16 1999  Mumit Khan  <khan@xraylith.wisc.edu>

	* i386/winnt.c (export_list): New type.
	(exports_head): Rename to
	(export_head):  this.
	(i386_pe_record_exported_symbol): Add is_data flag.
	(i386_pe_asm_file_end): Emit directive for exported variables.
	* i386/cygwin.h (i386_pe_record_exported_symbol): Update
	prototype.
	* i386/cygwin.h (ASM_OUTPUT_COMMON): Specify symbol type.
	(ASM_DECLARE_OBJECT_NAME): Likewise.
	(ASM_DECLARE_FUNCTION_NAME): Likewise.
	* i386/uwin.h (ASM_DECLARE_FUNCTION_NAME): Likewise.

Fri Aug 27 15:35:24 1999  Jeffrey A Law  (law@cygnus.com)

	* cse.c (fold_rtx): Work around bug in Sun V5.0 compilers.

	* pa.c (emit_move_sequence): Do not stop on SUBREG_WORD of an
	operand.

Fri Aug 27 14:01:19 1999  Marc Espie <espie@cvs.openbsd.org>

	* config/openbsd.h: Define SET_ASM_OP.
	* tm.texi: cross-reference SET_ASM_OP in the index.

1999-08-27 13:27 -0700  Zack Weinberg  <zack@bitmover.com>

	* rtl.c: Define CONST_DOUBLE_FORMAT to the appropriate format
	for a CONST_DOUBLE, at compile time.  Initialize rtx_length
	and class_narrowest_mode at compile time.  Kill init_rtl.
	Mark rtx_length, mode_class, mode_size, mode_unit_size,
	mode_wider_mode, mode_mask_array, class_narrowest_mode, and
	rtx_format as const.  Kill all references to EXTRA_CC_MODES or
	EXTRA_CC_NAMES.
	* rtl.def (CONST_DOUBLE): Use CONST_DOUBLE_FORMAT macro for
	format.
	* rtl.h: Declare rtx_length and rtx_format as const.
	* machmode.def: Define CC().  Use CC() to define CCmode.  If
	EXTRA_CC_MODES is defined, expand it here.
	* machmode.h: Declare mode_class, mode_size, mode_unit_size,
	mode_wider_mode, mode_mask_array, and class_narrowest_mode as
	const.  Kill all references to EXTRA_CC_MODES.

	* toplev.c: Don't prototype or call init_rtl.
	* optabs.c: Don't call init_mov_optab.
	* genemit.c: Don't generate init_mov_optab.  Don't call
	init_rtl.
	* gengenrtl.c: Duplicate calculation of CONST_DOUBLE_FORMAT
	here.
	* genattr.c, genattrtab.c, gencodes.c, genconfig.c,
	genextract.c, genflags.c, genopinit.c, genoutput.c, genpeep.c,
	genrecog.c: Don't call init_rtl.

	* arc.h, arm.h, c4x.h, i386.h, i960.h, m88k.h, pa.h, pdp11.h,
	rs6000.h, sparc.h: Don't define EXTRA_CC_NAMES.  Use CC() in
	definition of EXTRA_CC_MODES.

	* md.texi: Kill ref to EXTRA_CC_NAMES.
	* tm.texi: Document new way to define EXTRA_CC_MODES.

	* genrecog.c: Do not look up the name of a define_split.
	(Unrelated bugfix.)

Fri Aug 27 17:03:42 1999  Nick Clifton  <nickc@cygnus.com>

	* config/v850/v850.md: Fix typo introduced by previous delta.

Fri Aug 27 09:48:59 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* gcc.c (fatal): Make definition static to match prototype.

Fri Aug 27 10:33:35 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* combine.c (get_last_value): Don't look for earlier sets if the last
	known set is somewhere in between the insns being combined.

Fri Aug 27 10:03:12 BST 1999  Nathan Sidwell  <nathan@acm.org>

	* configure.in: Don't use shell ! to negate exit codes
	* configure: Regenerate

Fri Aug 27 09:36:17 1999  Andreas Schwab  <schwab@suse.de>

	* function.c (assign_stack_temp_for_type): Fix change of Mar 5 for
	the fact that ALIGN is measured in bits, not bytes.

1999-08-27 00:27 -0700  Zack Weinberg  <zack@bitmover.com>

	* errors.c: New file; defines functions error, warning, and
	fatal, variables have_error and progname.
	* errors.h: New file; prototypes and decls for stuff in errors.c.

	* Makefile: Add rules to build errors.o and
	$(HOST_PREFIX)errors.o.  Link genconfig, gencodes, genemit,
	genopinit, genrecog, genextract, genpeep, genattr, and
	genoutput with errors.o.  Add errors.h to deps of genconfig.o,
	gencodes.o, genemit.o, genopinit.o, genrecog.o, genextract.o,
	genpeep.o, genattr.o, and genoutput.o.

	* genconfig.c, gencodes.c, genemit.c, genopinit.c, genrecog.c,
	genextract.c, genpeep.c, genattr.c:  Include errors.h.  Don't
	define or prototype fatal.  Set progname at beginning of main.
	* genoutput.c:  Likewise, and don't define or prototype error
	either.

	* c-typeck.c (c_expand_start_case): Return immediately if exp
	is an ERROR_MARK.
	* fold-const.c (operand_equal_p): Return immediately if arg1
	or arg0 are ERROR_MARKs.
	* stor-layout.c (layout_type [case RECORD_TYPE]): Ignore
	fields of type ERROR_MARK when calculating if the record can
	go in a register.

Fri Aug 27 01:03:48 1999  Jim Kingdon  <http://developer.redhat.com>
	with much help from Jeffrey A Law and Richard Henderson

	* i386.md: In the 6 insns which call output_fix_trunc,
	earlyclobber operands[0].

Fri Aug 27 01:01:51 1999  Philip Blundell  <pb@nexus.co.uk>

	* jump.c (duplicate_loop_exit_test): Call reg_scan_update after
	creating new registers.

1999-08-26 23:09 -0700  Zack Weinberg  <zack@bitmover.com>

	* i386.h: Declare ix86_cpu_string, ix86_arch_string,
	i386_reg_alloc_order, i386_regparm_string,
	i386_align_loops_string, i386_align_jumps_string,
	i386_align_funcs_string, i386_preferred_stack_boundary_string,
	and i386_branch_cost_string as type "const char *".
	* i386.c: Define all above strings as type "const char *".

Thu Aug 26 20:36:30 1999  Jim Wilson  <wilson@cygnus.com>

	* dwarf2out.c (output_aranges): Check DWARF_OFFSET_SIZE not PTR_SIZE
	when emitting alignment padding.  Emit padding byte of 0 instead of 4.

Thu Aug 26 18:11:20 1999  Mark Mitchell  <mark@codesourcery.com>

	* tree.c (array_type_nelts): Don't create RTL_EXPRs from
	SAVE_EXPRs unless the SAVE_EXPRs have already been expanded.

Thu Aug 26 19:33:23 1999  Jim Wilson  <wilson@cygnus.com>

	* dwarf2out.c (DWARF2_ASM_LINE_DEBUG_INFO): Add default definition.
	(debug_dwarf): Add DWARF2_ASM_LINE_DEBUG_INFO support.
	(dwarf2out_line, dwarf2out_finish): Likewise.
	* tm.texi (DWARF2_ASM_LINE_DEBUG_INFO): Add documetation.

Thu Aug 26 16:10:56 1999  Gavin Romig-Koch  <gavin@cygnus.com>

	* tree.c (lang_unsave_expr_now) : Correct return type.
	* tree.h (lang_unsave_expr_now) : Same.

Thu Aug 26 13:12:29 1999  Jeffrey A Law  (law@cygnus.com)

	* pa.c (cint_ok_for_move): Use CONST_INT_OK_FOR_LETTER_P macros
	instead of duplicating code.

Thu Aug 26 18:32:32 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* gcse.c (hash_scan_insn): Don't scan obvious no-ops.

1999-08-26 09:42 -0700  Zack Weinberg  <zack@bitmover.com>

	* tree.h: fancy_abort always takes three args.
	* resource.c: Move include of system.h before toplev.h.

Thu Aug 26 09:46:16 1999  Nick Clifton  <nickc@cygnus.com>

	* dwarf2out.c (mem_loc_descriptor): Accept LABEL_REFs as well
	as SYMBOL_REFs.

1999-08-25 22:10 -0700  Zack Weinberg  <zack@bitmover.com>

	* system.h: Don't redefine abort or trim_filename.
	* rtl.h: Define abort to fancy_abort (__FILE__, __LINE__, 0)
	or fancy_abort (__FILE__, __LINE__, __FUNCTION__) depending on
	whether or not __FUNCTION__ is available.
	* tree.h: Duplicate rtl.h's definition of abort, for files
	that don't include rtl.h.  Delete all code to perform type
	checking with a compiler other than GCC.
	* varray.h: Delete all code to perform type checking with a
	compiler other than GCC.  Make VARRAY_CHECK() always evaluate
	its arguments exactly once, using a statement expression.
	Adjust the VARRAY_<type> accessor macros to match.
	* toplev.h (fatal_insn, fatal_insn_not_found): Kill.
	(_fatal_insn, _fatal_insn_not_found): New fns, take info on
	caller's location.  Define fatal_insn and fatal_insn_not_found
	as macros that use _fatal_insn and _fatal_insn_not_found.
	(fancy_abort, trim_filename): Kill prototypes.

	* rtl.c (trim_filename): Move here from toplev.c.
	(fancy_abort): New function.
	(DIR_SEPARATOR): Provide default definition.
	* tree.c (tree_check_failed, tree_class_check_failed): Go
	through fancy_abort.
	(tree_check, tree_class_check, cst_or_constructor_check,
	expr_check): Delete.
	* varray.c (varray_check_failed): New function.
	* toplev.c (fatal_insn, fatal_insn_not_found): Replace with
	_fatal_insn and _fatal_insn_not_found.  Go through
	fancy_abort.
	(trim_filename, fancy_abort): Delete.

	* builtins.c (expand_builtin_args_info): Report ICE with abort.
	* except.c (start_catch_handler): Report ICE with error/abort
	combo.
	* final.c (output_operand_lossage): Likewise.
	* flow.c (verify_flow_info): Likewise.

	* gcc.c: Prototype fatal.
	* gengenrtl.c: Undef abort after including rtl.h not system.h.
	* genattr.c, genattrtab.c, genemit.c, genextract.c,
	genflags.c, genopinit.c, genoutput.c, genpeep.c, genrecog.c:
	Don't define fancy_abort.

Wed Aug 25 17:56:59 1999  Richard Henderson  <rth@cygnus.com>

	* optabs.c (emit_cmp_and_jump_insns): Be more thorough in
	canonization.

Wed Aug 25 15:35:55 1999  Richard Henderson  <rth@cygnus.com>

	* m88k.h (VERSION_INFO2): Kill.
	(VERSION_STRING): Kill.
	(TM_RCS_ID): Kill.
	(VERSION_INFO1): Tidy.
	(TARGET_VERSION): Update.
	* m88k/dgux.h (VERSION_INFO2): Kill.
	(ASM_FIRST_LINE): Adjust for death of VERSION_STRING.
	* m88k/luna.h (VERSION_INFO1): Tidy.
	* m88k/sysv4.h (VERSION_INFO1): Likewise.
	* m88k.c (out_rcs_id, tm_rcs_id): Kill.
	(output_file_start): Adjust for death of VERSION_STRING.

1999-08-25 13:51 -0700  Jim Meyering  <meyering@ascend.com>

	* cpplib.c (detect_if_not_defined): New function.
	(do_if): Use it to detect potential once-only headers.

Wed Aug 25 14:00:18 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* c-common.c (combine_strings): Always set TREE_CONSTANT.

Wed Aug 25 15:27:22 1999  Gavin Romig-Koch  <gavin@cygnus.com>

	* combine.c (nonzero_bits) : Allow single-ly set registers to be
	anywere in the function only if they are pseudos and set before
	being used (not live at the start of the function).
	(num_sign_bit_copies) : Same.
	(get_last_value_validate) : Same.
	(get_last_value) : Same.

Wed Aug 25 11:13:29 1999  Richard Henderson  <rth@cygnus.com>

	* loop.c (express_from): Try harder to unify (* c N) and (* c M)
	where N and M are constant and N is an integer multiple of M.

Wed Aug 25 13:55:47 EDT 1999  Andrew MacLeod  <amacleod@cygnus.com>

	* sbitmap.h (sbitmap_intersection_of_succs): Add prototype.
	(sbitmap_intersection_of_preds, sbitmap_union_of_succs,
	sbitmap_union_of_preds): Add prototypes.
	* sbitmap.c (sbitmap_intersection_of_succs): New function to compute
	the intersection of successors with the new flow graph structures.
	(sbitmap_intersection_of_preds): New function to compute the
	intersection of predecessors with the new flow graph structures.
	(sbitmap_union_of_succs): New function to compute the union of
	successors with the new flow graph structures.
	(sbitmap_union_of_preds): New function to compute the union of
	predecessors with the new flow graph structures.
	* gcse.c (compute_rdm, compute_available): Use new sbitmap routines.
	(expr_reaches_here_p): Use edge and basic_block structures instead
	of s_preds and s_succs.
	(compute_cprop_avinout): Use new sbitmap routines.
	(pre_expr_reaches_here_p): Use edge and basic_block structures instead
	of s_preds and s_succs.
	* flow.c (compute_flow_dominators): Compute dominators using
	edges and basic blocks instead of s_preds and s_succs.

Wed Aug 25 13:41:47 EDT 1999  Andrew MacLeod  <amacleod@cygnus.com>

	* lists.c (unused_insn_list, unused_expr_list): New file for
	maintaining various types of lists. New statics for maintaining a
	cache of available INSN_LIST and EXPR_LIST nodes.
	(free_list): Static function for freeing a list of INSN/EXPR nodes.
	(alloc_INSN_LIST): Function to get a free INSN_LIST node.
	(alloc_EXPR_LIST): Function to get a free EXPR_LIST node.
	(init_EXPR_INSN_LIST_cache): Initialize the cache lists.
	(free_EXPR_LIST_list): Free an entire list of EXPR_LIST nodes.
	(free_INSN_LIST_list): Free an entire list of INSN_LIST nodes.
	(free_EXPR_LIST_node): Free an individual EXPR_LIST node.
	(free_INSN_LIST_node): Free an individual INSN_LIST node.
	* haifa-sched.c (unused_insn_list, unused_expr_list): Moved to flow.c
	(free_list, alloc_INSN_LIST, alloc_EXPR_LIST): Moved to flow.c
	(remove_dependence, free_pending_lists): Use new global routines.
	(flush_pending_lists, sched_analyze_insn): Use new global routines.
	(sched_analyze, compute_block_backward_dependences): Use new routines.
	(sched_analyze_1, sched_analyze_2): Use new routines.
	(schedule_insns): Use new global routines.
	* rtl.h (init_EXPR_INSN_LIST_cache, free_EXPR_LIST_list): Add function
	prototypes.
	(free_INSN_LIST_list, free_EXPR_LIST_node): Add prototypes.
	(free_INSN_LIST_node, alloc_INSN_LIST, alloc_EXPR_LIST): Add function
	prototypes.
	* toplev.c (rest_of_compilation): Initialize node cache.
	* Makefile.in (OBJS): Add lists.o to list of object files.
	(lists.o): Add dependancies.

Wed Aug 25 17:31:56 1999  Nick Clifton  <nickc@cygnus.com>

	* config/v850/v850.md: Fix compile time warning messages.
	* config/v850/v850.c: Fix compile time warning messages.
	* config/v850/v850.h: Fix compile time warning messages.

Wed Aug 25 09:44:43 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* genattr.c (gen_attr): Add prototype arguments for get_attr_*().
	Remove unused prototype for `init_lengths'.

Wed Aug 25 09:32:31 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* calls.c (emit_call_1): Mark parameter `stack_size' with
	ATTRIBUTE_UNUSED.
	(expand_call): Initialize variable `insn'.
	(emit_library_call): Likewise for variable `high_to_save'.
	(emit_library_call_value): Likewise.
	(store_one_arg): Likewise for variables `lower_bound' and
	`upper_bound'.

	* combine.c (try_combine): Likewise for variables `i2_code_number'
	and `other_code_number'.
	(find_split_point): Likewise for variables `pos', `unsignedp' and
	`inner'.
	(simplify_if_then_else): Likewise for variables `op' and `c1'.
	(simplify_and_const_int): Remove unused variable `width'.
	(merge_outer_ops): Likewise.

	* cse.c (simplify_binary_operation): Cast an INTVAL() to `unsigned
	HOST_WIDE_INT' when comparing against one.
	(simplify_relational_operation): Likewise.
	(cse_insn): Initialize variables `src_eqv_volatile',
	`src_eqv_in_memory', `src_eqv_in_struct', `src_eqv_hash' and `sets'.

	* final.c (init_final): Constify parameter `filename'.
	(final_start_function): Mark parameter `optimize' with
	ATTRIBUTE_UNUSED.
	(profile_function): Likewise for parameters `first' and `optimize'.
	(output_source_line): Likewise for parameter `file'.

	* integrate.c (subst_constants): Cast a value to `size_t' when
	comparing against one.
	(mark_stores): Initialize variable `mode'.  Cast a value to
	`size_t' when comparing against one.

	* integrate.h (MAYBE_EXTEND_CONST_EQUIV_VARRAY): Likewise.

	* loop.c (move_movables): Initialize variable `first'.
	(strength_reduce): Likewise for variable `increment'.
	(check_dbra_loop): Likewise for variable `comparison_val'.  Cast a
	value to `size_t' when comparing against one.
	(load_mems): Initialize variable `end_label'.

	* output.h (init_final): Constify parameter.

	* reload.c (decompose): Initialize variable `base'.

	* reload1.c (reload): Likewise for variable `is_scalar'.
	(spill_hard_reg): Mark parameter `dumpfile' with ATTRIBUTE_UNUSED.
	(choose_reload_regs): Initialize variable `mode'.
	(emit_reload_insns): Likewise for variable `store_insn'.
	(reload_cse_noop_set_p): Mark parameter `insn' with
	ATTRIBUTE_UNUSED.
	(reload_combine): Initialize variable `set'.

	* unroll.c (unroll_loop): Likewise for variable `local_label'.
	(copy_loop_body): Cast a value to `size_t' when comparing against
	one.

	* varasm.c (assemble_variable): Initialize variable `size_tree'.
	(const_hash): Add an `else abort()' in an if-else-if-else sequence.
	(remove_from_pending_weak_list): Mark parameter `name' with
	ATTRIBUTE_UNUSED.

Wed Aug 25 11:18:39 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* toplev.c (rest_of_compilation): Use decl_printable_name when opening
 	gcse dump file.

Wed Aug 25 10:57:12 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/telf.h (ASM_WEAKEN_LABEL): Define.
	(ASM_DECLARE_FUNCTION_NAME): Define.
	(TYPE_ASM_OP, SIZE_ASM_OP, TYPE_OPERAND_FORMAT,
	ASM_DECLARE_RESULT, ASM_DECLARE_OBJECT_NAME,
	ASM_FINISH_DECLARE_OBJECT, ASM_DECLARE_FUNCTION_SIZE): Define if
	not already defined.

Wed Aug 25 01:36:11 1999  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* calls.c (emit_call_1): Use call_pop/call_value_pop for all values
	of n_popped when call/call_value are not defined.

Wed Aug 25 01:25:14 1999  Jeffrey A Law  (law@cygnus.com)

	* tm.texi: GNU CC -> GCC conversion.
	(CC1_SPEC): Indicate it is used for all language front ends.

Tue Aug 24 23:43:03 1999  Mark Mitchell  <mark@codesourcery.com>

	* flow.c (delete_block): Spell NOTE_INSN_EH_REGION_BEG and
	NOTE_INSN_EH_REGION_END correctly.

Tue Aug 24 23:26:44 1999  Michael Tiemann  <tiemann@holodeck.cygnus.com>
			  Jeff Law <law@cygnus.com>

	* loop.c (strength_reduce): Automatically unroll loops if the
	unrolled loop size is smaller than the rolled loop size.

	* loop.c (insert_bct): Replace use of sdiv_optab with asr_optab
	and delete comment that code should be rewritten.

Tue Aug 24 22:56:35 1999  Jeffrey A Law  (law@cygnus.com)

	* haifa-sched.c (find_rgns): Mark a block found during the DFS search
	as reachable.

	* haifa-sched.c (get_visual_tbl_length): Fix off-by-one error.

Tue Aug 24 22:41:06 1999  Mumit Khan  <khan@xraylith.wisc.edu>

	* fixinc/mkfixinc.sh: Don't fix uwin headers.
	* i386/uwin.h (MD_STARTFILE_PREFIX): Define.
	(LINK_SPEC): Add -u _main when building executables.
	(ASM_DECLARE_FUNCTION): Update from Cygwin.
	(ASM_FILE_END): Use the default for ix86-pe.
	* i386/xm-uwin.h (HAVE_BCOPY): Undefine.

Tue Aug 24 20:49:47 1999  Art Haas  <ahaas@neosoft.com>

	* final.c (output_addr_const): Handle case where ASM_OPEN_PAREN
	and ASM_CLOSE_PAREN are empty strings.

Wed Aug 25 12:46:22 1999  Fred Fish  <fnf@cygnus.com>
			  Geoffrey Keating <geoffk@cygnus.com>

	* Makefile.in (PREPROCESSOR_DEFINES): New macro.
	(protoize.o):  Use PREPROCESSOR_DEFINES and DRIVER_DEFINES.
	(unprotoize.o): Ditto.
	(test-protoize-simple): Don't define STD_PROTO_DIR.
	* protoize.c: Use PARAMS rather than PROTO.  Minor whitespace
	changes to make 'test-protoize-simple' pass.
 	(STD_PROTO_DIR): Remove define.
	(STANDARD_EXEC_PREFIX): Supply default define.
	(standard_exec_prefix): New variable, init to STANDARD_EXEC_PREFIX.
	(target_machine): New variable, init to DEFAULT_TARGET_MACHINE.
	(target_version): New variable, init to DEFAULT_TARGET_VERSION.
	(GET_ENV_PATH_LIST): New macro.
	(default_syscalls_dir): No longer initialized to STD_PROTO_DIR.
	(do_processing): Initialize default_syscalls_dir using new
	macros.  Use it to initialize syscalls_absolute_filename.

Tue Aug 24 16:58:15 1999  Richard Henderson  <rth@cygnus.com>

	* jump.c (jump_optimize_1): Do cmov opt on any single-set; force
	B into a register before emit_conditional_move.

Tue Aug 24 15:37:03 1999  Richard Henderson  <rth@cygnus.com>

	* fold-const.c (fold): Reassociate (+ (+ (* a b) c) (* d e))
	as (+ (+ (* a b) (* d e)) c).  Factor a common power-of-two
	multiplicand out of (+ (* a b) (* c d)).

Tue Aug 24 11:46:10 1999  Bob Manson <manson@cygnus.com>
			  Richard Henderson  <rth@cygnus.com>

	* haifa-sched.c (split_hard_reg_notes): Move to flow.c
	(new_insn_dead_notes): Likewise.
	(update_n_sets): Likewise.
	(update_flow_info): Move to flow.c, renamed to update_life_info;
	extend to handle multiple source insns.
	* flow.c: Include resource.h
	(unlink_insn_chain): New.
	(split_hard_reg_notes): New.
	(maybe_add_dead_note): New.
	(maybe_add_dead_note_use): New.
	(find_insn_with_note): New.
	(new_insn_dead_notes): New.
	(update_n_sets): New.
	(sets_reg_or_subreg_1, sets_reg_or_subreg): New.
	(maybe_remove_dead_notes): New.
	(update_life_info): New.
	(prepend_reg_notes): New.
	(replace_insns): New.
	* output.h (update_life_info): Declare.
	* recog.c (split_block_insns): Use update_life_info.
	* resource.c (find_free_register): Use reg_alloc_order, don't use
	fixed regs, make sure the mode is supported, don't use new regs.
	(reg_dead_p): New.
	* rtl.h (replace_insns): Declare.

Tue Aug 24 13:48:39 1999  Nathan Sidwell  <nathan@acm.org>

	* expr.c (expand_expr): Cope with COND_EXPRs with one
	non-returning branch.

Mon Aug 23 22:28:16 1999  Mark Mitchell  <mark@codesourcery.com>

	* expr.c (store_expr): Always pass down the target, even when not
	doing CSE.

1999-08-24  Nick Clifton  <nickc@cygnus.com>

	* configure.in: Define target_cpu_default for v850 targets.
	* configure: Regenerate

	* config/v850/v850.h (TARGET_CPU_generic): Define.
	(GO_IF_LEGITIMATE_ADDRESS): Insist that SImode and larger constant
	addresses are 4 byte aligned.

	* config/v850/v850.c (print_operand): Cope with 'R' format DFmode
	addresses.

Tue Aug 24 09:32:07 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* genattr.c (function_unit_desc): Constify a char*.  Add prototype.
	(main): Add prototypes.

	* genattrtab.c (substitute_address, write_const_num_delay_slots,
	attr_eq, attr_numeral, attr_equal_p, attr_copy_rtx): Prototype.
	(write_attr_get): Emit prototypes along with function definition.
	(write_eligible_delay): Mark a parameter with ATTRIBUTE_UNUSED.
	(write_complex_function): Emit static prototype along with
	function definition.

	* genemit.c (gen_split): Emit prototypes along with function
	definition.

	* genoutput.c (output_epilogue): Add prototype to `insn_outfun'.
	Likewise for predicates and `insn_operand_predicate'.
	(process_template): Emit static prototype along with function
	definition.

	* genrecog.c (make_insn_sequence): Constify a char*.  Add
	prototypes for get_split_*().
	(write_subroutine): Emit prototypes along with function
	definition.

Tue Aug 24 12:35:20 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* gcse.c (find_avail_set): Follow chains of register-register copies.
	Use oprs_not_set_p to guarantee that the returned value can be
	substituted.
	(cprop_insn): Don't verify the return value of find_avail_set with
	oprs_not_set_p.

	* gcse.c (cprop_jump): New function, broken out of cprop_insn.
	(cprop_cc0_jump): New function.
	(cprop_insn): Break out new function cprop_jump and use it.
	Also use cprop_cc0_jump for machines with CC0.
	(cprop): Don't crash if cprop_insn turned the insn into a NOTE.

	* tree.h (current_function_calls_setjmp,
 	current_function_calls_longjmp): Delete declarations.
	* dsp16xx.c: Include "function.h".
	* elxsi.c: Likewise.
	* gmicro.c: Likewise.
	* h8300.c: Likewise.
	* i370.c: Likewise.
	* m32r.c: Likewise.
	* mn10200.c: Likewise.
	* mn10300.c: Likewise.
	* ns32k.c: Likewise.
	* spur.c: Likewise.
	* v850.c: Likewise.

	* rtl.h (rtx_equal_function_value_matters): Declare.
	* toplev.c (rtx_equal_function_value_matters): Don't declare.
	* cse.c: Likewise.
	* function.c: Likewise.
	* emit-rtl.c: Likewise.

Tue Aug 24 02:47:44 1999  Jeffrey A Law  (law@cygnus.com)

	* expr.c (convert_move): Fix arguments to TRULY_NOOP_TRUNCATION
	call.

1999-08-24 Herman A.J. ten Brugge <Haj.Ten.Brugge@net.HCC.nl>

	* jump.c (delete_barrier_successors) Match (set (pc) (pc)) insn
	exactly.

Mon Aug 23 23:35:52 1999  Matthias Klose  <doko@cs.tu-berlin.de>

	* cpp.texi: Add a node documenting macro varargs (copied
 	from extend.texi).

1999-08-23 22:23 -0700  Zack Weinberg  <zack@bitmover.com>

	* cppspec.c: Put a null pointer at the end of the new argv.

Mon Aug 23 21:23:24 1999  Jeffrey A Law  (law@cygnus.com)

	* configure.in: Remove code to select/de-select the haifa
	scheduler.  Every scheduled port gets haifa now.
	* configure: Rebuilt.
	* flags.h, genattrtab.c, rtl.h, toplev.c: Remove HAIFA ifdefs.
	* sched.c Deleted.
	* Makefile.in: Corresponding changes.

Mon Aug 23 16:04:13 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* optabs.c (prepare_cmp_insn): Turn COMPARISON arg into a pointer.
	All callers changed.
	(prepare_float_lib_cmp): Likewise.
	Use FLOAT_LIB_COMPARE_RETURNS_BOOL.
	* expr.h (emit_float_lib_cmp): Delete declaration.
	* tm.texi (FLOAT_LIB_COMPARE_RETURNS_BOOL): Document.
	* sparc.h (FLOAT_LIB_COMPARE_RETURNS_BOOL): Define.
	* sparc.md (bcc and scc patterns): Don't handle TFmode comparisons
	specially.
	(cmptf): Now conditional on TARGET_HARD_QUAD.

Fri Aug 20 17:52:27 1999  Jim Wilson  <wilson@cygnus.com>

	* resource.c (mark_target_live_regs): Use
	PIC_OFFSET_TABLE_REG_CALL_CLOBBERED.

Fri Aug 20 19:07:55 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* rtl.c (rtx_class, note_insn_name, reg_note_name): Constify.

	* rtl.h (rtx_class, reg_note_name, note_insn_name): Likewise.

	* genopinit.c (gen_insn): Use accessor macro, not `rtx_class'.

Fri Aug 20 18:53:43 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* rtl.h (rtx_format): Constify a char*.

	* rtl.c (rtx_format): Likewise.
	(copy_rtx, copy_most_rtx, read_rtx): Likewise.
	(init_rtl): Use accessor macro, not `rtx_format'.

	* alias.c (rtx_equal_for_memref_p, find_symbolic_term): Constify a
	char*.

	* caller-save.c (mark_referenced_regs): Likewise.

	* combine.c (subst, make_compound_operation, known_cond,
	gen_rtx_combine, update_table_tick, get_last_value_validate,
	use_crosses_set_p, mark_used_regs_combine, move_deaths): Likewise.

	* cse.c (rtx_cost, mention_regs, canon_hash, exp_equiv_p,
	refers_to_p, canon_reg, fold_rtx, cse_process_notes,
	count_reg_usage): Likewise.

	* emit-rtl.c (gen_rtx, copy_rtx_if_shared, reset_used_flags):
	Likewise.

	* final.c (leaf_renumber_regs_insn): Likewise.

	* flow.c (mark_used_regs, find_use_as_address, dump_flow_info,
	dump_edge_info, count_reg_references): Likewise.

	* function.c (fixup_var_refs_1, walk_fixup_memory_subreg,
	fixup_stack_1, purge_addressof_1, instantiate_virtual_regs_1):
	Likewise.

	* gcse.c (oprs_unchanged_p, hash_expr_1, expr_equiv_p,
	oprs_not_set_p, expr_killed_p, compute_transp, find_used_regs,
	add_label_notes): Likewise.

	* genattrtab.c (attr_rtx, attr_copy_rtx, encode_units_mask,
	clear_struct_flag, count_sub_rtxs, count_alternatives,
	compares_alternatives_p, contained_in_p, walk_attr_value,
	write_expr_attr_cache): Likewise.

	* genconfig.c (walk_insn_part): Likewise.

	* genemit.c (max_operand_1, gen_exp): Likewise.

	* genextract.c (walk_rtx): Likewise.

	* genflags.c (num_operands): Likewise.

	* genoutput.c (scan_operands): Likewise.

	* genpeep.c (match_rtx): Likewise.

	* genrecog.c (add_to_sequence): Likewise.

	* haifa-sched.c (may_trap_exp, sched_analyze_2, attach_deaths):
	Likewise.

	* integrate.c (save_constants, copy_for_inline,
	copy_rtx_and_substitute, subst_constants, restore_constants):
	Likewise.

	* jump.c  (mark_jump_label, invert_exp, redirect_exp,
	rtx_renumbered_equal_p, rtx_equal_for_thread_p): Likewise.

	* local-alloc.c (contains_replace_regs, memref_referenced_p):
	Likewise.

	* loop.c (record_excess_regs, rtx_equal_for_loop_p,
	add_label_notes, replace_call_address, count_nonfixed_reads,
	invariant_p, find_single_use_in_loop, find_mem_givs,
	find_life_end, maybe_eliminate_biv_1, update_reg_last_use):
	Likewise.

	* print-rtl.c (reg_names, print_rtx): Likewise.

	* recog.c (validate_replace_rtx_1, find_single_use_1): Likewise.

	* reg-stack.c (stack_regs_mentioned_p, record_label_references,
	record_reg_life_pat, swap_rtx_condition, goto_block_pat,
	print_blocks): Likewise.

	* regclass.c (fix_register, record_address_regs,
	reg_scan_mark_refs): Likewise.

	* regmove.c (stable_but_for_p): Likewise.

	* reload.c (loc_mentioned_in_p, operands_match_p,
	find_reloads_toplevsubst_reg_equivs, find_reloads_address_1,
	copy_replacements, refers_to_regno_for_reload_p,
	refers_to_mem_for_reload_p, find_inc_amount, regno_clobbered_p,
	reload_when_needed_name, reg_class_names, debug_reload_to_stream):
	Likewise.

	* reload1.c (eliminate_regs, scan_paradoxical_subregs,
	delete_address_reloads_1, count_occurrences,
	reload_cse_mem_conflict_p, reload_combine_note_use,
	add_auto_inc_notes): Likewise.

	* resource.c (mark_referenced_resources, mark_set_resources):
	Likewise.

	* rtlanal.c (rtx_unstable_p, rtx_varies_p, rtx_addr_varies_p,
	reg_mentioned_p, regs_set_between_p, modified_between_p,
	modified_in_p, refers_to_regno_p, reg_overlap_mentioned_p,
	rtx_equal_p, volatile_insn_p, volatile_refs_p, side_effects_p,
	may_trap_p, inequality_comparisons_p, replace_rtx, replace_regs,
	jmp_uses_reg_or_mem, for_each_rtx, regno_use_in): Likewise.

	* sched.c (sched_analyze_2, attach_deaths): Likewise.

	* stupid.c (stupid_mark_refs): Likewise.

	* unroll.c (remap_split_bivs): Likewise.

	* varasm.c (mark_constants): Likewise.

	* a29k/a29k.c (uses_local_reg_p): Likewise.

	* alpha/alpha.c (summarize_insn): Likewise.

	* arm/arm.c (symbol_mentioned_p, label_mentioned_p,
	eliminate_lr2ip): Likewise.

	* arm/thumb.c (symbol_mentioned_p, label_mentioned_p): Likewise.

	* i386/i386.c (symbolic_reference_mentioned_p, copy_all_rtx,
	reg_mentioned_in_mem): Likewise.

	* ns32k/ns32k.c (global_symbolic_reference_mentioned_p,
	symbolic_reference_mentioned_p): Likewise.

	* romp/romp.c (unsigned_comparisons_p, hash_rtx): Likewise.

	* sh/sh.c (regs_used, mark_use): Likewise.

	* vax/vax.c (vax_rtx_cost): Likewise.

Fri Aug 20 18:38:43 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* machmode.h (mode_name): Constify a char*.

	* rtl.c (mode_name): Likewise.

	* genopinit.c (gen_insn): Use accessor macro, not `mode_name'.

	* optabs.c (init_libfuncs): Constify a char*.

	* print-tree.c (mode_name): Remove redundant declaration.
	(print_node): Use accessor macro, not `mode_name'.

	* reload1.c (dump_needs): Constify a char*.  Use accessor macro,
	not `mode_name'.
	(new_spill_reg): Constify a char*.

	* tree.c (mode_name): Remove redundant declaration.

Fri Aug 20 18:31:26 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* rtl.c (rtx_name): Constify a char*.

	* rtl.h (rtx_name, fix_sched_param): Likewise.

	* gmicro/gmicro.c (rtx_name): Remove redundant declaration.
	(mypr): Use accessor macro, not `rtx_name'.

	* genemit.c (print_code): Constify a char*.

	* genopinit.c (gen_insn): Use accessor macro, not `rtx_name'.

	* genpeep.c (print_code): Constify a char*.

	* genrecog.c (print_code): Likewise.

	* graph.c (start_fct, start_bb, node_data, draw_edge, end_fct,
	end_bb): Add static prototype.
	(draw_edge): Constify a char*.
	(end_bb): Remove unused parameter.

	* haifa-sched.c (fix_sched_param, safe_concat, print_exp
	print_block_visualization): Constify a char*.

Fri Aug 20 15:02:10 1999  Mark Mitchell  <mark@codesourcery.com>

	* c-common.c (c_get_alias_set): Update comment.

1999-08-20  Andreas Jaeger  <aj@arthur.rhein-neckar.de>

	* linux.h (LIB_SPEC): Added.

Fri Aug 20 22:32:17 1999  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* config/c4x/c4x.h (STARTFILE_SPEC): Don't define.

1999-08-19 18:43 -0700  Zack Weinberg  <zack@bitmover.com>

	* tree.c (expr_check): Fix typo in last change.

1999-08-19 14:44 -0700  Zack Weinberg  <zack@bitmover.com>

	* rtl.def (NOTE): Change format to "iuu0n".
	(ADDR_DIFF_VEC): Change format to "eEee0".
	(ADDRESSOF): Change format to "eit".

	* rtl.h (rtvec): Make "elem" an array of rtx, not rtunion.
	(RTVEC_ELT): Change to match.
	(XVECEXP): Use XVEC and RTVEC_ELT.
	(INSN_UID, INSN_CODE, CODE_LABEL_NUMBER, NOTE_LINE_NUMBER,
	ADDRESSOF_REGNO, REGNO, SUBREG_WORD): Use XINT.
	(PREV_INSN, NEXT_INSN, PATTERN, REG_NOTES,
	CALL_INSN_FUNCTION_USAGE, SUBREG_REG, SET_SRC, SET_DEST,
	TRAP_CONDITION, TRAP_CODE): Use XEXP.
	(INTVAL): Use XWINT.
	(ADDRESSOF_DECL): Use XTREE.
	(SET_ADDRESSOF_DECL): Delete.
	(NOTE_DECL_NAME, NOTE_DECL_CODE, NOTE_DECL_RTL,
	NOTE_DECL_IDENTIFIER, NOTE_DECL_TYPE): Kill.  These have been
	ifdefed out since 2.6 at least.
	(gen_rtvec_vv): Delete prototype.

	* rtl.h (rtvec_alloc): rt->elem is now an array of rtx,
	not rtunion.
	(copy_most_rtx): Handle 't' format letter.
	* emit-rtl.c (gen_rtvec_v): rt_val->elem is an array of rtx.
	(gen_rtvec_vv): Delete function.  All callers changed to use
	gen_rtvec_v instead.
	* print-rtl.c (print_rtx): Move special casing of NOTEs to
	the '0' format letter.

	* function.c (gen_mem_addressof): Don't use
	SET_ADDRESSOF_DECL; provide `decl' to gen_rtx_ADDRESSOF
	instead.
	* integrate.c (copy_rtx_and_substitute): Likewise.
	Copy 't' slots with XTREE.
	(subst_constants): Treat 't' slots like '[swi]' slots.
	* cse.c (canon_hash, exp_equiv_p): Treat 't' slots like	'0' slots.
	* jump.c (rtx_equal_for_thread_p): Likewise.
	* rtlanal.c (rtx_equal_p): Likewise.
	* stmt.c (expand_end_case): gen_rtx_ADDR_DIFF_VEC now takes
	only four arguments.
	* gengenrtl.c (type_from_format): Provide correct types for
	'b' and 't' slots.


	* tree.h [ENABLE_CHECKING] (TREE_CHECK, TREE_CLASS_CHECK):
	If a recent gcc is in use (always in stage2 and beyond), use
	statement expressions, so we don't make a function call unless
	the check fails.  Evaluate arguments exactly once.
	(CHAIN_CHECK, DO_CHECK, DO_CHECK1, TREE_CHECK1,
	TREE_CLASS_CHECK1, TYPE_CHECK1, DECL_CHECK1, CST_CHECK1):
	Delete.
	(CST_OR_CONSTRUCTOR_CHECK, EXPR_CHECK): Redefine such that
	they evaluate their arguments exactly once, irrespective of
	the compiler in use.

	* tree.c [ENABLE_CHECKING]: Define whichever set of functions
	is used by the currently-enabled check macros.  This is:
	(tree_check_failed, tree_class_check_failed): For gcc.
	(tree_check, tree_class_check, cst_or_constructor_check,
	expr_check): For other compilers.

	* gencheck.c: Do not define any *_CHECK1 macros.

Thu Aug 19 14:42:38 1999  Mike Stump <mrs@wrs.com>
		          Mark Mitchell <mark@codesourcery.com>

	* c-common.c (c_get_alias_set): Fix support for poitners and
	references.

Thu Aug 19 11:51:22 EDT 1999  John Wehle  (john@feith.com)

	* alias.c: Include tree.h.
	(nonlocal_reference_p, mark_constant_function): New functions.
	* flow.c (life_analysis): Call mark_constant_function.
	* rtl.h (mark_constant_function): Declare it.

Thu Aug 19 15:02:01 1999  Nick Clifton  <nickc@cygnus.com>

	* config/rs6000/rs6000.c (rs6000_override_options): Fix test for
	unrecognisable switches.

Wed Aug 18 23:31:57 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* loop.c (recombine_givs): Set ix field after sorting.
	(recombine_givs): Remove bogus index / giv lockstep looping.

Wed Aug 18 18:20:40 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* expmed.c (emit_store_flag): If UNSIGNEDP, call unsigned_condition
	on CODE.
	(emit_store_flag_force): Use do_compare_rtx_and_jump.
	(do_cmp_and_jump): Formatting fixes.
	* expr.c (do_compare_and_jump): Renamed from compare; changed to call
	do_compare_rtx_and_jump instead of compare_from_rtx.
	(do_compare_rtx_and_jump): New function; mostly copied from
	compare_from_rtx.
	(do_jump_for_compare): Delete.
	(expand_expr): Use do_compare_rtx_and_jump when handling MAX_EXPR and
	MIN_EXPR.
	(do_jump): Use do_compare_and_jump or do_compare_rtx_and_jump instead
	of compare/do_jump_for_compare pairs.
	(do_jump_by_parts_greater): Use do_jump_by_parts_greater_rtx.
	(do_jump_by_parts_greater_rtx): Use do_compare_rtx_and_jump instead of
	compare_from_rtx/do_jump_for_compare pairs.
	(do_jump_by_parts_equality): Likewise.
	(do_jump_by_parts_equality_rtx): Likewise.
	* expr.h (do_compare_rtx_and_jump): Declare.
	* optabs.c (prepare_cmp_insn): New function, contains most of the code
	that used to be in emit_cmp_insn.
	(cmp_available_p): New function.
	(prepare_operand): New function.
	(emit_cmp_and_jump_insn_1): New function, contains some code that used
	to be in emit_cmp_insn.
	(prepare_float_lib_cmp): Renamed from emit_float_lib_cmp; change some
	parameters to be pointers; don't emit final compare but modify some of
	the values pointed to by the args so the caller can perform the
	correct comparison.
	(expand_binop): Call emit_store_flag_force with signed forms of
	comparison code.
	(expand_abs): Use do_compare_rtx_and_jump instead of compare_from_rtx/
	emit_jump_insn pair.
	(emit_cmp_and_jump_insn): Use prepare_cmp_insn and
	emit_cmp_and_jump_insn_1.  Call emit_queue.
	(emit_cmp_insn): Just call emit_cmp_and_jump_insns with zero for LABEL
	arg.
	* flow.c (tidy_fallthru_edge): If HAVE_cc0, verify insn before a
	jump sets cc0 before deleting it.
	* integrate.c (expand_inline_function): Likewise.
	* unroll.c (unroll_loop): Similar changes in several places.
	(copy_loop_body): If HAVE_cc0, verify insn before a jump sets cc0
	before deleting it.

Wed Aug 18 06:37:44 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* Makefile.in (insn-recog.o): Update dependencies.
	* genrecog.c (main): Make generated file include "function.h".

Sat Aug 14 00:54:57 1999  Geoffrey Keating  <geoffk@cygnus.com>

	* cse.c (cse_insn): Call never_reached_warning when a jump is
 	changed to be unconditional.
	* flags.h: Declare warn_notreached.
	* flow.c (delete_block): Call never_reached_warning when
	a block is deleted.
	* jump.c (delete_barrier_successors): Call never_reached_warning
	when we delete everything after a BARRIER.
	(never_reached_warning): New function.
	* rtl.h: Declare never_reached_warning.
	* toplev.c (warn_notreached): New variable.
	(lang_independent_options): Set warn_notreached
	when -Wunreachable-code.
	(compile_file): We need line numbers for -Wunreachable-code.

Tue Aug 17 22:06:11 1999  Jan Hubicka  <hubicka@freesoft.cz>

	* haifa-sched.c (insn_unit): Fix typo on out of range test.
	* sched.c (insn_unit): Likewise.

Tue Aug 17 21:57:23 1999  Andreas Schwab  <schwab@suse.de>

	* combine.c (distribute_notes): Handle REG_EH_RETHROW.

Tue Aug 17 17:39:43 EDT 1999  Andrew MacLeod  <amacleod@cygnus.com>

	* flow.c (create_edge_list): Use xmalloc, not malloc.

Tue Aug 17 01:40:54 1999  Loren Rittle  <ljrittle@acm.org>

	* fixinc/inclhack.def (no_double_slash): Do not trash single-line
	C-style comments.  Do not lose the character before double slash.

Mon Aug 16 18:08:22 EDT 1999  Andrew MacLeod  <amacleod@cygnus.com>

	* basic-block.h (struct edge_list): Stucture to maintain a vector
	of edges.
	(EDGE_INDEX_NO_EDGE, EDGE_INDEX, INDEX_EDGE_PRED_BB, INDEX_EDGE_SUCC_BB,
	 INDEX_EDGE, NUM_EDGES): New Macros for accessing edge list.
	(create_edge_list, free_edge-List, print_edge_list, verify_edge_list):
	New function prototypes.
	* flow.c (create_edge_list): Function to create an edge list.
	(free_edge_list): Discards memory used by an edge list.
	(print_edge_list): Debug output showing an edge list.
	(verify_edge_list): Internal consistency check for an edge list.
	(find_edge_index): Function to find an edge index for a pred and succ.

Mon Aug 16 11:56:36 1999  Mark Mitchell  <mark@codesourcery.com>

	* tree.c (type_hash_add): Use permalloc to allocate nodes in the
	hashtable.

Mon Aug 16 17:04:15 1999  Jorn Rennecke <amylaar@cygnus.co.uk>

	* mips.h (CLASS_CANNOT_CHANGE_SIZE): Define.

Fri Aug 13 15:20:43 1999  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* config/i386/freebsd.h (HANDLE_PRAGMA_PACK_PUSH_POP): Define.

Fri Aug 13 10:21:28 1999  Nick Clifton  <nickc@cygnus.com>

	* toplev.c (rest_of_compilation): Allow machine dependent
	reorganisation pass to place information into the RTL dump
	file if it so wishes.

Sun Aug 15 12:41:21 1999  Jim Wilson  <wilson@cygnus.com>

	* explow.c (hard_function_value): Use VOIDmode instead of
	MAX_MACHINE_MODE.
	* stmt.c (expand_return): Likewise.
	* stor-layout.c (get_best_mode): Likewise.

	* genemit.c (gen_expand): If next is MATCH_PAR_DUP, then output
	emit call instead of emit_insn call.

Sat Aug 14 15:04:06 1999  Mumit Khan  <khan@xraylith.wisc.edu>

	* configure.in: Handle --disable/enable-win32-registry.
	* install.texi: Document --disable/enable-win32-registry.
	* acconfig.h (ENABLE_WIN32_REGISTRY): New macro.
	(WIN32_REGISTRY_KEY): New macro.
	* prefix.c: Use to enable/disable win32-specific code.
	(lookup_key): Use versioned key.
	* configure: Regenerate.
	* config.in: Likewise.

Fri Aug 13 17:41:55 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* cpplib.c (read_line_number): New fn, split out of...
	(do_line): Here.

Fri Aug 13 14:18:27 1999  Gavin Romig-Koch  <gavin@cygnus.com>

	tree.c (lang_unsave_expr_now) : New.
	(unsave_expr_now): Call lang_unsave_expr_now.
	tree.h (lang_unsave_expr_now) : New.

Fri Aug 13 00:49:46 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* toplev.c (flag_new_exceptions): On by default.

1999-08-13  Michael Meissner  <meissner@cygnus.com>

	* Makefile.in (GCC_FOR_TARGET): Move -B./ after the tooldir -B.

Fri Aug 13 01:29:57 1999  Alexandre Oliva  <oliva@dcc.unicamp.br>

	* dwarfout.c (fundamental_type_code): Return FT_boolean for
	INTEGER_TYPE with precision==1, it's __java_boolean.

Thu Aug 12 23:51:04 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* global.c (prune_preferences): Move some invariants out of the
	inner loop.

Thu Aug 12 15:30:29 1999  Jesse Perry  (jap@unx.dec.com)

	* configure.in (alpha*-dec-osf*): Add osf5.

Sun Aug  1 22:24:03 1999  Philip Blundell  <philb@gnu.org>

	* configure.in: Rework handling of ARM GNU/Linux slightly.
	(arm*-*-linux-gnuoldld): New target.
	* configure: Regenerate.
	* install.texi (Configurations): Add arm-*-linux-gnu{oldld} and
	arm-*-elf.  Mention that arm-*-linux-gnuaout is obsolete.
	* config/arm/linux-oldld.h: New file.
	* config/arm/linux-elf26.h: Don't include linux-elf.h.
	(TARGET_DEFAULT, SUBTARGET_LINK_SPEC, SUBTARGET_EXTRA_ASM_SPEC):
	Don't define.
	* config/arm/linux-elf.h (ASM_SPEC): Define.
	(TARGET_DEFAULT, SUBTARGET_EXTRA_LINK_SPEC,
 	SUBTARGET_EXTRA_ASM_SPEC, CPP_APCS_PC_DEFAULT): Add definitions
 	for 26-bit APCS and old linker.
	(CPP_PREDEFINES): Define `__arm__'; don't define `arm' or
	`arm_elf'.
	(FP_DEFAULT): Define to FP_SOFT3 for all machines.
	* config/arm/linux-aout.h (CPP_PREDEFINES): Define `__arm__';
	don't define `arm' or `arm_elf'.
	* config/arm/t-linux (EXTRA_MULTILIB_PARTS, MULTILIB_OPTIONS,
	MULTILIB_DIRNAMES): Define.  Fix typo in comment.

Thu Aug 12 10:14:47 1999  Andreas Schwab  <schwab@suse.de>

	* rtl.texi: Fix typo.

Wed Aug 11 23:50:57 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* invoke.texi (C++ Dialect Options): Add -fms-extensions.

Wed Aug 11 12:59:37 1999  Mark Mitchell  <mark@codesourcery.com>

	* extend.texi (C++ Signatures): Remove node.
	* invoke.texi: Remove discussion of -fhandle-signatures,
	signature, sigof, __signature__, and __sigof__.

Wed Aug 11 03:38:25 1999  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (JAVAGC): Removed.

Wed Aug 11 02:13:26 1999  Mumit Khan  <khan@xraylith.wisc.edu>

	* i386/cygwin.h (ASM_OUTPUT_ALIGNED_BSS): Define.

1999-08-11 Mark Elbrecht <snowball3@bigfoot.com>

	* i386/djgpp.h (ASM_OUTPUT_ALIGNED_BSS): Define.

1999-08-11  Richard Earnshaw (rearnsha@arm.com)

	* emit-rtl.c (mark_reg_pointer): Don't increase the alignment of
	a register that is already known to be a pointer.

1999-08-11  Bruce Korb  <ddsinc09@ix.netcom.com>

	* fixinc/inclhack.tpl: Only install assert.h conditionally.
	* fixinc/inclhack.sh: Regenerated.
	* fixinc/fixincl.sh: Regenerated.

Wed Aug 11 00:34:22 1999  Joe Buck  <jbuck@synopsys.com>

	* invoke.texi: s/GNU CC/GCC/ for consistency with gcc.texi.
	Fix documentation of -ansi flag to describe its C++ behavior.
	Remove bogus reference to GCC 2.9.

Tue Aug 10 17:19:02 1999  Jim Wilson  <wilson@cygnus.com>

	* config/sh/sh.c (machine_dependent_reorg): Only call PUT_MODE on
	note if it is non-NULL.

Tue Aug 10 10:47:42 EDT 1999  Andrew MacLeod  <amacleod@cygnus.com>

	* except.h (eh_nesting_info): Add new structure defintion.
	(init_eh_nesting_info, free_eh_nesting_info): Add function prototypes.
	(reachable_handlers, update_rethrow_references): Add function
	prototypes.
	* rtl.h (struct rtvec_def): Update comments.  REG_EH_RETHROW takes
	a rethrow symbol instead of an integer exception region number.
	* flow.c (Make_edges): Use new exception nesting routines to determine
	which handlers are reachable from a CALL or asynchronous insn.
	Dont add an edge for calls with a REG_EH_REGION of -1 to non-local
	goto receivers.
	(delete_eh_regions): Update rethrow labels, and don't delete
	regions which are the target of a rethrow.
	* except.c (struct func_eh_entry): Add rethrow_ref field, now we can
	avoid overloading the SYMBOL_REF_USED flag.
	(rethrow_symbol_map): Use new rethrow_ref field.
	(rethrow_used): Use new rethrow_ref field.
	(expand_rethrow): REG_EH_RETHROW now has a SYMBOL_REF instead
	of an integer.  Fix formatting.
	(output_exception_table_entry): Use new rethrow_ref field.
	(can_throw): Check for EH_REGION_NOTE before deciding
	whether a CALL can throw or not.
	(scan_region): Call rethrow_used() instead of accessing data structure.
	(update_rethrow_references): New function to make sure only regions
	which are still targets of a rethrow are flagged as such.
	(process_nestinfo): New static function to initialize a handler
	list for a specific region.
	(init_eh_nesting_info): New function to allocate and initialize
	the list of all EH handlers reachable from all regions.
	(reachable_handlers): New function to retrieve the list of handlers
	reachable from a specific region and insn.
	(free_eh_nesting_info): New function to dispose of a list of
	reachable handlers.

Tue Aug 10 10:39:31 EDT 1999  Andrew MacLeod  <amacleod@cygnus.com>

	* flow.c (split_edge): Set JUMP_LABEL field.
	(commit_one_edge_insertion): Set head correctly for insert_before.
	When inserting insns, update insn block numbers if allocated.

Tue Aug 10 09:26:07 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* dwarf2out.c (dwarf2out_frame_debug_expr, add_incomplete_type,
	retry_incomplete_types): Add static prototype.
	(stripattributes, dwarf_cfi_name, ASM_OUTPUT_DWARF_STRING,
	dwarf_tag_name, dwarf_attr_name, dwarf_form_name,
	dwarf_stack_op_name, dwarf_type_encoding_name, add_AT_string,
	dwarf2_name, add_name_attribute, lookup_filename, dwarf2out_line,
	dwarf2out_start_source_file, dwarf2out_define, dwarf2out_undef):
	Constify a char*.

	* dwarf2out.h (dwarf2out_define, dwarf2out_undef,
	dwarf2out_start_source_file, dwarf2out_line): Likewise.

Tue Aug 10 09:21:46 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* output.h (assemble_name): Constify a char*.

	* varasm.c (UNIQUE_SECTION, assemble_start_function,
	assemble_variable, assemble_name): Likewise.

	* dwarf2out.c (ASM_NAME_TO_STRING): Likewise.

	* arm/pe.c (arm_pe_unique_section): Likewise.

	* i386/cygwin.h (STRIP_NAME_ENCODING): Likewise.

	* i386/i386-interix.h (STRIP_NAME_ENCODING): Likewise.

	* i386/interix.c (i386_pe_unique_section): Likewise.

	* i386/win32.h (STRIP_NAME_ENCODING): Likewise.

	* i386/winnt.c (i386_pe_unique_section): Likewise.

	* m32r/m32r.h (ASM_OUTPUT_LABELREF): Likewise.

	* mn10200/mn10200.h (ASM_OUTPUT_LABELREF): Likewise.

	* mn10300/mn10300.h (ASM_OUTPUT_LABELREF): Likewise.

	* pa/pa.c (output_call): Likewise.

	* pa/pa.h (ASM_OUTPUT_MI_THUNK): Likewise.

	* pa/som.h (ASM_OUTPUT_FUNCTION_PREFIX): Likewise.

	* rs6000/rs6000.c (rs6000_output_load_toc_table, output_toc):
	Likewise.

	* rs6000/rs6000.h (RS6000_OUTPUT_BASENAME, STRIP_NAME_ENCODING):
	Likewise.

	* rs6000/sol2.h (ASM_OUTPUT_SOURCE_LINE): Likewise.

	* rs6000/sysv4.h (ASM_DECLARE_FUNCTION_NAME, ASM_OUTPUT_INT,
	STRIP_NAME_ENCODING, ASM_OUTPUT_LABELREF): Likewise.

	* v850/v850.h (ASM_OUTPUT_LABELREF): Likewise.

Mon Aug  9 19:54:05 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* real.c (GET_REAL, PUT_REAL): Use memcpy instead of bcopy.

Mon Aug  9 19:36:00 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* tree.h (lang_identify): Constify a char*.
	(print_error_function): Add extern prototype.  Constify a char*.

	* c-lang.c (lang_identify): Constify a char*.

	* objc/objc-act.c (lang_identify): Constify a char*.

Mon Aug  9 16:21:53 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* genpeep.c (main): Make generated file include "function.h".
	* arm.c (function_really_clobbers_lr): Delete INLINE_HEADER case.

Mon Aug  9 10:08:50 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* Makefile.in: Update dependencies.
	* alias.c: Include "function.h"
	* c-decl.c: Likewise.
	* caller-save.c: Likewise.
	* calls.c: Likewise.
	* combine.c: Likewise.
	* cse.c: Likewise.
	* explow.c: Likewise.
	* final.c: Likewise.
	* global.c: Likewise.
	* graph.c: Likewise.
	* local-alloc.c: Likewise.
	* loop.c: Likewise.
	* optabs.c: Likewise.
	* profile.c: Likewise.
	* recog.c: Likewise.
	* regclass.c: Likewise.
	* regmove.c: Likewise.
	* reload.c: Likewise.
	* reorg.c: Likewise.
	* resource.c: Likewise.
	* sched.c: Likewise.
	* stupid.c: Likewise.
	* config/1750a/1750a.c: Likewise.
	* config/a29k/a29k.c: Likewise.
	* config/arc/arc.c: Likewise.
	* config/arm/arm.c: Likewise.
	* config/arm/thumb.c: Likewise.
	* config/c4x/c4x.c: Likewise.
	* config/clipper/clipper.c: Likewise.
	* config/convex/convex.c: Likewise.
	* config/fx80/fx80.c: Likewise.
	* config/i860/i860.c: Likewise.
	* config/m68k/m68k.c: Likewise.
	* config/m88k/m88k.c: Likewise.
	* config/mips/mips.c: Likewise.
	* config/pdp11/pdp11.c: Likewise.
	* config/pyr/pyr.c: Likewise.
	* config/romp/romp.c: Likewise.
	* config/sh/sh.c: Likewise.
	* config/tahoe/tahoe.c: Likewise.
	* config/vax/vax.c: Likewise.
	* config/we32k/we32k.c: Likewise.
	* config/sparc/sparc.c: Include "function.h".
	(mem_min_alignment): Test current_function rather than
	regno_pointer_align.
	* config/pa/pa.c: Likewise.
	(compute_frame_size): Delete declaration of
	current_function_outgoing_args_size.
	* config/arc/arc.h (current_function_varargs): Delete declaration.
	* config/elxsi/elxsi.h (current_function_calls_alloca): Delete
	declaration.
	* config/i370/i370.h (current_function_outgoing_args_size): Delete
	declaration.
	* config/i386/i386.h (FINALIZE_PIC): Delete declaration of
	current_function_uses_pic_offset_table.
	* config/m68k/a-ux.h (FUNCTION_EXTRA_EPILOGUE): Delete declaration
	of current_function_returns_pointer.
	* config/m68k/altos3068.h (FUNCTION_EXTRA_EPILOGUE): Likewise.
	* config/m68k/linux.h (FUNCTION_EXTRA_EPILOGUE): Likewise.
	* config/m68k/m68kv4.h (FUNCTION_EXTRA_EPILOGUE): Likewise.
	* config/m68k/mot3300.h (FUNCTION_EXTRA_EPILOGUE): Likewise.
	* config/m68k/pbb.h (FUNCTION_EXTRA_EPILOGUE): Likewise.
	* config/m68k/tower-as.h (FUNCTION_EXTRA_EPILOGUE): Likewise.
	* config/m88k/m88k.c: Include "function.h"
	(call_used_regs, current_function_pretend_args_size,
	current_function_outgoing_args_size, frame_pointer_needed): Delete
	declarations.
	* config/m88k/m88k.h (current_function_pretend_args_size): Delete
	declaration.
	* config/mips/mips.h (current_function_calls_alloca): Delete
	declaration.
	* config/mn10200/mn10200.h (current_function_needs_context,
	rtx_equal_function_value_matters): Delete declarations.
	* config/ns32k/ns32k (current_function_uses_pic_offset_table,
	flag_pic): Delete declarations.
	* config/pa/pa.h (current_function_pretend_args_size,
	current_function_decl): Delete declarations.
	* config/pa/som.h (current_function_varargs): Delete declaration.
	* config/pdp11/pdp11.h (current_function_pretend_args_size): Delete
	declaration.
	* config/pyr/pyr.h (current_function_pretend_args_size,
	current_function_args_size, current_function_calls_alloca): Delete
	declarations.
	* config/sh/sh.h (current_function_varargs): Delete declaration.
	* config/sparc/sparc.h (current_function_outgoing_args_size,
	current_function_calls_alloca, current_function_decl): Delete
	declarations.
	* config/spur/spur.h (current_function_pretend_args_size,
	current_function_calls_alloca): Delete declarations.
	* config/v850/v850.c (current_function_outgoing_args_size): Delete
	declaration.
	* config/vax/vms.h (current_function_name): Delete declaration.
	* gcse.c: Include "function.h".
	(current_function_name, current_function_calls_setjmp): Delete
	declarations.
	* haifa-sched.c: Include "function.h".
	(forced_labels): Delete declaration.
	* jump.c: Likewise.
	* reg-stack.c: Likewise.
	* reload1.c: Likewise.
	* genemit.c (main): Make generated file include function.h.
	* genoutput.c (output_prologue): Likewise.

	* builtins.c (saveregs_value, apply_args_value): Delete variables.
	* emit-rtl.c (reg_rtx_no, first_label_num, first_insn, last_insn,
	sequence_rtl_expr, cur_insn_uid, last_linenum, last_filename,
	regno_pointer_flag, regno_pointer_flag_length, regno_pointer_align,
	regno_reg_rtx, sequence_stack): Delete variables.  Add accessor
	macros for some of them.
	(emit_filename, emit_lineno): Delete declarations.
	(gen_reg_rtx): Use memset/memcpy instead of bzero/bcopy.  Access
	regno_pointer_* variables through current_function.
	(gen_inline_header_rtx): Delete function.
	(save_emit_status): Delete function.
	(set_new_last_label_num): New function.
	(clear_emit_caches): New function.
	(restore_emit_status): Just clear last_labelnum and call
	clear_emit_caches.
	(get_last_insn_anywhere): Variable sequence_stack is now accessed
	through macro seq_stack.
	(add_insn_after): Likewise.
	(add_insn_before): Likewise.
	(remove_insn): Likewise.
	(pop_topmost_sequence): Likewise.
	(in_sequence_p): Likewise.
	(start_sequence_for_rtl_expr): Likewise.
	(start_sequence): Likewise, and likewise for
	sequence_rtl_expr/seq_rtl_expr.
	(push_topmost_sequence): Likewise.
	(end_sequence): Likewise.
	(init_virtual_regs): Now takes a "struct emit_status *" argument.
	All callers changed.  Store into that pointer instead of globals.
	(init_emit): Allocate emit elt of current_function.
	Changes for sequence_rtl_expr/sequence_stack renaming.
	Call clear_emit_caches instead of doing it in-line.
	Access regno_pointer_* variables through current_function.
	(init_emit_once) Don't clear sequence_stack.

	* expr.c (pending_stack_adjust, inhibit_defer_pop, pending_chain):
	Delete variables.
	(arg_pointer_save_area): Delete declaration.
	(finish_expr_for_function): Renamed from init_queue; no longer static.
	(init_expr): Don't call init_queue.
	(save_expr_status, restore_expr_status): Delete functions.
	(expand_expr): Changes to reflect new layout of struct function.
	Don't access current_function_check_memory_usage when current_function
	is 0.
	* expr.h (forced_labels, save_expr_regs, saveregs_value,
	apply_args_value, current_function_calls_alloca, inhibit_defer_pop,
	current_function_outgoing_args_size, current_function_arg_offset_rtx,
	current_function_uses_const_pool, function_call_count,
	current_function_uses_pic_offset_table, nonlocal_labels,
	current_function_internal_arg_pointer, nonlocal_goto_stack_level,
	current_function_check_memory_usage, nonlocal_goto_handler_slots,
	pending_stack_adjust, target_temp_slot_level, temp_slot_level): Delete
	declarations.
	(finish_expr_for_function): Declare.
	* flags.h (current_function_has_nonlocal_label,
	current_function_has_nonlocal_goto, current_function_is_thunk,
	current_function_has_computed_jump): Delete declarations.
	* flow.c (forced_labels): Delete declaration.
	* function.c (current_function_pops_args,
	current_function_returns_struct, current_function_returns_pcc_struct,
	current_function_needs_context, current_function_calls_setjmp,
	current_function_calls_longjmp, current_function_has_nonlocal_label,
	current_function_has_nonlocal_goto, current_function_is_thunk,
	current_function_has_computed_jump, current_function_calls_alloca,
	current_function_contains_functions, current_function_returns_pointer,
	current_function_epilogue_delay_list, current_function_args_size,
	current_function_pretend_args_size, current_function_arg_offset_rtx,
	current_function_outgoing_args_size, current_function_varargs,
	current_function_stdarg, current_function_args_info, cleanup_label,
	current_function_name, current_function_uses_const_pool,
	current_function_instrument_entry_exit, current_function_return_rtx,
	current_function_uses_pic_offset_table, nonlocal_labels,
	current_function_internal_arg_pointer, current_function_cannot_inline,
	current_function_check_memory_usage, function_call_count,
	nonlocal_goto_handler_slots, nonlocal_goto_handler_labels,
	nonlocal_goto_stack_level, return_label, save_expr_regs,
	stack_slot_list, rtl_expr_chain, tail_recursion_label, temp_slots,
	tail_recursion_reentry, arg_pointer_save_area, frame_offset,
	context_display, trampoline_list, parm_birth_insn, invalid_stack_slot,
	last_parm_insn, max_parm_reg, parm_reg_stack_loc, sequence_rtl_expr,
	temp_slot_level, var_temp_slot_level, target_temp_slot_level):
	Delete variables.
	(push_function_context_to): Don't save them.  Don't call
	save_storage_status, save_emit_status or save_expr_status.
	(pop_function_context_from): Don't restore them.  Don't call
	restore_storage_status or restore_expr_status.
	(get_func_frame_size): New function.
	(get_frame_size): Use it.
	(assign_outer_stack_local): Reflect some member name changes in struct
	function.
	(put_reg_into_stack): Likewise.
	(assign_stack_temp_for_type): sequence_rtl_expr was renamed to
	seq_rtl_expr.
	(fixup_var_refs): Likewise.
	(fix_lexical_addr): Likewise.
	(trampoline_address): Likewise.
	(prepare_function_start): Clear field inlinable of current_function.
	(init_function_for_compilation): New function.
	(expand_dummy_function_end): New function.
	(expand_function_end): Call finish_expr_for_function.
	* function.h (struct emit_status): New; fields moved here from struct
	function and from global variables.  Add accessor macros for some of
	the fields.
	(struct expr_status): Likewise.
	(REGNO_POINTER_ALIGN, REGNO_POINTER_FLAG): Moved here from regs.h.
	(struct function): Add fields expr and emit, inlinable, inl_emit,
	original_arg_vector, original_decl_initial, inl_last_parm_insn,
	inl_max_label_num.  Add many comments.
	Add accessor macros for all elts of struct function that no longer
	have a global variable.
	(cleanup_label, return_label, frame_offset, tail_recursion_label,
	tail_recursion_reentry, arg_pointer_save_area, rtl_expr_chain,
	stack_slot_list): Delete declarations.
	(get_func_frame_size): Declare.
	(save_expr_status, restore_expr_status, save_emit_status,
	save_storage_status, restore_storage_status): Delete declarations.
	(init_virtual_regs): Declare.
	* output.h (current_function_pops_args,
	current_function_returns_struct, current_function_returns_pcc_struct,
	current_function_needs_context, current_function_calls_setjmp,
	current_function_calls_longjmp, current_function_calls_alloca,
	current_function_has_nonlocal_label, current_function_varargs,
	current_function_has_computed_jump, current_function_returns_pointer,
	current_function_contains_functions, current_function_args_size,
	current_function_pretend_args_size, current_function_stdarg,
	current_function_outgoing_args_size, current_function_args_info,
	current_function_name, current_function_return_rtx,
	current_function_epilogue_delay_list,
	current_function_uses_const_pool, current_function_cannot_inline):
	Delete declarations.
	* regs.h (reg_rtx_no, regno_pointer_flag, regno_pointer_flag_length,
	regno_reg_rtx): Delete declaration.
	(REGNO_POINTER_FLAG): Delete macro.
	* stmt.c (expand_goto): Changes to reflect that some fields in struct
	function were renamed.
	* stor-layout.c (save_storage_status, restore_storage_status): Delete
	functions.
	* toplev.c: Include "function.h".
	(current_function_decl): Delete declaration.
	(compile_file): Call init_dummy_function_start and
	expand_dummy_function_end around some initializations that need to
	emit rtl.
	(rest_of_compilation): Use DECL_SAVED_INSNS properly.
	Call init_function_for_compilation.
	* unroll.c: Include "function.h"
	(unroll_loop): Access regno_pointer_* variables through
	current_function.

	* tree.h (struct tree_decl): Add elt f to saved_insns member.
	(DECL_SAVED_INSNS): use it.
	(expand_dummy_function_end): Declare.
	(init_function_for_compilation): Declare.
	* calls.c (calls_function_1): Change use of DECL_SAVED_INSNS now
	that it's no longer an INLINE_HEADER.
	(expand_call): Likewise.
	* integrate.c (finish_inline): Delete function.
	(max_parm_reg, parm_reg_stack_loc): Delete declarations.
	(initialize_for_inline): Delete min_labelno, max_labelno and max_reg
	args.  Don't generate an INLINE_HEADER rtx, just return the arg
	vector.  All callers changed.
	(save_for_inline_copying):  Create a duplicate struct emit_status to
	hold the emit state for compiling the current function.  Use this and
	the other new fields in struct function that are for integration
	instead of an INLINE_HEADER.
	Use memcpy instead of bcopy.
	Store the current struct function in DECL_SAVED_INSNS of fndecl.
	(save_for_inline_nocopy): Similar changes, except no new emit_status
	is needed here.
	(expand_inline_function): Get information from function structure,
	not from an inline header rtx.
	(output_inline_function): Lose code to extract the necessary
	information from an inline header; simply put back the function
	structure into current_function.  Clear its inlinable elt.
	* rtl.def (INLINE_HEADER): Delete.
	* rtl.h: Delete all accessors for an INLINE_HEADER.
	(gen_inline_header_rtx): Delete declaration.
	(regno_reg_rtx, regno_pointer_align, nonlocal_goto_handler_labels):
	Delete declarations.
	(REGNO_POINTER_ALIGN): Delete.
	(clear_emit_caches): Declare.
	(set_new_last_label_num): Declare.

Mon Aug  9 01:52:24 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* print-tree.c (print_node): Print base for OFFSET_TYPEs.

	* except.c (expand_eh_region_start_for_decl): Always start a new block.
	* stmt.c (is_eh_region): Make sure current_function is present, too.

Mon Aug  9 01:15:24 1999  Jeffrey A Law  (law@cygnus.com)

	* pa.h (HARD_REGNO_MODE_OK): Correctly handle FPregs, even when
	for 64bit PA targets.

	* pa.h (SELECT_SECTION): Define.
	* som.h (SELECT_SECTION): Delete.

Sun Aug  8 15:13:20 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* alias.c (init_alias_analysis): Wrap call to
	`prologue_epilogue_contains' within HAVE_prologue||HAVE_epilogue.

1999-08-07  Bruce Korb  <autogen@linuxbox.com>

	* fixinc/inclhack.def(irix_asm_apostrophe):  IRIX 5.2's
	<sys/asm.h> contains an asm comment with an apostrophe
	* fixinc/inclhack.sh:  regen
	* fixinc/fixincl.x:  regen

Sat Aug  7 19:37:07 1999  Richard Henderson  <rth@cygnus.com>

	* function.c (init_function_start): Clear prologue & epilogue.
	(prologue_epilogue_contains): New function.
	* alias.c (init_alias_analysis): Use it.
	* rtl.h (prologue_epilogue_contains): Declare it.

Sat Aug  7 19:32:16 1999  Richard Henderson  <rth@cygnus.com>

	* jump.c (onlyjump_p): New function.
	* rtl.h: Declare it.
	* flow.c (delete_unreachable_blocks): Use onlyjump_p instead
	of condjump_p in calling tidy_fallthru_edge and merge_blocks.

Sat Aug  7 17:09:36 1999  Richard Henderson  <rth@cygnus.com>

	* global.c (build_insn_chain): Use EXECUTE_IF_SET_IN_REG_SET
	to invert loops.  Simplify block scanning.

Sat Aug  7 02:11:13 1999  Bernd Schmidt <bernds@cygnus.co.uk>

	* gcse.c (hash_scan_set): Treat SYMBOL_REFs like CONST_INTs.
	(cprop_insn): Treat SYMBOL_REFs like CONST_INTs.

1999-08-07  Jonathan Larmour  <jlarmour@cygnus.co.uk>

	* config/sparc/liteelf.h: New file to support sparclite-elf target
	* config/sparc/t-sp86x: New file to support sparc86x targets
	* config/sparc/sp86x-aout.h: New file to support sparc86x-aout target
	* config/sparc/sp86x-elf.h: New file to support sparc86x-elf target
	* configure.in: Support above target triplets
	* configure: Regenerated

Sat Aug  7 01:39:27 1999  Philippe De Muyter  <phdm@macqel.be>

	* fixinc/server.c (server_setup): Do not prefix function used as
 	parameter with `&'.

Sat Aug  7 00:21:20 1999  Richard Henderson  <rth@cygnus.com>

	* alpha.md (movhi and movqi patterns): Correct predicate for !BWX.
	Remove fp reg alternatives.

Sat Aug  7 00:06:54 1999  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (TAROUTOPTS): Kill.
	(install-headers-tar): Use "xpf" for tar headerfile extraction
	* i370/x-oe (TAROUTOPTS): Delete.
	* m68k/x-apollo68 (TAROUTOPTS): Delete.
	* m68k/x-hp320 (TAROUTOPTS): Delete.
	* m68k/x-hp320g (TAROUTOPTS): Delete.
	* gcc.texi: Update bug reporting text.

1999-08-6 Herman A.J. ten Brugge <Haj.Ten.Brugge@net.HCC.nl>

	* reg-stack.c (change_stack) Fixed problem with negative array index.

Fri Aug  6 23:08:44 1999  Jeffrey A Law  (law@cygnus.com)

	* extend.texi, install.texi: Fix spelling mistakes.

	* Makefile.in (PREMADE_ATTRTAB_MD, PREMADE_ATTRTAB): Delete.
	(s-attrtab); No longer try to use pre-made insn-attrtab file.
	* mips/t-bsd: Delete references to obsolete PREMADE_ATTRTAB and
	PREMADE_ATTRTAB_MD.
	* mips/t-ecoff: Likewise.
	* mips/t-elf: Likewise.
	* mips/t-mips: Likewise.
	* mips/t-osfrose: Likewise.
	* mips/t-r3900: Likewise.
	* mips/t-svr3: Likewise.
	* mips/t-svr4: Likewise.
	* mips/t-ultrix: Likewise.

	* gcc.texi: Document recommend means to provide software floating
	point libraries in libgcc.a

1999-08-06  Jason Merrill  <jason@yorick.cygnus.com>

	* c-lex.c (yylex): We can have a number with no digits.

Fri Aug  6 16:53:55 EDT 1999  John Wehle  (john@feith.com)

	* jump.c (delete_prior_computation): New function, broken
	out of delete_computation.  Check for side effects with
	side_effects_p instead of FIND_REG_INC_NOTE.  Handle
	multi-word hard registers.
	(delete_computation): Use it.  Check for side effects with
	side_effects_p instead of FIND_REG_INC_NOTE.  Synthesize a
	missing REG_DEAD note for a register which is both set and
	used by an insn.

Fri Aug  6 11:05:29 1999  Jeffrey A Law  (law@cygnus.com)

	* elf.h (TEXT_SPACE_P, FUNCTION_NAME_P): Delete.
	(ASM_GLOBALIZE_LABEL, ASM_OUTPUT_INT, ASM_OUTPUT_DOUBLE_INT): Likewise.
	(ASM_FILE_START): Import _mcount with the right type.
	(ASM_DECLARE_FUNCTION_NAME): Define.
	(ASM_OUTPUT_EXTERNAL, ASM_OUTPUT_EXTERNAL_LIBCALL): Define.
	* pa.c (output_function_prologue): Always emit the function's label
	here.
	* pa.h (TEXT_SPACE_P): Define.
	(FUNCTION_NAME_P, ENCODE_SECTION_INFO, STRIP_NAME_ENCODING): Likewise.
	(ASM_OUTPUT_INT, ASM_OUTPUT_DOUBLE_INT, ASM_GLOBALIZE_LABEL): Likewise.
	* som.h (TEXT_SPACE_P): Delete.
	(FUNCTION_NAME_P, ENCODE_SECTION_INFO, STRIP_NAME_ENCODING): Likewise.
	(ASM_GLOBALIZE_LABEL, ASM_OUTPUT_INT): Likewise.

Thu Aug  5 19:29:39 1999  Jim Wilson  <wilson@cygnus.com>

	* expr.c (emit_group_load): Allow src to be a CONCAT.

Thu Aug  5 22:27:15 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* config/sh/lib1funcs.asm (___movstrSI0): Change or r0,r0,r0 to nop.
	(___mulsi3): Use '!' comment character.

Thu Aug  5 13:34:14 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* reload1.c (maybe_fix_stack_asms): Also declare P as "const char *".

Thu Aug  5 02:40:42 1999  Jeffrey A Law  (law@cygnus.com)

	* gcc.c: Update URLs and mail addresses.
	* gcc.texi: Likewise.

Thu Aug  5 01:14:13 1999  Daniel Jacobowitz <drow@false.org>

	* rs6000.c (current_file_function_operand): Return zero for
	weak functions.
	(rs6000_encode_section_info): Do not set SYMBOL_REF_FLAG for
	weak symbols.
	* rs6000.h (ENCODE_SECTION_NIFO): Do not set SYMBOL_REF_FLAG
	for weak symbols.

Thu Aug  5 00:56:30 1999  Geoffrey Keating   <geoffk@cygnus.com>

	* rs6000.c (rs6000_stack_info): For ABI_V4/ABI_SOLARIS -fpic, always
	allocate space in the stack frame for the PIC register.

Thu Aug  5 00:20:47 1999  Jeffrey A Law  (law@cygnus.com)

	* m68k.md (xordi3, anddi3): These patterns are not available on
	the coldfire.

Wed Aug  4 23:39:20 1999  Mark Mitchell  <mark@codesourcery.com>

	* real.c (GET_REAL): Don't violate ANSI/ISO aliasing rules.
	(PUT_REAL): Likewise.

Wed Aug  4 20:45:04 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* final.c (shorten_branches): Don't add an alignment for loops
	that have no label inside.

Wed Aug  4 16:39:24 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (expand_builtin_memcmp, expand_builtin_strcmp): Wrap
	prototypes in macro HAVE_cmpstrsi.

	* cpplib.c (cpp_get_token): Remove unused label `op3'.

	* emit-rtl.c (operand_subword): Remove unused variable
	`bits_per_word'.

	* rtl.c (shallow_copy_rtx): Remove unused variable `format_ptr'.

	* tree.c (chainon): Wrap variable `t2' in macro ENABLE_CHECKING.

Wed Aug  4 13:29:23 1999  Zack Weinberg  <zack@bitmover.com>

	* cpphash.c (macroexpand): Delete leading whitespace when arg
	is concatenated before.
	(unsafe_chars): Correct test for whether + and - can extend a
	token.

	* cppinit.c (cpp_start_read): Do dependencies for
	-include/-imacros files also.

	* cpplib.c (cpp_scan_buffer): In no-output mode, don't bother
	tokenizing non-directive lines.
	(cpp_expand_to_buffer): Temporarily disable no-output mode.
	* cppmain.c: In no-output mode, just call cpp_scan_buffer for
	the input file.

Wed Aug  4 12:53:44 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* expr.c (expand_expr, case PLUS_EXPR): Fix parallel case, too.

	* c-lex.c: Sync with C++ frontend.
	(linemode): New variable.
	(parse_float): imag, conversion_errno, and type are output only.
	(yylex): Adjust.  Move initial '.' case into main switch.
	Use linemode.
	(handle_generic_pragma): Just deal with tokens.
	(readescape): Use ISXDIGIT and ISGRAPH.
	* c-parse.in: Add END_OF_LINE token.

	* c-lex.c (lang_init): Generalize.
	(nextchar): Remove.  Replace uses with UNGETC.
	(skip_white_space): Handle linemode here.  Optimize for cpplib.
	(skip_white_space_on_line): Remove.
	(extend_token_buffer_to): New fn.
	(extend_token_buffer): Use it.
	(read_line_number, check_newline): Just deal with tokens.
	(token_getch, token_put_back): New fns.
	(yylex): Use them.  More cpplib optimizations.  Simplify.

Wed Aug  4 12:53:44 1999  Michael Tiemann  <tiemann@holodeck.cygnus.com>
			  Jason Merrill  <jason@yorick.cygnus.com>

	* c-lex.c (init_parse): Set cpp_token to CPP_DIRECTIVE.
	(consume_string): Make this smart about USE_CPPLIB.
	(check_newline): Rewrite to be intelligent about USE_CPPLIB.
	(yylex): Rewrite to be intelligent about USE_CPPLIB.
	Also, clean up cases where we redundantly set token_buffer[0].
	(read_line_number): New fn.
	(ignore_escape_flag): New variable.

Wed Aug  4 13:12:17 1999  Jeffrey A Law  (law@cygnus.com)

	* a29k/t-a29kbare: Fix some comments.
	(LIB2FUNCS_EXTRA): Remove fp-bit.c and dp-bit.c
	(FPBIT, DPBIT): Define.
	* a29k/t-vx29k: Likewise.
	* arc/t-arc: Likewise.
	* arm/t-arm-elf: Likewise.
	* arm/t-bare: Likewise.
	* arm/t-pe: Likewise.
	* arm/t-pe-thumb: Likewise.
	* arm/t-semi: Likewise.
	* arm/t-thumb: Likewise.
	* arm/t-thumb-elf: Likewise.
	* arm/t-thumb-linux: Likewise.
	* h8300/t-h8300: Likewise.
	* i960/t-i960: Likewise.
	* i960/t-vxworks960: Likewise.
	* m32r/t-m32r: Likewise.
	* mips/t-ecoff: Likewise.
	* mips/t-elf: Likewise.
	* mips/t-r3900: Likewise.
	* pa/t-pro: Likewise.
	* rs6000/t-aix43: Likewise.
	* rs6000/t-beos: Likewise.
	* rs6000/t-newas: Likewise.
	* rs6000/t-ppccomm: Likewise.
	* rs6000/t-rs6000: Likewise.
	* rs6000/t-winnt: Likewise.
	* rs6000/t-xnewas: Likewise.
	* rs6000/t-xrs6000: Likewise.
	* sh/t-sh: Likewise.
	* sparc/t-elf: Likewise.
	* sparc/t-sparcbare: Likewise.
	* sparc/t-sparclite: Likewise.
	* sparc/t-splet: Likewise.
	* v850/t-v850: Likewise.
	* mn10200/t-mn10200: Fix comments.
	* mn10300/t-mn10300: Likewise.

	* pa.md (divsi3, udivsi3, modsi3, umodsi3 expanders): Clobber a new
	dummy operand.  Allocate a new pseudo for the dummy operand.
	(divsi3, udivsi3, modis3, umodsi3 patterns): Corresponding changes.

	* pa.md (movqi, movhi patterns): Do not expose FP regs to regclass.

Wed Aug  4 11:53:55 1999  Tom Tromey  <tromey@cygnus.com>

	* configure: Rebuilt.
	* configure.in: Removed --enable-java-gc option and JAVAGC subst.

Wed Aug  4 09:06:14 1999  Richard Earnshaw (rearnsha@arm.com)

	* recog.c (preproces_constraints): Zero recog_op_alt before
	processing the constraints.

	* arm.c (typedef minipool_node): Renamed from pool_node.
	(minipool_vector, minipool_size, minipool_vector_label): Similarly.
	(add_minipool_constant): New function.
	(dump_minipool): New function.
	(find_barrier): Remove special case for getting the insn size of
	an insn that references the constant pool.
	(minipool_fixup): New structure.
	(push_minipool_barrier): New function.
	(push_minipool_fix): New function.
	(note_invalid_constants): New function.
	(add_pool_constant, dump_table, fixit, broken_move): Delete.
	(arm_reorg): Rewrite code to fix up the constant pool into a
	series of mini-pools embedded in the insn stream.
	(arm_output_epilogue): New function, made mainly from the body
	of output_func_epilogue.
	(output_func_epilogue): Move insn generation part of epilogue code
	to arm_output_epilogue.
	* arm.h (ASM_OUTPUT_SPECIAL_POOL_ENTRY): Delete.
	* arm.md (pool_range): New attribute.
	(zero_extendqidi2): Add attribute pool_range.
	(zero_extend_hisi_insn, load_extendqisi, extendhisi_insn,
	extendqihi_insn, extendqisi_insn, movdi, movsi_insn, pic_load_addr,
	pic_load_addr_based_insn, movhi_insn_arch4, movhi_insn_littleend,
	movhi_insn_bigend, loadhi_si_bigend, movsf_hard_insn, movsf_soft_insn,
	movdf_hard_insn, movdf_soft_insn, movxf_hard_insn): Likewise.
	(epilogue): New expand.
	(epilogue_insn): New insn.  Call arm_output_epilogue.

	* arm.c (arm_poke_function_name): Undo change of July 17.  Tidy up.
	* arm.h (TARGET_SWITCHES): Add missing doc string for TARGET_DEFAULT.

Mon Aug  2 19:18:44 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* linux.h (HANDLE_PRAGMA_PACK_PUSH_POP): Define.

1999-08-04 Mark Elbrecht <snowball3@bigfoot.com>

	* config/i386/djgpp.h  (BSS_SECTION_ASM_OP): Define.

Wed Aug  4 02:15:32 1999  Richard Henderson <rth@cygnus.com>

	* jump.c (delete_insn): Delete the addr_vec when deleting a tablejump.

Wed Aug  4 01:48:08 1999  Jim Kingdon  <http://developer.redhat.com>

	* global.c: Fix comment.

Wed Aug  4 01:43:01 1999  Ian Lance Taylor  <ian@zembu.com>

	* gcc.c (access_check): New static function.
	(find_a_file): Use it when searching a directory list.
	* collect2.c (find_a_file): Don't accept directories found when
	searching a directory list.

Wed Aug  4 01:40:43 1999  Philippe De Muyter  <phdm@macqel.be>

	* tlink.c (symbol_hash_lookup): Do not prefix functions used as
	function parameters with `&'.
	(file_hash_lookup, demangled_hash_lookup, tlink_init): Ditto.

Wed Aug  4 01:08:44 1999  Jeffrey A Law  (law@cygnus.com)

	* flow.c (delete_unreachable_blocks): Do not call merge_blocks
	or tidy_fallthru_edge if the last insn in the block is not
	an unconditional jump or a simple conditional jump.

Tue Aug  3 20:21:20 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* Makefile.in (c-decl.o): Depends on defaults.h.

Tue Aug  3 14:14:52 1999  Jeffrey A Law  (law@cygnus.com)

	* pa.h (HARD_REGNO_NREGS): FP registers are always 4 bytes wide for
	PA1.1 and above.
	(CLASS_MAX_NREGS): Likewise.

Tue Aug  3 03:51:20 1999  Jeffrey A Law  (law@cygnus.com)

	* cse.c (cse_insn): Fix dumb thinko in last change.

Tue Aug  3 10:36:13 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* reload1.c (maybe_fix_stack_asms): Declare CONSTRAINTS as
	"const char *".

Mon Aug  2 23:45:45 1999  Hans-Peter Nilsson  <hp@bitrange.com>

	* dwarf2out.c (add_location_or_const_value_attribute): Correct
	test for sizes of passed and declared parameter types.

Tue Aug  3 00:03:41 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* fixincludes: Fix the return type of bsearch, char* -> void*.

	* fixinc/inclhack.def: Likewise.

Mon Aug  2 18:29:32 1999  Mark Mitchell  <mark@codesourcery.com>

	* invoke.texi (-fdump-translation-unit): New option.

Mon Aug  2 17:54:19 1999  Richard Henderson  <rth@cygnus.com>

	* expr.h (PROMOTE_PROTOTYPES): Move ...
	* defaults.h: ... to here.
	* c-decl.c: Include defaults.h instead of expr.h.
	* c-typeck.c: Include defaults.h.

Mon Aug  2 17:10:24 1999  Mark Mitchell  <mark@codesourcery.com>

	* toplev.h (errorcount): Declare.
	(warningcount): Likewise.
	(sorrycount): Likewise.
	* c-lex.c (errorcount): Don't declare.
	* dwarf2out.c (errorcount): Don't declare.

Mon Aug  2 17:02:08 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* config/libgloss.h: Add a note discouraging use with ELF.
	* configure.in: Don't use libgloss.h for ELF targets.
	Always use_collect2 on a.out targets.

Mon Aug  2 16:27:42 1999  Jim Wilson  <wilson@cygnus.com>

	* combine.c (force_to_mode, case LSHIFTRT): Add goto shiftrt.
	(force_to_mode, case ASHIFTRT): Add shiftrt label.

Tue Aug  3 00:45:02 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* loop.c (strength_reduce): When doing biv->giv conversion, update
	reg note of NEXT->insn.

1999-08-02  Jakub Jelinek  <jj@ultra.linux.cz>

	* real.c (PUT_REAL): Clear unused bytes if long double is IEEE quad.

1999-08-02  Jakub Jelinek  <jj@ultra.linux.cz>

	* c-decl.c (get_parm_info, store_parm_decls): Change all uses of
	PROMOTE_PROTOTYPES, so that it tests it as a C expression.
	Ensure expr.h is included.
	* c-typecheck.c (convert_arguments): Ditto.

	* expr.h: Supply default for PROMOTE_PROTOTYPES (0).

	* config/arc/arc.h: Define PROMOTE_PROTOTYPES to 1.
	* config/convex/convex.h: Ditto.
	* config/dsp16xx/dsp16xx.h: Ditto.
	* config/fx80/fx80.h: Ditto.
	* config/gmicro/gmicro.h: Ditto.
	* config/i370/i370.h: Ditto.
	* config/i386/i386.h: Ditto.
	* config/m32r/m32r.h: Ditto.
	* config/m68k/m68k.h: Ditto.
	* config/m88k/m88k.h: Ditto.
	* config/mips/mips.h: Ditto.
	* config/pa/pa.h: Ditto.
	* config/pyr/pyr.h: Ditto.
	* config/tahoe/tahoe.h: Ditto.
	* config/we32k/we32k.h: Ditto.

	* config/sparc/sparc.h: Define PROMOTE_PROTOTYPES
	based on arch size.

	* config/i1750a/i1750a.h: Define PROMOTE_PROTOTYPES to 0.

	* config/i860/paragon.h: Remove PROMOTE_PROTOTYPES
	from comment.

	* tm.texi: Document new usage of PROMOTE_PROTOTYPES.

1999-08-02  Richard Henderson  <rth@cygnus.com>

	* m32r.c (m32r_setup_incoming_varargs): Use get_varargs_alias_set
	for the register spill block.
	(m32r_va_arg): New.
	* m32r.h (EXPAND_BUILTIN_VA_ARG): New.
	(EXPAND_BUILTIN_SAVEREGS): Delete #if 0 code.

	* m32r.h (INT8_P): Don't short-cut test with (unsigned).
	(INT16_P, CMP_INT16_P, UINT16_P): Likewise.
	(UPPER16_P, UINT24_P, INT32_P, UINT5_P): Likewise.

1999-08-02  Jakub Jelinek  <jj@ultra.linux.cz>

	* config/sparc/linux.h: Define WCHAR_TYPE as "int" and undef
	MAX_WCHAR_TYPE defined in sparc.h.
	* config/sparc/linuxaout.h: Likewise.
	* config/sparc/linux64.h: Likewise.
	Also default to -mvis if CPU is UltraSPARC.

1999-08-02  Jakub Jelinek  <jj@ultra.linux.cz>

	* config/sparc/sparc.h (ASM_DECLARE_REGISTER_GLOBAL): New macro.
	(RTX_OK_FOR_OLO10): Likewise.
	(GO_IF_LEGITIMATE_ADDRESS): If assembler supports offsetable
	%lo(), allow it in addresses...
	(PRINT_OPERAND_ADDRESS): ... and print it appropriately.
	* config/sparc/sparc.md (sethi_di_medlow_embmedany_pic): sethi %lo()
	does not make sense.
	* config/sparc/sparc.c (sparc_hard_reg_printed): New array.
	(sparc_output_scratch_registers): New function.
	(output_function_prologue, sparc_flat_output_function_prologue): Use
	it.
	* varasm.c (make_decl_rtl): Use ASM_DECLARE_REGISTER_GLOBAL if
	defined.
	* tm.texi (ASM_DECLARE_REGISTER_GLOBAL): Document it.
	* configure.in: Add check for .register pseudo-op support in as and
	check for offsetable %lo().
	* acconfig.h: Add templates for the above checks.
	* configure: Regenerate.

1999-08-02  Richard Henderson  <rth@cygnus.com>

	* sparc/linux64.h (TARGET_DEFAULT): Remove MASK_APP_REGS.
	* sparc/sol2-sld-64.h (TARGET_DEFAULT): Likewise.
	* sparc/sol2.h (TARGET_DEFAULT): Likewise.

Mon Aug  2 23:46:45 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* loop.c (strength_reduce): When doing biv->giv conversion, fix up
	reg_biv_class.

1999-08-02  Jakub Jelinek  <jj@ultra.linux.cz>

	* config/float-sparc.h: New file.
	* configure.in: Use float_format=sparc for sparc-*-linux-gnulibc1,
	sparc-*-linux-gnu and sparc64-*-linux*.

1999-08-02  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* rs6000.c (rs6000_va_list): Type is an array.
	(rs6000_va_start): Don't doubly adjust for varargs.
	(rs6000_va_arg): Evaluate long long GPR adjustment.

Mon Aug  2 16:15:57 1999  David Edelsohn  <edelsohn@gnu.org>

	* rs6000/aix43.h (SUBTARGET_SWITCHES): Use -m64 and -m32 instead of
	-maix64 and -maix32.
	(ASM_SPEC, ASM_CPU_SPEC, CPP_SPEC, CPP_CPU_SPEC, LIB_SPEC,
	LINK_SPEC): Change appropriately.
	* rs6000/rs6000.c (short_cint_operand): Use CONST_OK_FOR_LETTER_P.
	(u_short_cint_operand): Likewise.
	* rs6000/rs6000.md (movdi splitters): Add TARGET_POWERPC64 support
	for 64-bit hosts.
	* rs6000/t-aix43 (MULTILIB): Change to -m64.

	* invoke.texi (RS/6000 Submodel): Document 64-bit processor options.

Mon Aug  2 16:15:57 1999  Geoff Keating  <geoffk@cygnus.com>

	* rs6000/rs6000.c (num_insns_constant_wide): Correct
	for type promotion.
	(add_operand): Get test correct for 64-bit HOST_WIDE_INT.
	(non_add_cint_operand): Likewise.
	(logical_operand): Likewise.
	(non_logical_cint_operand): Likewise.
	(print_operand): Correct printf()s for 64-bit HOST_WIDE_INT.
	(print_operand_address): Correct printf() for 64-bit HOST_WIDE_INT.
	(rs6000_select_rtx_section): Suppress warning.
	(small_data_operand): Suppress warning.
	(rs6000_got_register): Suppress warning.
	* rs6000/rs6000.md (andsi3): HOST_WIDE_INT is a signed
	type, so `J' is generally the wrong constraint for a SImode value;
	use `L' instead.
	(andsi3_internal2): Likewise.
	(andsi3_internal3): Likewise.
	(iorsi3_internal1): Likewise.
	(xorsi3_internal1): Likewise.
	(movsi): Likewise.
	(movsf_softfloat): Likewise.
	(scc insns): Likewise.
	(movsi+2): Preserve sign bits of SImode constant.
	(floatsidf2_internal+1): Sign-extend SImode constant correctly.
	(movdf+1): Sign-extend properly.
	(movdi_32+1): Sign-extend properly.
	(scc insns): Sign-extend properly.

	* md.texi (RS/6000 EXTRA_CONSTRAINTS): Update documentation for J,
	K, L, and T.

1999-08-02  Richard Henderson  <rth@cygnus.com>

	* alpha.c (override_options): Move ev6 alpha_tp frobbing out of
	-mcpu parsing code.
	(print_operand): Notice alpha_fptm not alpha_tp for sw completion.
	* alpha.md (all fp insns): Likewise.

1999-08-02  Nick Clifton  <nickc@cygnus.com>

	* config/v850/v850.h (STRICT_ALIGNMENT): Only define if not
	already defined.

Mon Aug  2 03:38:33 1999  Jeffrey A Law  (law@cygnus.com)

	* pa.c (legitimize_pic_address): Clarify comments.  Do not call the
	pic_load_label generator directly.
	* pa.md (pic_load_label): Clarify comments.  Remove modes on operands.
	No longer a named pattern.

Mon Aug  2 09:38:10 1999  Nick Clifton  <nickc@cygnus.com>

	* explow.c (force_reg): Call force_operand if X does not
	satisfy general_operand.

Mon Aug  2 01:34:22 1999  Jeffrey A Law  (law@cygnus.com)

	* fix-header.c (main): When testing for CONTINUED, use string
	equality, not pointer equality.

Mon Aug  2 01:27:24 1999  Dan Nicolaescu  <dann@ics.uci.edu>

	* sparc.c (sparc_block_profiler): Use the %g2 register, not %o0.

Sun Aug  1 22:46:42 1999  Jeffrey A Law  (law@cygnus.com)

	* cse.c (cse_insn): Fix loop which deletes insns after a jump
	that has become an unconditional jump.

	* m68k.c (output_function_prologue): Fix typo in CPU32 case.
	(output_function_epilogue): Similarly.

Sun Aug  1 20:14:00 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* tree.h (init_dummy_function_start): Declare.

Sun Aug  1 12:55:31 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* stmt.c (emit_filename, emit_lineno, expr_stmts_for_value,
	last_expr_type, last_expr_value, block_start_count, block_stack,
	stack_block_stack, cond_stack, loop_stack, case_stack, nesting_stack,
	nesting_depth, goto_fixup_chain): Delete global	vars; now allocated
	dynamically in stmt elt of struct function for each function.
	(struct nesting): Rename function_call_count elt to n_function_calls,
	target_temp_slot_level to block_target_temp_slot_level.  All users
	changed.
	(struct stmt_status): New structure definition.
	Add many accessor macros for stmt_status elements which previously
	were global variables.
	(init_stmt_for_function): Allocate stmt elt for current_function.
	Reflect that block_start_count was renamed to
	current_block_start_count.
	(save_stmt_status, restore_stmt_status): Delete functions.
	(preserve_subexpressions_p): Don't access loop_stack when outside
	a function.
	(expand_start_bindings): Reflect that block_start_count was renamed to
	current_block_start_count.
	(expand_fixup): Likewise.
	(expand_decl): Don't access block_stack when outside a function.
	(expand_decl_cleanup): Likewise.
	(expand_dcc_cleanup): Likewise.
	(expand_dhc_cleanup): Likewise.
	(expand_anon_union_decl): Likewise.
	(set_file_and_line_for_stmt): New function.
	(in_control_zone_p): New function.

	* function.h (struct function): Add new elt stmt.
	Delete elts block_stack, stack_block_stack, cond_stack, loop_stack,
	case_stack, nesting_stack, nesting_depth, block_start_count,
	last_expr_type, last_expr_value, expr_stmts_for_value, emit_filename,
	emit_lineno, goto_fixup_chain.
	(save_eh_status, restore_eh_status, save_stmt_status,
	restore_stmt_status): Delete declarations.
	* function.c (push_function_context_to): Don't call save_stmt_status.
	(pop_function_context_to): Don't call restore_stmt_status.
	* tree.h (in_control_zone_p): Declare.
	* rtl.h (set_file_and_line_for_stmt): Declare.

	* emit-rtl.c (emit_line_note): Don't set emit_filename/emit_lineno;
	call set_file_and_line_for_stmt.

Thu Jul 31 12:34:45 1999  Joe Buck  <jbuck@synopsys.com>

	* gcc.texi: Use terms "GNU Compiler Collection" and "GCC".
	Also update copyright.

Sat Jul 31 11:10:07 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* c-pragma.c: Don't include "except.h".
	* emit-rtl.c: Likewise.
	* stor-layout.c: Likewise.
	* tree.c: Likewise.
	* varasm.c: Likewise.

	* flow.c: Include "function.h".
	* tree.h (init_dummy_function_start): Declare new function.

	* except.h (struct eh_status): New structure.
	(struct label_node, struct eh_entry): Declare even if tree.h hasn't
	been included.
	(eh_return_stub_label, ehstack, catchstack, ehqueue,
	catch_clauses, false_label_stack, caught_return_label_stack,
	protect_list, current_function_ehc): Add accessor macros for the
	corresponding fields in current_function->eh; delete declarations
	for all items that used to be declared here.
	* except.c (eh_return_stub_label, ehstack, catchstack, ehqueue,
	catch_clauses, false_label_stack, caught_return_label_stack,
	protect_list, current_function_ehc): Delete variables.
	(init_eh_for_function): Allocate current_function->eh.
	(save_eh_status, restore_eh_status): Delete functions.

	* function.h (struct function): Add fields next_global and eh.
	Delete all exception handling related fields.
	* function.c (current_function): New variable.
	(all_functions): New variable.
	(push_function_context_to): Don't allocate a struct function,
	use current_function instead.  Call init_dummy_function_start when
	outside a function.  Clear current_function before returning.
	(pop_function_context_from): Restore current_function.
	Don't free the restored struct function.
	(prepare_function_start): New function.
	(init_dummy_function_start): New function.
	(init_function_start): Break out some code into prepare_function_start
	and call it here.

	* stmt.c (save_stmt_status): Don't call save_eh_status.
	(restore_stmt_status): Don't call restore_eh_status.

	* Makefile.in: Update dependencies.

Sat Jul 31 04:10:01 1999  Jeffrey A Law  (law@cygnus.com)

	* pa.c (compute_frame_size): Use STARTINg_FRAME_OFFSET instead
	of depending on a magic constant value.  Update comments.
	(hppa_expand_prologue): Similarly.

	* pa.md (reload_indi, reload_outdi): Allow any register for the
	original reload register.

Fri Jul 30 19:41:35 1999  Jim Wilson  <wilson@cygnus.com>

	* cccp.c (print_help): Change marcos to macros.

1999-07-30  Richard Henderson  <rth@cygnus.com>

	* c-typeck.c (initializer_constant_valid_p): Move ...
	* c-common.c (initializer_constant_valid_p): ... here.  Use
	FOO_TYPE_P instead of tests against TREE_CODE.  Allow subtraction
	of label addresses.
	* c-common.h (initializer_constant_valid_p): Declare.
	* c-tree.h (initializer_constant_valid_p): Remove.

Fri Jul 30 16:33:42 1999  Mathias Froehlich  <frohlich@na.uni-tuebingen.de>

	* config/i386/sol2-c1.asm: Align the stack.
	* config/i386/sol2-gc1.asm: Likewise.

1999-07-30  Vladimir Makarov  <vmakarov@loony.cygnus.com>

	* config/sparc/sparc.h (ASM_CPU32_DEFAULT_SPEC): Change -Av8 onto
 	-Asparclite for sparc86x.
	(CPP_CPU32_DEFAULT_SPEC, CPP_CPU_SPEC): Remove -D__sparc_v8__ for
 	sparc86x.
	(ASM_CPU_SPEC): Use -Asparclite for sparc86x.

Fri Jul 30 14:53:56 1999  Jakub Jelinek  <jj@ultra.linux.cz>

	* config/sparc/linux64.h (CC1_SPEC): Preserve CPU specified by
	the user if using the non-default arch size in BI_ARCH configuration.
	* config/sparc/sol2-sld-64.h (CC1_SPEC): Ditto.

	* config/sparc/sparc.md (cmp_mul_set, cmp_udiv_cc_set):
	Fix patterns so that they actually match.
	(cmp_sdiv_cc_set): Ditto, also don't require g0 to be zero.
	(mulsidi3_sp64, const_mulsidi3_sp64): New patterns.
	(const_mulsidi3_sp32): Renamed from const_mulsidi3, only on
	TARGET_HARD_MUL32.
	(mulsidi3): Reflect this in the expand.
	(smulsi3_highpart): Only on TARGET_ARCH32.
	(umulsidi3_sp64, const_umulsidi3_sp64): New patterns.
	(const_umulsidi3_sp32): Renamed from const_umulsidi3.
	(umulsidi3): Reflect this in the expand.
	(umulsi3_highpart): Only on TARGET_ARCH32.
	(divsi3_sp32): Renamed from divsi3, only on TARGET_ARCH32,
	don't require g0 to be zero.
	(udivsi3_sp32): Renamed from udivsi3, only on TARGET_ARCH32.
	({,u}divsi3): New expands.
	({,u}divsi3_sp64): New patterns.
	(after lshrdi3_v8plus): Four new patterns to help combiner
	optimizing nested mixed mode shifts.

	* config/sparc/sparc.c (sparc_override_options): Use deprecated
	v8 instructions if optimizing for UltraSPARC I, II, IIi, as it
	speed things up. Don't use them by default on plain v9 in 64bit
	mode, according to what SPAMv9 sais.

	* config/sparc/sparc.h: Fix comments, e.g. Linux already preserves
	top 32 bits of %[og][0-7] in signal handlers.
	Also, TARGET_HARD_MUL32 now is only true for TARGET_ARCH32.

Fri Jul 30 03:00:41 1999  Jeffrey A Law  (law@cygnus.com)

	* pa.md (zvdep_imm32): Renamed from zvdep_imm.
	(ashlsi3): Corresponding changes.

	* pa.c (compute_zdepwi_operands): Renamed from compute_zdepi_operands.

Thu Jul 29 18:37:13 1999  Jeffrey A Law  (law@cygnus.com)

	* pa.h (FIRST_PARM_CALLER_OFFSET): Delete.

Thu Jul 29 19:01:58 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* arm.h (Hint): Delete macro.
	Substitute HOST_WIDE_INT for Hint in some prototypes.
	* arm.c: Substitute HOST_WIDE_INT for Hint in one prototype.

Thu Jul 29 09:21:42 1999  Nick Clifton  <nickc@cygnus.com>

	* builtins.c (expand_builtin_setjmp): Use force_operand to
	make sure that the buffer address is in a suitable form to be
	passed to force_reg.

Wed Jul 28 12:50:48 1999  Geoff Keating  <geoffk@cygnus.com>

	* config/mips/mips.c: system.h handles MIN and MAX, don't undefine
	them here.

Wed Jul 28 13:18:35 1999  Jeffrey A Law  (law@cygnus.com)

	* pa.md (indirect_jump): Remove mode from match_operand.  Verify
	proper mode in the condition string.
	(icacheflush, dcacheflush): Remove modes from match_operands.

	* pa.c (emit_move_sequence): Always convert scratch_reg to the
	proper mode before using it.

	* pa.md (adddi3, subdi3): Turn into a define_expand/define_insn
	pair.

	* pa.c (store_reg): Do not call add_high_const generator directly.
	(load_reg, set_reg_plus_d): Likewise.
	* pa.md (add_high_const): No longer a named pattern.

	* pa.c (legitimize_address): Consistently use Pmode rather than
	SImode.  Do not call gen_pic2_highpart directly anymore.
	* pa.md (pic2_highpart): No longer a named pattern.
	(pic2_lo_sum): Similarly.  Reformat to make more readable.

	* pa.md (call, call_value): Use "word_mode" instead of "SImode" as
	needed.

	* README: Update.

Wed Jul 28 11:28:04 1999  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* builtins.c (expand_builtin): Typo in call to expand_builtin_ffs.

Wed Jul 28 11:23:48 1999  Richard Henderson  <rth@cygnus.com>

	* pa.c (hppa_builtin_saveregs):  Use get_varargs_alias_set
	and tag the spill mems.
	(hppa_va_start): New.
	(hppa_va_arg): New.
	* pa.h (EXPAND_BUILTIN_VA_START): New.
	(EXPAND_BUILTIN_VA_ARG): New.

Wed Jul 28 11:22:21 1999  Richard Henderson  <rth@cygnus.com>

	* mn10300.c (mn10300_builtin_saveregs): Use get_varargs_alias_set
	and tag the spill mems.
	(mn10300_va_start): New.
	(mn10300_va_arg): New.
	* mn10300.h (EXPAND_BUILTIN_VA_START): New.
	(EXPAND_BUILTIN_VA_ARG): New.

Wed Jul 28 11:20:19 1999  Richard Henderson  <rth@cygnus.com>

	* mn10200.c (mn10200_va_arg): New.
	* mn10200.h (EXPAND_BUILTIN_VA_ARG): New.

Wed Jul 28 11:19:06 1999  Richard Henderson  <rth@cygnus.com>

	* builtins.c (std_expand_builtin_va_arg): Use int_size_in_bytes
	rather than play with TREE_INT_CST_LOW.

1999-07-27  Philip Blundell  <pb@nexus.co.uk>

	* config/arm/telf.h: Include dbxelf.h.
 	(CPP_PREDEFINES): Only define if not already defined.
	(ASM_IDENTIFY_GCC): Likewise.
	(SUBTARGET_EXTRA_SECTIONS): Likewise.
	(SUBTARGET_EXTRA_SECTION_FUNCTIONS): Likewise.
	* config/arm/thumb.h (LINK_SPEC): Only define if not already
	defined.
	(DBX_DEBUGGING_INFO): Don't define.
	* config/arm/linux-telf.h: New file.
	* config/arm/linux-tgas.h: New file.
	* config/arm/t-thumb-linux: New file.
	* config/arm/uclinux-elf.h: New file.
	* config/arm/uclinux-telf.h: New file.
	* configure.in (arm-*-uclinux, thumb-*-linux-gnu,
	thumb-*-uclinux): New targets.
	* configure: Regenerate.

Tue Jul 27 23:20:21 1999  Jeffrey A Law  (law@cygnus.com)

	* pa.md (post_store, pre_load): New expanders.
	(post_stwm, pre_ldwm): Renamed to post_stw and pre_ldw respectively.
	(post_ldwm, pre_stwm): Make these unnamed patterns since we never
	need to directly generate RTL for them.
	* pa.c (hppa_expand_prologue, hppa_expand_epilogue): Corresponding
	changes.

Tue Jul 27 16:05:52 1999  David Edelsohn  <edelsohn@gnu.org>

	* aix43.h (ASM_CPU_SPEC, CPP_CPU_SPEC): Add rs64a and PPC630.
	* rs6000.c (processor_target_table): Add powerpc64, rs64a, and PPC630.
	(rs6000_cpu): Choose between 32-bit and 64-bit default processors.
	(secndary_reload_class): Make TARGET_ELF conditional compile.
	(print_operand_address): Similar.
	(output_toc): Print all values as hex.
	(get_issue_rate): Rearrange and add RS64A and PPC630.
	* rs6000.h (processor_type): Add RS64A and PPC630.
	(PROCESSOR_POWERPC64): New.
	(PROMOTE_MODE): Use word_mode.
	(RTX_COSTS): Add RS64A and PPC630.
	* rs6000.md (scheduling information): Add lmul and ldiv
	representing 64-bit integer multiply and divide.  Add rs64a and
	PPC630 information.
	(ashldi3): Add support for "rldic" instruction.
	* sysv4.h (PROCESSOR_DEFAULT): Change to PROCESSOR_750.

Tue Jul 27 15:31:53 1999  Vladimir Makarov  <vmakarov@toad.to.cygnus.com>

	* config/sparc/sparc.c (sparc_override_options): Enable SPARCLITE
	instead of V8 for sparclite86x in cpu_table.

Tue Jul 27 17:49:42 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* config/arm/coff.h (ASM_FILE_START): If generating SDB output, call
	output_file_directive.

Tue Jul 27 03:15:33 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* expr.c (expand_expr, case PLUS_EXPR): Get the mode from the
	tree for op1, not the rtl.

Tue Jul 27 00:18:34 1999  Richard Henderson  <rth@cygnus.com>

	* m88k.c (m88k_builtin_saveregs): Break out the constructor code
	to m88k_va_start, leaving only the register spill.
	(m88k_build_va_list): New.
	(m88k_va_start): New.
	(m88k_va_arg): New.
	* m88k.h (BUILD_VA_LIST_TYPE): New.
	(EXPAND_BUILTIN_VA_START): New.
	(EXPAND_BUILTIN_VA_ARG): New.

Mon Jul 26 19:07:11 1999  Geoff Keating  <geoffk@cygnus.com>

	* config/rs6000/rs6000.c (rs6000_expand_builtin_saveregs):
	Rename from expand_builtin_saveregs.
	* config/rs6000/rs6000.h (EXPAND_BUILTIN_SAVEREGS): Change caller.

Mon Jul 26 22:52:47 1999  Richard Henderson  <rth@cygnus.com>

	* i960.c (i960_setup_incoming_varargs): Use get_varargs_alias_set
	for the register spill block.
	(i960_build_va_list): New.
	(i960_va_start): New.
	(i960_va_arg): New.
	* i960.h (BUILD_VA_LIST_TYPE): New.
	(EXPAND_BUILTIN_VA_START): New.
	(EXPAND_BUILTIN_VA_ARG): New.
	* i960.md (store_multiple): Use change_address on individul mems.

Mon Jul 26 22:43:12 1999  Richard Henderson  <rth@cygnus.com>

	* builtins.c (stabilize_va_list): Don't INDIRECT_REF through
	an ARRAY_TYPE.
	(std_expand_builtin_va_start): Back out one word if !stdarg_p.
	(expand_builtin_va_end): Evaluate arg for side effects.
	* c-common.c (c_common_nodes_and_builtins): Construct a
	va_list_arg_type_node to handle array decomposition to pointer.

Mon Jul 26 18:51:34 1999  Richard Henderson  <rth@cygnus.com>

	* except.c (start_dynamic_cleanup): Use force_operand on the
	buffer's address.

Mon Jul 26 16:43:26 1999  Richard Henderson  <rth@cygnus.com>

	* c4x.h (EXPAND_BUILTIN_VA_ARG): New.
	* c4x.c (c4x_va_arg): New.

Mon Jul 26 12:30:09 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* cpplib.c (cpp_get_token): Don't return a CPP_POP if the buffer
	has manual_pop set.

1999-07-26  Nathan Sidwell  <nathan@acm.org>

	* eh-common.h (__eh_matcher): Prototype correctly.

Mon Jul 26 17:24:51 1999  Philip Blundell  <pb@nexus.co.uk>

	* config/arm/thumb.h (THUMB_FLAG_SINGLE_PIC_BASE): Define.
	(TARGET_SINGLE_PIC_BASE): Likewise.
	(GOT_PCREL, NEED_GOT_RELOC, NEED_PLT_RELOC): Provide default
	definitions.
	(TARGET_CALLEE_INTERWORKING): Fix typo in comment.
	(TARGET_SWITCHES): Add -m{no-}single-pic-base.
	(TARGET_OPTIONS): Add -mpic-register=N.
	(OUTPUT_INT_ADDR_CONST): New macro.
	(INDEX_REGISTER_RTX_P, PIC_OFFSET_TABLE_REGNUM, FINALIZE_PIC,
	LEGITIMATE_PIC_OPERAND_P): Likewise.
	(LEGITIMIZE_ADDRESS, GOT_IF_LEGITIMATE_ADDRESS): Support PIC.
	(ASM_OUTPUT_INT): Use OUTPUT_INT_ADDR_CONST rather than calling
	output_addr_const directly.
	(PRINT_OPERAND_PUNCT_VALID_P): Accept `|' for compatibility with
	ARM port.
	(thumb_pic_register, thumb_pic_register_string): Declare.

	* config/arm/thumb.c (symbol_mentioned_p): New function: Imported
	from arm.c.
	(label_mentioned_p): New function: Imported from arm.c.
	(legitimize_pic_address): New function: Imported from arm.c.
	(is_pic):New function: Imported	from arm.c.
	(thumb_finalize_pic):New function: Imported from arm.c.
	(add_constant): Cope with PIC constants.
	(fixit): Cope with PIC constants.
	(output_return): Do not treat the PIC register as live if
	TARGET_SINGLE_PIC_BASE is true.
	(thumb_function_prologue): Do not treat the PIC register as live if
	TARGET_SINGLE_PIC_BASE is true.
	(thumb_expand_prologue): Do not treat the PIC register as live if
	TARGET_SINGLE_PIC_BASE is true.
	(thumb_unexpand_epilogue): Do not treat the PIC register as live if
	TARGET_SINGLE_PIC_BASE is true.
	(thumb_print_operand): Accept '|'.
	(thumb_override_options): Process PIC options.

	* config/arm/thumb.md (movsi): Support PIC.
	(call_insn): Change "i" constraint to "X".
	(call_value_insn): Likewise.
	(consttable_4, consttable_8, consttable_end): Set and clear
	"making_const_table" as appropriate.
	(pic_load_addr, pic_add_dot_plus_four): New insns.

	* invoke.texi (Thumb Options): Fix spelling.  Document new
	options -msingle-pic-base and -mpic-register=.

1999-07-26  Andrew Haley  <aph@cygnus.com>

	* config/m32r/initfini.c (__init): Use a full word immediate for
	__fini: this allows it to be placed in any memory region.

	* config/m32r/t-m32r: Compile crtinit.o and crtfini.o for
	-mmodel=medium.  This is OK for all memory models.

Mon Jul 26 11:58:46 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.c: Replace %R%s in asm_fprintf strings with %r.
	* config/arm/arm.h: Replace %R%s in asm_fprintf strings with %r.

Mon Jul 26 10:23:36 1999  Nick Clifton  <nickc@cygnus.com>

	* final.c (asm_fprintf): Accept ASM_FPRINTF_EXTENSIONS, if
	defined.

	* tm.texi: Document ASM_FPRINTF_EXTENSIONS.

Sun Jul 25 23:51:59 1999  Richard Henderson  <rth@cygnus.com>

	* i860.h (EXPAND_BUILTIN_SAVEREGS): New.
	(BUILD_VA_LIST_TYPE): New.
	(EXPAND_BUILTIN_VA_START): New.
	(EXPAND_BUILTIN_VA_ARG): New.
	* i860.c (output_delayed_branch): Disable.
	(output_delay_insn): Likewise.
	(i860_saveregs): New.
	(i860_build_va_list): New.
	(i860_va_start): New.
	(i860_va_arg): New.
	* i860.md: Disable all peepholes using output_delayed_branch.
	* i860/sysv4.h (I860_SVR4_VA_LIST): New.

Sun Jul 25 23:44:13 1999  Richard Henderson  <rth@cygnus.com>

	* clipper.h (EXPAND_BUILTIN_SAVEREGS): Remove argument.
	(BUILD_VA_LIST_TYPE): New.
	(EXPAND_BUILTIN_VA_START): New.
	(EXPAND_BUILTIN_VA_ARG): New.
	* clipper.c (clipper_builtin_saveregs): Only dump registers.
	Return the address of the save area.
	(clipper_build_va_list): New.
	(clipper_va_start): New.
	(clipper_va_arg): New.

Sun Jul 25 22:56:47 1999  Richard Henderson  <rth@cygnus.com>

	* arc.h (EXPAND_BUILTIN_VA_START): New.
	(EXPAND_BUILTIN_VA_ARG): New.
	* arc.c (arc_setup_incoming_varargs): Set alias set of
	varargs save area.
	(arc_va_start): New.
	(arc_va_arg): New.

Sun Jul 25 22:45:55 1999  Richard Henderson  <rth@cygnus.com>

	* alpha.h (EXPAND_BUILTIN_SAVEREGS): Delete.
	(BUILD_VA_LIST_TYPE): New.
	(EXPAND_BUILTIN_VA_START): New.
	(EXPAND_BUILTIN_VA_ARG): New.
	* alpha.c (alpha_builtin_saveregs): Delete.
	(alpha_build_va_list): New.
	(alpha_va_start): New.
	(alpha_va_arg): New.

Sun Jul 25 21:40:33 1999  Jeffrey A Law  (law@cygnus.com)

	* config/svr4.h (CTORS_SECTION_ASM_OP): Do not emit directives in
	column zero.
	(DTORS_SECTION_ASM_OP, INIT_SECTION_ASM_OP): Likewise.
	(FINI_SECTION_ASM_OP, ASM_OUTPUT_SECTION_NAME): Likewise.

	* gcc.texi: More changes related to list conversion.
	* invoke.texi: Likewise.

Sun Jul 25 18:15:39 1999  Richard Henderson  <rth@cygnus.com>

	* builtins.c (expand_builtin_saveregs): Remove static, remove exp
	and ignore arguments, bail if no EXPAND_BUILTIN_SAVEREGS.
	(expand_builtin_next_arg): Accept ARGLIST not EXP.
	(stabilize_va_list): New function.
	(std_expand_builtin_va_start): New function.
	(expand_builtin_va_start): New function.
	(get_varargs_alias_set): New function.
	(std_expand_builtin_va_arg): New function.
	(expand_builtin_va_arg): New function.
	(expand_builtin_va_end): New function.
	(expand_builtin_va_copy): New function.
	(expand_builtin): Call them.
	* c-common.c (c_common_nodes_and_builtins): Build __builtin_va_list,
	__builtin_{varargs_start,stdarg_start,end,copy}.
	(build_va_arg): New function.
	* c-common.h (CTI_PTR_TYPE, ptr_type_node): Delete.
	(build_va_arg): Declare.
	* c-decl.c (ptr_type_node, va_list_type_node): New.
	* c-parse.gperf (__builtin_va_arg): New.
	* c-parse.in (VA_ARG): New token.
	(unary_expr): Recognize it.
	* expr.c (expand_expr): Expand VA_ARG_EXPR.
	* expr.h (std_expand_builtin_va_start): Declare.
	(std_expand_builtin_va_arg): Declare.
	(expand_builtin_va_arg): Declare.
	(get_varargs_alias_set): Declare.
	* tree.def (VA_ARG_EXPR): New.
	* tree.h (BUILT_IN_VARARGS_START): New.
	(BUILT_IN_STDARG_START, BUILT_IN_VA_END): New.
	(ptr_type_node, va_list_type_node): Declare.
	* tm.texi (EXPAND_BUILTIN_SAVEREGS): Kill unused ARGLIST argument.
	* m32r.h (EXPAND_BUILTIN_SAVEREGS): Likewise.
	* m88k.h, m88k.c: Likewise.
	* mn10300.h, mn10300.c: Likewise.
	* pa.h, pa.c: Likewise.
	* rs6000.h, rs6000.c: Likewise.
	* sh.h, sh.c: Likewise.
	* sparc.h, sparc.c: Likewise.

	* emit-rtl.c (operand_subword): Copy alias set.
	(change_address): Likewise.

Sun Jul 25 15:04:37 1999  Jeffrey A Law  (law@cygnus.com)

	* pa.c (compute_frame_size): Scan all the used callee saved registers,
	not just the first one.

Fri Jul 23 14:09:58 1999  Philip Blundell  <pb@nexus.co.uk>

	* config/arm/arm.h (TARGET_SWITCHES): Add
	-m{no-}single-pic-base.  Correct help string for -mshort-load-words.
	(TARGET_OPTIONS): Add -mpic-register=.
	(ARM_FLAG_SINGLE_PIC_BASE, TARGET_SINGLE_PIC_BASE): Define.
	(arm_pic_register_string): Declare.
	(NEED_PLT_GOT): Delete, replace with ...
	(NEED_GOT_RELOC, NEED_PLT_RELOC): ... these.  New macros.
	(OUTPUT_INT_ADDR_CONST): Replace NEED_PLT_GOT with NEED_GOT_RELOC.
	(ASM_OUTPUT_MI_THUNK): Replace NEED_PLT_GOT with NEED_PLT_RELOC.
	* config/arm/arm.c (arm_override_options): Add new option
 	-mpic-register=N.
	(arm_pic_register_string): New variable.
	(arm_finalize_pic): Respect TARGET_SINGLE_PIC_BASE.
	(output_func_prologue): If TARGET_SINGLE_PIC_BASE, treat the PIC
	register as never live.  Use NEED_PLT_RELOC not NEED_PLT_GOT.
	(output_return_instruction): Likewise.
	* config/arm/elf.h (NEED_PLT_GOT): Delete, replace with ...
	(NEED_GOT_RELOC, NEED_PLT_RELOC): ... these.  Define to flag_pic.
	* config/arm/arm.md: Use NEED_PLT_RELOC in place of NEED_PLT_GOT.

	* invoke.texi (ARM Options): Fix spelling.  Remove duplicate
	mention of -msched-prolog.  Document new options -msingle-pic-base
	and -mpic-register=.

Thu Jul 22 18:23:56 1999  Richard Henderson  <rth@cygnus.com>

	* haifa-sched.c (reemit_notes): Tidy.
	* sched.c (reemit_notes): Duplicate 1998-08-31 patch to
	haifa's routine.

Thu Jul 22 18:21:04 1999  Richard Henderson  <rth@cygnus.com>

	* explow.c (trunc_int_for_mode): New function.
	(plus_constant_wide): Use it.
	* combine.c (simplify_and_const_int): Likewise.
	(merge_outer_ops): Likewise.
	(simplify_shift_const): Likewise.
	* cse.c (simplify_unary_operation): Likewise.
	(simplify_binary_operation): Likewise.
	* emit-rtl.c (operand_subword): Likewise.
	* rtl.h: Declare it.

Thu Jul 22 14:34:59 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* config/arm/arm.c (arm_print_operand): Fix typo in 'M' case
	(use NUM_REGS instead of NUM_INTS).

Thu Jul 22 11:25:20 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* builtins.c: New file.
	* expr.c (saveregs_value, apply_args_value):  Delete definition,
	moved into builtins.c.
	(string_constant): No longer static.
	(get_pointer_alignment, c_strlen, get_memory_rtx, expand_builtin,
	apply_args_size, apply_result_size, result_vector,
	expand_builtin_apply_args, expand_builtin_apply,
	expand_builtin_return): Delete functions, moved into builtins.c.
	(INCOMING_REGNO, OUTGOING_REGNO): Delete unused macros.
	* expr.h (saveregs_value, apply_args_value): Declare variables.
	(expand_builtin, string_constant): Declare functions.
	* Makefile.in: Update to build builtin.o.

Wed Jul 21 00:46:58 1999  Mark P. Mitchell  <mark@codesourcery.com>

	* defaults.h (DWARF2_GENERATE_TEXT_SECTION_LABEL): New macro.
	* tm.texi (DWARF2_GENERATE_TEXT_SECTION_LABEL): Define it.
 	* dwarf2out.c (dwarf2out_init): Don't output a label to mark the
 	start of the text section if DWARF2_GENERATE_TEXT_SECTION_LABEL is
	false.
	* config/mips/iris6.h (DWARF2_GENERATE_TEXT_SECTION_LABEL):
	Define to zero.

1999-07-21  Michael Meissner  <meissner@cygnus.com>

	* print-rtl.c (print_rtx): Print the names of the virtual
	registers.

Wed Jul 21 16:00:32 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.h (INITIAL_ELIMINATION_OFFSET): Fix typo
	introduced in previous delta.

Wed Jul 21 14:30:51 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* c-lang.c (finish_file): Rename void_list_node to void_list_node_1
	to avoid name clash.

Wed Jul 21 08:39:22 1999  Gavin Romig-Koch  <gavin@cygnus.com>

	* c-lex.c (yylex) : Correct the test for overflow when lexing
	integer literals.

Tue Jul 20 18:02:42 1999  Richard Henderson  <rth@cygnus.com>

	* haifa-sched.c (insn_cost): FREE implies cost 0 and vice versa.
	(adjust_priority): Always call ADJUST_PRIORITY.
	(schedule_insn): Only put insns into the ready at cost 0.
	(schedule_block): Remove redundant initial sort.  Give clock_var
	and can_issue_more to MD_SCHED_REORDER.  Requeue if hazard cost
	is not 0.
	* tm.texi (MD_SCHED_REORDER): Update docs.

	* sparc.h (MD_SCHED_REORDER): Update.  Set CAN_ISSUE_MORE.
	* sparc.c (ultra_reorder_called_this_block): Delete.
	(ultrasparc_sched_init): Don't set it.
	(ultrasparc_sched_reorder): Don't check it.

Tue Jul 20 17:07:54 1999  Richard Henderson  <rth@cygnus.com>

	* rs6000.h (struct rs6000_args): Add sysv_gregno.
	* rs6000.c (init_cumulative_args): Init sysv_gregno.
	(function_arg_boundary): Align DFmode.
	(function_arg_advance): Restructure for ABI_V4; use sysv_gregno
	to get fp reg and stack overflow correct.
	(function_arg): Likewise.
	(function_arg_pass_by_reference): True for TFmode for ABI_V4.
	(setup_incoming_varargs): Restructure for ABI_V4; use
	function_arg_advance to skip final named argument.
	(expand_builtin_saveregs): Properly unskip the last integer arg
	when doing varargs.  Adjust overflow location calculation.

	* ginclude/va-ppc.h (struct __va_list_tag): Make gpr and fpr
	explicitly unsigned.
	(__VA_FP_REGSAVE): Use new OFS argument instead of AP->fpr directly.
	(__VA_GP_REGSAVE): Similarly.
	(__va_longlong_p): Delete.
	(__va_arg_type_violation): New declaration.
	(va_arg): Restructure.  Flag promotion errors.  Align double.
	TFmode passed by reference.

	* rs6000.md (movdi_32+1): Use GEN_INT after arithmetic
	in the HOST_BITS_PER_WIDE_INT > 32 case.

Tue Jul 20 12:37:30 1999  Hans-Peter Nilsson  <hp@bitrange.com>

	* dwarf2out.c (output_abbrev_section): Terminate with a zero.

Tue Jul 20 12:12:27 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* gcc.c (default_compilers, cpp-output): Pass -fpreprocessed.
	* toplev.c (documented_lang_options): Add -fpreprocessed.
	* cpplib.h (struct cpp_buffer): Add preprocessed.
	* cppinit.c (cpp_handle_option): Handle -fpreprocessed.
	(cpp_start_read): Don't expand macros or emit an initial #line
	directive if -fpreprocessed.

Tue Jul 20 12:12:09 1999  Michael Tiemann  <tiemann@holodeck.cygnus.com>

	* cpplib.h (struct cpp_buffer): Added manual_pop for
	better C++ tokenization.
	* cpplib.c (cpp_get_token): Return CPP_EOF if manual_pop.
	Also, support C++ tokenization for ->*, .*, <?, and >? operators.
	* c-common.c (cpp_token): Make non-static.

Tue Jul 20 11:24:19 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* c-common.h: New file.
	* c-common.c (permanent_obstack): Delete unused declaration.
	(c_global_trees): New array.
	(c_common_nodes_and_builtins): New function; split off common code
	from init_decl_processing in both c-decl.c and cp/decl.c.
	* c-tree.h: Delete lots of declarations of tree nodes; replaced by
	c_global_trees and accessor macros defined in c-common.h.
	Include c-common.h.
	* c-decl.c: Delete definitions for tree nodes that were replaced by
	c_global_trees.
	(init_decl_processing): Build void_list_node.
	Call c_common_nodes_and_builtins; delete code to generate the common
	builtins here.
	* objc/objc-act.c (build_module_descriptor): Rename variable
	void_list_node to avoid clash with c-common.h.

	* Makefile.in: Update dependencies.
	* objc/Make-lang.in: Likewise.

Mon Jul 19 14:22:18 1999  Mark P. Mitchell  <mark@codesourcery.com>

	* config/mips/iris6gld.h (MAKE_DECL_ONE_ONLY): Define.
	(UNIQUE_SECTION_P): Likewise.
	(UNIQUE_SECTION): Likewise.

1999-07-19  Linas Vepstas  <linas@linas.org>

	* config/i370/README: New file.
	* config/i370/linux.h: New file.
	* config/i370/mvs.h: New file.
	* config/i370/oe.h: New file.
	* config/i370/t-linux: New file.
	* config/i370/t-mvs: New file.
	* config/i370/t-oe: New file.
	* config/i370/x-oe: New file.
	* config/i370/xm-linux.h: New file.
	* config/i370/xm-mvs.h: New file.
	* config/i370/xm-oe.h: New file.

	* i370.c (label_node_t): Add first_ref_page, label_addr,
	label_first_ref, label_last_ref members.
	(mvs_need_base_reload): Renamed from mvs_label_emitted.
	(MAX_MVS_LABEL_SIZE): Define.
	(MAX_LONG_LABEL_SIZE): Define.
	(alias_node_t, alias_anchor, alias_number): New.
	(mvs_function_table): Reorder for EBCDIC.
	(ascebc, ebcasc): Unconditionally define.
	(i370_branch_dest, i370_branch_length): New functions.
	(i370_short_branch, i370_label_scan): New functions.
	(mvs_get_label): Renamed from mvs_add_label.  Search for
	an existing label before creating a new one.
	(mvs_add_label): New function.
	(mvs_get_label_page): New function.
	(mvs_free_label_list): Renamed from mvs_free_label.  Iterate
	over the entire list.
	(mvs_check_page) [TARGET_HLASM]: Use BASR not BALR.
	(mvs_check_page) [TARGET_ELF_ABI]: New function.
	(mvs_add_alias, mvs_need_alias): New functions.
	(mvs_get_alias, mvs_check_alias): New functions.
	(handle_pragma): New function.
	(mvs_function_check): New function.
	(unsigned_jump_follows_p): Search harder.
	(i370_function_prolog) [TARGET_HLASM]: Handle LE370.  Scan labels.
	(i370_function_prolog) [TARGET_ELF_ABI]: New function.
	* i370.h (TARGET_VERSION): Delete.
	(CPP_SPEC, CPP_PREDEFINES): Delete.
	(mvs_label_emitted): Delete.
	(TARGET_EBCDIC): Delete.
	(MAP_CHARACTER): Define only if TARGET_EBCDIC.
	(HANDLE_PRAGMA): Define.
	(HARD_REGNO_NREGS): Handle complex modes.
	(HARD_REGNO_MODE_OK): Likewise.
	(CLASS_MAX_NREGS): Likewise.
	(RET_REG): Likewise.
	(EXTRA_CONSTRAINT): Define.
	(RETURN_IN_MEMORY): True for DImode.
	(TRAMPOLINE_TEMPLATE): Use gen_rtx instead of GEN_INT.
	(FUNCTION_PROFILER): Delete.
	(COUNT_REGS): Fail if REG_P but not REG_OK_FOR_BASE_P.
	(NOTICE_UPDATE_CC): Correct handling of MULT, DIV, logicals and shifts.
	(TARGET_ESC, TARGET_BELL): Conditionally define for TARGET_EBCDIC.
	(TARGET_BS, TARGET_TAB, TARGET_NEWLINE): Likewise.
	(TARGET_VT, TARGET_FF, TARGET_CR): Likewise.
	(ASM_FILE_START): Add "RMODE ANY".
	(ASM_OUTPUT_EXTERNAL): Check for aliases.
	(ASM_GLOBALIZE_LABEL): Likewise.
	(ASM_OUTPUT_LABELREF): Likewise.
	(ASM_OUTPUT_COMMON): Likewise.
	(PRINT_OPERAND): Handle 'K', 'W', default.
	(PRINT_OPERAND_ADDRESS): New.
	(Lots of defines): Add support for TARGET_ELF_ABI.
	* i370.md (attr length): New.  Define for all patterns.
	(*): Lots of tweeks to assembly output and constraints.

Mon Jul 19 15:09:29 1999  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.md (arithmetic, logical, and shift Rc combiner patterns):
	Disable patterns performing SImode comparisons with SImode values
	if TARGET_POWERPC64 and instruction does not sign-extend or does
	not mask to narrower than SImode, i.e. where bit 31 and bit 63 may
	differ for signed quantities.
	(indirect_jump): Add expander to choose RTL based on TARGET_64BIT.
	(tablejump): Patterns contingent on TARGET_64BIT not TARGET_POWERPC64.
	(decrement_and_branch_on_count): Add 64-bit variant.

Mon Jul 19 09:36:27 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* final.c (output_asm_insn): When searching for the matching string
	for a given dialect, don't run past the end of the list of
	alternatives if there are fewer alternatives in the template than
	dialects.

1999-07-17  Alexandre Oliva  <oliva@dcc.unicamp.br>

	* gcc.texi: Update e-mail addresses and URLs to gcc.gnu.org.
	Removed paragraph about compression of files and size limitation,
	duplicated in the FAQ.  Use gcc-patches for posting patches.
	* gcc.c (main): Updated URL with bug reporting instructions to
	gcc.gnu.org.  Removed e-mail address.
	* system.h (abort): Likewise.

1999-07-17  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (stmp-multilib-sub): Make the files extracted
	from $(LIBGCC1) writable.

Sat Jul 17 14:25:46 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/aout.h: Reformat for improved readability.

	* config/arm/arm.h: Reformat for improved readability.
	Replace uses of fprintf with asm_fprintf where appropriate.
	(ARM_DECLARE_FUNCTION_NAME): New macro:  Perform any generic ARM
	function declaration assembler actions.
	(NUM_INTS): New macro: Convert from bytes to words.
	(NUM_REGS): New macro: Compute number of registers required to
	hold a quanitity of tyep MODE.
	(NUM_REGS2): New macro: Like NUM_REGS but also copes with BLKmode
	types.
	(NUM_ARG_REGS): New macro: The number of argument registers
	available.
	(ARG_REGISTER): New macro: Compute the register number of the Nth
	argument register.
	(LAST_ARG_REGNUM): New macro: The number of the last argument
	register.
	(SP_REGNUM): New macro: Register number of the stack pointer.
	(FP_REGNUM): New macro: Register number of the frame pointer.
	(FUNCTION_ARG, FUNCTION_ARG_PARTIAL_NREGS, INIT_CUMULATIVE_AGS,
	FUNCTION_ARG_ADVANCE, SETUP_INCOMING_VARARGS): Change
	CUMULATIVE_ARGS so that it counts registers not bytes.

	* config/arm/arm.c: Rename TARGET_THUMB_INTERWORK to
	TARGET_INTERWORK.
	Replace uses of fprintf with asm_fprintf where appropriate.
	(output_ascii_pseudo_op): Replace with version from thumb.c

	* config/arm/coff.h (ASM_FILE_START): Emit ASM_APP_OFF.

	* config/arm/elf.h (CPP_PREDEFINES): Replace with
	SUBTARGET_CPP_SPEC.
	(ASM_DECLARE_FUNCTION_NAME): Use ARM_DECLARE_FUNCTION_NAME.
	(ASM_FILE_START): Emit ASM_APP_OFF.

Fri Jul 16 13:48:09 1999  Jeffrey A Law  (law@cygnus.com)

	* pa.c (compute_frame_size): Round frame according to
	STACK_BOUNDARY rather than a hardwired value.

	* pa.h (POINTER_SIZE, PARM_BOUNDARY): Define in terms of BITS_PER_WORD.

	* configure.in (hppa*-*-hpux11*): Use symbolic MASK_PA_11 instead
	of "1".
	* configure: Rebuilt.

	* configure.in (hppa*-*-linux*): New configuration.
	* configure: Rebuilt.
	* pa.h (MAX_OFILE_ALIGNMENT): Delete.
	* pa/som.h (MAX_OFILE_ALIGNMENT): Define.
	* pa/pa-linux.h: New file.
	* pa/t-linux: New file.
	* pa/xm-linux.h: New file.

	* pa.c (hppa_legitimize_address): Change references from SImode to
	either Pmode or word_mode as appropriate.
	(emit_move_sequence, store_reg, load_reg): Likewise.
	(set_reg_plus_d, hppa_expand_prologue): Likewise.
	(output_mul_insn): Likewise.
	* pa.h (PROMOTE_MODE): Likewise.
	(INITIALZE_TRAMPOLINE): Likewise.
	(Pmode): Define to word_mode.

	* pa.c (compute_frame_size): Use UNITS_PER_WORD instead of hardwired
	value of 4.  Allocate 8 bytes for each FP register save.
	(hppa_expand_epilogue): Use UNITS_PER_WORD instead of harwarewired
	value of 4.
	(hppa_expand_prologue): Likewise.
	* pa.h (PROMOTE_MODE): Likewise.
	(HARD_REGNO_MODE_OK, FUNCTION_ARG_SIZE): Likewise.
	(FUNCTION_ARG_BOUNDARY): Likewise.

	* invoke.texi (HPPA Options): Remove -mspace/-mno-space.

	* pa.c (out_of_line_prologue_epilogue): Delete.
	(override_options): Remove -mspace related code.
	(hppa_expand_prologue, hppa_expand_epilogue): Likewise.
	(compute_frame_size): Only allocate space for register that
	actually need to be saved.
	* pa.h (MASK_SPACE, TARGET_SPACE): Delete.
	(TARGET_SWITCHES): Remove -mspace, -mno-space
	* pa/t-pa (LIB2FUNCS_EXTRA): Remove ee.asm and ee_fp.asm
	* pa/t-pro (LIB2FUNCS_EXTRA): Likewise.  Remove -mspace multilib.
	* pa/ee.asm, pa/ee_fp.asm: Delete.

	* pa/elf.h (ASM_OUTPUT_DOUBLE_INT): Define.

	* config/svr4.h (CONST_SECTION_ASM_OP): Do not emit assembler
	directive in column zero.

Fri Jul 16 01:39:57 1999  Jeffrey A Law  (law@cygnus.com)

	* m68k.c (output_function_prologue): Fix computation of save mask
	when generating PIC code.

Thu Jul 15 15:40:09 1999  Jim Wilson  <wilson@cygnus.com>

	* tree.c (build_type_attribute_variant): Move current_obstack restore
	after build_qualified_type call.

1999-07-15  Mark Mitchell  <mark@codesourcery.com>

	* configure.in: Use t-iris6, even with GNU LD.
	* config/mips/iris6gld.h: Fix typo in linker spec.
	* config/mips/t-iris6gld: Remove.

Thu Jul 15 15:15:43 1999  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.md (insv, extzv): Remove SImode dependence in named
	patterns.  Explicitly generate DImode RTL if PowerPC64 and
	operand is DImode.
	(insvdi): Reverse start and size in instruction template.

1999-07-12  Joseph S. Myers  <jsm28@cam.ac.uk>

	* invoke.texi: Typo fixes.

Wed Jul 14 23:28:06 1999  Jeffrey A Law  (law@cygnus.com)

	* emit-rtl.c (gen_realpart): Issue an error for cases GCC can not
	handle at this time instead of silently generating incorrect code.
	(gen_imagpart): Likewise.

	* reload.c (find_reloads): Emit a USE for a pseudo register without
	a hard register if we could not create an optional reload for the
	pseudo.

Wed Jul 14 23:45:48 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* c-typeck.c (output_init_element, process_init_element):
	When advancing constructor_unfilled_fields for a RECORD_TYPE,
	check for nameless bit fields.

Wed Jul 14 01:57:39 1999  Richard Henderson  <rth@cygnus.com>

	* regclass.c (scan_one_insn): Notice subregs that change the
	size of their operand.
	(record_reg_classes): Use that to obey CLASS_CANNOT_CHANGE_SIZE.

Wed Jul 14 01:41:42 1999  Jeffrey A Law  (law@cygnus.com)

	* configure.in (alpha*-*-*): Include alpha/t-ieee.
	* configure: Rebuilt.
	* alpha/t-ieee: New file.

Tue Jul 13 10:45:58 1999  Jeffrey A Law  (law@cygnus.com)

	* rs6000.c (find_addr_reg): Do not select r0 as an address
	register.

Tue Jul 13 00:46:18 1999  Philippe De Muyter  <phdm@macqel.be>

	* m68k/x-mot3300 (XCFLAGS): List of big files now includes `cse.o'.

Mon Jul 12 14:29:15 1999  Jeffrey A Law  (law@cygnus.com)

	* rs6000.md (movsf): Do not force easy FP constants into memory.

	* expr.c (expand_expr, case PLUS_EXPR): Pass constants through
	immed_double_const to ensure they are properly truncated then
	sign extended.

Mon Jul 12 10:40:01 1999  Vladimir Makarov  <vmakarov@tofu.to.cygnus.com>

	* config/arm/thumb.c (thumb_reorg): Call replace_symbols_in_block
 	always unless NO_DEBUG is used.  Compile this code
 	unconditionally.
	(replace_symbols_in_block): Compile it unconditionally.

Sun Jul 11 12:32:32 1999  Jeffrey A Law  (law@cygnus.com)

	* configure.in (i?86-*-elf*): New target.
	* configure: Rebuilt.
	* i386/i386elf.h, i386/t-i386elf: New files.

Fri Jul  9 22:39:44 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* toplev.c (main): Don't complain about saying -gdwarf.
	(rest_of_compilation): Remove redundant code.

Fri Jul  9 19:08:55 1999  Jim Wilson  <wilson@cygnus.com>

	* unroll.c (unroll_loops): Don't delete named CODE_LABELs.

Fri Jul  9 18:54:18 1999  Felix Lee  <flee@cygnus.com>

	* config/i960/i960.c (ret_label): Change asm label from "LR:" to
	"Li960R:", to avoid name clash.

Fri Jul  9 10:48:28 1999  Bernd Schmidt  <bernds@cygnus.co.uk>

	* loop.c (check_dbra_loop): When reversing a loop, delete all
	REG_EQUAL notes referencing the reversed biv except those which are
	for a giv based on it.

Fri Jul  9 03:51:52 1999  Jeffrey A Law  (law@cygnus.com)

	* version.c: Drop "gcc-" prefix from version #.

Thu Jul  8 18:06:30 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* dwarf2out.c (dwarf2out_line): Emit a line number comment after
	the label if we're being verbose.

Thu Jul  8 14:18:46 1999  Richard Henderson  <rth@cygnus.com>

	* m68k.c (output_function_prologue): Add pic register to mask
	if live and flag_pic.
	(output_function_epilogue): Likewise.

Thu Jul  8 12:55:12 1999  Jeffrey A Law  (law@cygnus.com)

	* dbxelf.h (ASM_OUTPUT_SOURCE_LINE): Do not put assembler
	directives in column zero.

	* pa/elf.h (ASM_FILE_START): Define.
	* pa/som.h (ASM_FILE_START): Include .level directives.
	* pa/hpux10.h (ASM_FILE_START): Delete.
	* pa/hpux11.h (ASM_FILE_START): Delete.

	* pa/elf.h (BSS_SECTION_ASM_OP): Use .section .bss.

Thu Jul  8 18:03:19 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload1.c (choose_reload_regs): Never call remove_adress_replacements
	when reload_out equals reload_in.

Thu Jul  8 16:50:14 1999  Nick Clifton  <nickc@cygnus.com>

	* invoke.texi (Spec Files): New node: Describe the contents of
	spec files.

Thu Jul  8 10:28:25 1999  Craig Burley  <craig@jcb-sc.com>

	* invoke.texi (DEC Alpha Options): Put @end table at
	beginning of line, to avoid confusing texi2html.

Thu Jul  8 09:22:06 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/elf.h (ASM_OUTPUT_INTERNAL_LABEL): Fixed typo
	introduced in previous delta.

Wed Jul  7 02:00:04 1999  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* reload1.c (gen_reload): When synthesizing a 3 operand add
	sequence, improve test for when to reload OP1 into the reload
	register instead of OP0.

Wed Jul  7 01:38:03 1999  Jim Wilson  <wilson@cygnus.com>

	* unroll.c (unroll_loop): Don't delete NOTE_INSN_DELETED_LABEL notes.

1999-07-07  Manfred Hollstein  <mhollstein@cygnus.com>

	* m88k/dguxbcs.h (CPP_SPEC): Add missing \ in multi-line
	string literal.

Wed Jul  7 01:16:43 1999  Richard Henderson  <rth@cygnus.com>

	* ginclude/varargs.h (__builtin_va_alist_t): New typedef.
	(va_dcl): Use __builtin_va_alist_t.

Wed Jul  7 01:14:42 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* dwarf2out.c (gen_struct_or_union_type_die): Only remember types
	on the permanent_obstack.
	* dwarfout.c (output_type): Likewise.

Tue Jul  6 15:25:32 1999  Gavin Romig-Koch  <gavin@cygnus.com>

	* c-common.c (unsigned_type,signed_type,signed_or_unsigned_type) :
	Merged from c-typeck.c and cp/typeck.c.
	* c-typeck.c (unsigned_type,signed_type,signed_or_unsigned_type) :
	Merged into c-common.

Tue Jul  6 13:06:01 1999  Dave Brolley  <brolley@cygnus.com>

	* c-lex.c (errorcount): Declare it.
	(finish_parse): Update errorcount when using CPPLIB.

1999-07-06  Bruce Korb  <ddsinc09@ix.netcom.com>

	* fixinc/inclhack.def(end_else_label): Double the backslash so
	sed gets a chance to see it.
	* fixinc/inclhack.sh: regen
	* fixinc/fixincl.x: regen

Fri Jul  2 18:49:51 1999  Nick Clifton  <nickc@cygnus.com>

	Add framework to support armv5 architecture when it becomes
	available:

	* config/arm/arm.c (FL_ARCH5): New processor capability flag.
	(arm_arch5): New variable.
	(all_architectures): Add armv5 line.
	* config/arm/arm.h (CPP_CPU_ARCH_SPEC): Define __ARM_ARCH_5__ if
	-march=armv5 is specified on the command line.
	(arm_arch5): Export this variable.
	* invoke.texi: Document new string accepted by -march= switch for
	ARM ports.

	* config/arm/arm.h: Replace use of constant 12 as a register
	number with IP_REGNUM.  Similarly 14 and LR_REGNUM.
	* config/arm/arm.c: Replace use of constant 12 as a register
	number with IP_REGNUM.  Similarly 14 and LR_REGNUM.

	* config/arm/elf.h: Tidy up.
	* config/arm/coff.h: Tidy up.

Thu Jul  1 19:08:13 1999  Mark P. Mitchell  <mark@codesourcery.com>

	* gcc/configure.in (mips-sgi-irix6*): Handle --with-gnu-ld.
	* gcc/config/mips/t-iris6gld: New file.
	* gcc/config/mips/iris6gld.h: Likewise.

Fri Jul  2 13:23:39 1999  Gavin Romig-Koch  <gavin@cygnus.com>

	* c-decl.c (widest_integer_literal_type_node,
	widest_unsigned_literal_type) : New.
	(init_decl_processing): Handle/use the two new types.
	* c-common.c (type_for_size,type_for_mode) : Same.
	* c-lex.c (yylex) : Same.
	* c-typeck.c (unsigned_type,signed_type,signed_or_unsigned_type) :
	Same.
	* c-tree.h (widest_integer_literal_type_node,
	widest_unsigned_literal_type) : New.

Fri Jul  2 03:05:44 1999  Jeffrey A Law  (law@cygnus.com)

	* dwarfout.c (field_byte_offset): Correctly compute the object's
	byte offset for the first bit of a field which crosses an alignment
	boundary on a !BYTES_BIG_ENDIAN target.

Fri Jul  2 01:36:36 1999  Robert Lipe  <robertlipe@usa.net>

	* fixinc.svr4: Fix <arpa/inet.h> by deleting protos for htons and
	ntohs.

Fri Jul  2 00:46:47 1999  Richard Henderson  <rth@cygnus.com>
	                  Jeff Law <law@cygnus.com>

	* ginclude/varargs.h (va_dcl): Use word_mode for type of
	__builtin_va_list.

	* except.c: Include intl.h.
	(expand_eh_return): Set current_function_cannot_inline.
	(save_eh_status, restore_eh_status): Twiddle eh_return_stub_label.
	* function.h (struct function): Add eh_return_stub_label.
	* flow.c (delete_unreachable_blocks): Don't merge across EH edges.
	* Makefile.in (except.o): Depend on intl.h.

Fri Jul  2 00:04:23 1999  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.md (movdf_hardfloat32): Handle PRE_INC and PRE_DEC the
	same as offsettable in cases 1 and 2.

Thu Jul  1 20:54:10 1999  Richard Henderson  <rth@cygnus.com>

	* alpha.md (extqh): Define as 64-((R&7)*8) instead of 56-(((R-1)&7)*8).
	(extlh, extwh): Likewise.

Thu Jul  1 11:05:25 1999  Gavin Romig-Koch  <gavin@cygnus.com>

	* c-lex.c (yylex): Improve 'integer constant out of range' messages.

Wed Jun 30 16:51:41 1999  Nick Clifton  <nickc@cygnus.com>

	* configure.in: Add arm-pe and thumb-pe targets.
	* configure: Regenerate.

	* thumb.c (arm_naked_function_p): New function: Determines if
	a function is naked (has no gcc generated prologue/epilogue).
	(is_called_in_ARM_mode): Return true if the func has the
	interfacearm attribute.
	(output_return): Do not generate a return for naked functions.
	(thumb_function_prologue): Do not generate a prologue for
	naked functions.
	(thumb_expand_prologue): Do not generate a prologue for naked
	functions.
	(thumb_expand_epilogue): Do not generate an epilogue for naked
	functions.
	(arm_valid_machine_decl_attribute): New function, copied from
	arm.c:  Permit naked and interfacearm attributes.

	* config/arm/pe.c: New file: Support code for arm-pe target.
	* config/arm/pe.h: New file: Header file for arm-pe target.
	* config/arm/tpe.h: New file: Header file for thumb-pe target.
	* config/arm/t-thumb-pe: New file: Makefile fragment for
	thumb-pe target.

1999-07-01  Mark Kettenis  <kettenis@gnu.org>

	* config/i386/gnu.h (CPP_SPEC): Define __PIC__ and __pic__ if
	-fPIC or -fpic is specified.

Wed Jun 30 03:31:54 1999  Jeffrey A Law  (law@cygnus.com)

	* expr.c (emit_block_move): Use copy_to_mode_reg for
	!TARGET_MEM_FUNCTIONS case too.

	* configure.in (hppa*-*-*): Add som.h or elf.h to tm_file as
	appropriate.
	* configure: Rebuilt.
	(hppa1.1-*-pro*, hppa1.1-*-rtems*): Define target_cpu_default.
	* pa.h: Include dbxelf.h.  Delete various dbx/stabs related
	definitions made redundant by dbxelf.h inclusion.  Delete
	lots of definitions related to assembly output that are
	specific to the SOM object format.
	* pa.c (output_function_prologue): Do not emit the function's
	name for OBJ_ELF.
	* pa-pro-end.h (STARTFILE_SPEC): Undefine before redefining.
	* pa-pro.h: Deleted.
	* som.h: New file with SOM specific definitions.
	* elf.h: New file with ELF specific definitions.

	* elfos.h (const_section): Output a tab before assembler directives.
	(ctors_section, dtors_section): Likewise.
	(ASM_OUTPUT_SECTION_NAME): Likewise.

	* pa/pa1.h: Delete unused file.

Tue Jun 29 01:37:53 1999  Jeffrey A Law  (law@cygnus.com)

	* configure.in (hppa*-hp-hpux11*): New configuration.
	* configure: Rebuilt.
	* pa/pa-hpux11.h: New file.
	* pa.h (CPP_SPEC): Conditionally add -D__STDC_EXT__ to the cpp
	command line.

	* mips.md (leasi, leadi): New patterns.

	* expr.c (emit_block_move): Properly handle case where one of the
	block move arguments has a queued increment or decrement.
	(clear_storage): Similarly.  Fix formatting goof.

1999-06-28  "David O'Brien"  <obrien@NUXI.com>

	* fixinc/inclhack.def(stdio_va_list): This patch Removes a
	semicolon from the BSD VA_LIST replacement expression.

	* fixinc/inclhack.sh: regen
	* fixinc/fixincl.x: regen

	* fixinc/mkfixinc.sh: Have `i[34567]86-*-freebsd*' machines
	now use the fixincl program.

Mon Jun 28 05:28:12 1999  Jeffrey A Law  (law@cygnus.com)

	* m68k.h (CONDITIONAL_REGISTER_USAGE): Define for !SUN_FPA
	case.  Also make the PIC register call_used.

	* m68k.h (FINALIZE_PIC): Delete.
	* m68k.c (finalize_pic): Delete.

Mon Jun 28 05:16:35 1999  Richard Henderson  <rth@cygnus.com>

	* m68k.h (PREFERRED_RELOAD_CLASS): Don't force any FP const_doubles
	to memory.

Mon Jun 28 04:07:27 1999  David Edelsohn  <edelsohn@gnu.org>

	* expmed.c (expand_divmod): Ensure unsigned value fits in reg_note.

Sun Jun 27 02:39:08 1999  Richard Henderson  <rth@cygnus.com>

	* jump.c (jump_optimize_1): Validate the cmov copy to a temporary.

Sat Jun 26 17:18:18 1999  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.c (print_operand, case 'L'): Use plus_constant_for_output.

Fri Jun 25 11:33:24 1999  Richard Henderson  <rth@cygnus.com>

	* alpha.c (override_options): Add -mcpu=ev45 as an alias for ev4.

Fri Jun 25 13:41:25 1999  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.c (output_toc): Always use hex values for floating-point
	constants.  Store single-precision values in upper-half of TOC
	entry in 64-bit mode.
	* rs6000.md (floatsidf2, floatunssidf2): Add !TARGET_POWERPC64
	to final constraints.
	(fix_truncdfsi2 splitter): Change pattern matching fctiwz.
	(fctiwz): Improve accuracy of RTL for pattern.

Fri Jun 25 11:26:38 1999  Gavin Romig-Koch  <gavin@cygnus.com>

	* expr.c (expand_expr): Allow RTL_EXPR's through the
	MAX_INTEGER_COMPUTATION_MODE checks.

Fri Jun 25 06:06:37 1999  Richard Henderson  <rth@cygnus.com>

	* alpha.h (MASK_SUPPORT_ARCH, MASK_CPU_EV5, MASK_CPU_EV6): Define
	such that MASK_SUPPORT_ARCH is not negative.

Fri Jun 25 05:35:44 1999  Jeffrey A Law  (law@cygnus.com)

	* loop.c (verify_dominator): Properly handle ADDR_VEC and
	ADDR_DIFF_VEC insns that appear inside loops.

Thu Jun 24 22:54:05 1999  David Edelsohn  <edelsohn@gnu.org>
			  Jeff Law <law@cygnus.com>

	* rs6000.md (movdf_hardfloat32): Revert previous patch.
	Handle LO_SUM the same as offsettable in cases 1 and 2.
	* rs6000.c (find_addr_reg): Revert previous patch.

Thu Jun 24 22:43:12 1999  Philippe De Muyter  <phdm@macqel.be>

	* system.h (strstr): New external function declaration.
	* acconfig.h (NEED_DECLARATION_STRSTR): New define slot.
	* configure.in (GCC_NEED_DECLARATIONS): Check for strstr.
	* config.in, configure: Rebuilt.

1999-06-24  Tom Tromey  <tromey@cygnus.com>

	* gcc.c (main): Read user-specified specs files after computing
	additional startfile_prefixes.

Thu Jun 24 15:00:47 1999  Mark Mitchell  <mark@codesourcery.com>

	Revert these two patches:

	Thu Jun 17 21:34:24 1999  J"orn Rennecke <amylaar@cygnus.co.uk>
	* loop.c (strength_reduce): When doing biv->giv conversion, update
	reg note of NEXT->insn.

	Thu Jun 17 17:22:07 1999  J"orn Rennecke <amylaar@cygnus.co.uk>
	* loop.c (strength_reduce): When doing biv->giv conversion, fix up
	reg_biv_class.
	(recombine_givs): Set ix field after sorting.

Wed Jun 23 21:26:00 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* rtlanal.c (reg_referenced_p): Use reg_overlap_mentioned_p
	for the parts of an UNSPEC / UNSPEC_VOLATILE.

1999-06-23  Bruce Korb  <ddsinc09@ix.netcom.com>

	*fixinc/inclhack.def:  Add fix development commentary
	(read_ret_type): reactivate and add selection clause
	(zzz_*): tweak output file name to match what is used in hackshell.tpl
	*fixinc/{fixincl.x|inclhack.sh}: regen

Wed Jun 23 00:48:21 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* expr.c (expand_expr): STRIP_NOPS before checking against
	MAX_INTEGER_COMPUTATION_MODE
	(check_max_integer_computation_mode): Likewise.

Tue Jun 22 20:23:43 1999  Jim Wilson  <wilson@cygnus.com>

	* md.texi (smul@var{m}3_highpart): Add missing 's' prefix.

1999-06-22  Jim Wilson  <wilson@cygnus.com>

	* expr.c (store_expr): When target is a promoted subreg, return a
	promoted subreg as a result.

Tue Jun 22 17:14:58 1999  Michael Meissner  <meissner@cygnus.com>

	* dwarf2out.c (dwarf2out_frame_debug_expr): Reformat to match GNU
	coding standards.
	(dwarf2out_define): Mark unused parameters appropriately.
	(gen_unspecified_parameters_die): Ditto.
	(gen_subprogram_die): Fix signed/unsigned warnings.
	(gen_variable_die): Ditto.

1999-06-22  Bruce Korb <ddsinc09@ix.netcom.com>

	* fixinc/inclhack.def(end_else_label): combined else_label
	and endif_label and fixed the sed expression.
	*fixinc/{fixincl.x|inclhack.sh}: regen

Tue Jun 22 01:58:18 1999  Jeffrey A Law  (law@cygnus.com)

	* rs6000.md (movdf_hardfloat32): Use %X instead of always emitting
	'x' when handling non-offsettable addresses

Tue Jun 22 00:20:05 1999  Richard Earnshaw (rearnsha@arm.com)

	* final.c (shorten_branches): Don't try to split an insn that has
	been deleted.

Mon Jun 21 12:47:39 1999  Mark Mitchell  <mark@codesourcery.com>

	* config/mips/mips.c (symbolic_expression_p): New function.
	(mips_select_rtx_section): Put symbolic expressions in the
	data section, not the read-only data section.

Mon Jun 21 22:13:06 1999  Jeffrey A Law  (law@cygnus.com)

	* rs6000.md (find_addr_reg): Handle LO_SUM addresses.

Mon Jun 21 20:10:42 1999  Richard Henderson  <rth@cygnus.com>

	* collect2.c (main): Log frame table count.
	(GCC_OK_SYMBOL) [ECOFF]: Accept stGlobal.
	(scan_prog_file) [COFF]: Handle frame tables.

	* alpha/alpha.h (UNALIGNED_SHORT_ASM_OP): Define.
	(UNALIGNED_INT_ASM_OP, UNALIGNED_DOUBLE_INT_ASM_OP): Define.
	* alpha/elf.h: Undef them again.
	* alpha/vms.h: Remove their definitions.

Tue Jun 22 03:17:53 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.c (machine_dependent_reorg): When fixing up fp pcloads,
	remove the clobber of r0 and change the REG_UNUSED note to
	REG_INC.

1999-06-21  Jakub Jelinek  <jj@ultra.linux.cz>

	* real.c (ereal_from_double): Fix for 64-bit big endian hosts.
	* emit-rtl.c (gen_lowpart_common): Add case for hosts where double
	fits in HOST_WIDE_INT and one uses union to access a long constant
	as double.

Mon Jun 21 17:18:25 1999  Richard Henderson  <rth@cygnus.com>

	* sparc.c (sparc_override_options): Don't allow profiling for
	code models other than medlow.
	(sparc_function_profiler): New function from old FUNCTION_PROFILER
	macro.  Use ASM_GENERATE_INTERNAL_LABEL and MCOUNT_FUNCTION.
	(sparc_function_block_profiler): Likewise.  Use user_label_prefix.
	(sparc_block_profiler): Likewise.
	(sparc_function_block_profiler_exit): Likewise.
	* sparc.h (FUNCTION_PROFILER): Call new sparc.c function.
	(FUNCTION_BLOCK_PROFILER): Likewise.
	(BLOCK_PROFILER): Likewise.
	(FUNCTION_BLOCK_PROFILER_EXIT): Likewise.
	(MCOUNT_FUNCTION): New.
	* sparc/pbd.h (FUNCTION_PROFILER): Delete.
	(FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER): Delete.
	* sparc/sun4o3.h (FUNCTION_PROFILER): Delete.
	(MCOUNT_FUNCTION): New.
	* sparc/sysv4.h (FUNCTION_BLOCK_PROFILER): Delete.
	(BLOCK_PROFILER): Delete.
	(MCOUNT_FUNCTION): New.

Mon Jun 21 14:11:29 1999  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.md (movdf_hardfloat32): Fix typo in case 2.

Mon Jun 21 12:27:17 1999  Vladimir Makarov  <vmakarov@tofu.to.cygnus.com>

	* config/mips/elf.h (BSS_SECTION_ASM_OP, ASM_OUTPUT_ALIGNED_BSS):
	Add the macros.

	* config/m68k/m68kelf.h (BSS_SECTION_ASM_OP, ASM_OUTPUT_ALIGNED_BSS):
	Ditto.

	* config/sh/sh.h (BSS_SECTION_ASM_OP, ASM_OUTPUT_ALIGNED_BSS):
	Ditto.

	* config/arm/telf.h (BSS_SECTION_ASM_OP, ASM_OUTPUT_ALIGNED_BSS):
	Ditto.

Mon Jun 21 14:58:42 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.h: Add cpp support for ARM920 and ARM920T cpu
	types.

Mon Jun 21 06:22:21 1999  Mark Elbrecht <snowball3@bigfoot.com>

	* i386/djgpp.h (LIB_SPEC): New.
	(STARTFILE_SPEC): New.

	* i386/xm-djgpp.h (NO_SYS_SIGLIST): Deleted. Now obsolete.

Mon Jun 21 06:19:33 1999  Philippe De Muyter  <phdm@macqel.be>

	* fixinc/Makefile.in (gnu-regex.o): Do not define STDC_HEADERS in
	compiler flags.

	* system.h (WSTOPSIG): New macro.

Mon Jun 21 05:33:15 1999  Mumit Khan  <khan@xraylith.wisc.edu>

	* c-pragma.c (push_alignment): Don't ignore alignments greater than
	4 bytes.
	(insert_pack_attributes): Take into account member natural
	alignment.

	* i386/winnt.c (exports_head): New static variable.
	(i386_pe_record_exported_symbol): New function.
	(i386_pe_asm_file_end): Use.
	* i386/cygwin.h (ASM_OUTPUT_COMMON): Record the exported
	symbols to be emitted at end of assembly.
	(ASM_DECLARE_OBJECT_NAME): Likewise.
	(ASM_DECLARE_FUNCTION_NAME): Likewise.

	* i386/uwin.h (CPP_SPEC): Use -idirafter instead -iprefix and
	-iwithprefix.

Mon Jun 21 04:44:31 1999  Jeffrey A Law  (law@cygnus.com)

	* sparc.h (LEGITIMIZE_RELOAD_ADDRESS): Fix paren error introduced
	in last change.

Sun Jun 20 17:27:20 1999  Richard Henderson  <rth@cygnus.com>

	* haifa-sched.c (sched_analyze_1): Use free_list instead of
	zapping reg_last_uses directly.
	(sched_analyze_2, sched_analyze_insn): Likewise.
	(sched_analyze): Likewise.  Don't clear reg_last_uses on calls.

Sun Jun 20 16:57:29 1999  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.md (movdf_hardfloat32): Use worst case insn length
	attributes for cases 1 and 2.

Sat Jun 19 22:52:55 1999  Richard Henderson  <rth@cygnus.com>

	* haifa-sched.c (sched_analyze): Mark call-user regs as clobbered
	instead of set.

Sat Jun 19 05:40:07 1999  Philip Blundell <pb@nexus.co.uk>

	* arm.c (arm_reload_in_hi): Invert sense of test on BYTES_BIG_ENDIAN.

Sat Jun 19 05:25:05 1999  Richard Earnshaw (rearnsha@arm.com)

	* arm.h (CONDITIONAL_REGISTER_USAGE): If flag_pic, never use
	PIC_OFFSET_TABLE_REGNUM for general alloaction.
	(INITIAL_ELIMINATION_OFFSET): Count the fact that the PIC register
	must be stacked if it is used for PIC accesses.
	* arm.c (use_return_insn): Handle PIC register specially.
	(output_return_instruction): Likewise.
	(output_func_{prologue,epilogue}): Likewise.
	(output_expand_prologue): Likewise.

	* arm.md (*adddf_esfdf_df): Renamed from *adddf_df_esfdf.
	(*strsi_predec): Renamed from *strqi_predec.
	(*loadsi_shiftpreinc): Renamed from *loadqi_shiftpreinc.
	(*loadsi_shiftpredec): Renamed from *loadqi_shiftpredec.

	* arm.c (arm_override_options): Remove warning about PIC code
	not being supported.

Fri Jun 18 23:47:06 1999  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.c (find_addr_reg): New function.
	* rs6000.h (find_addr_reg): Declare.
	(offsettable_addr_operand): Delete.
	* rs6000.md (movdf_hardfloat32): Handle non-offsettable loads
	from and stores to GPRs.

Fri Jun 18 15:44:18 1999  Richard Henderson  <rth@cygnus.com>

	* alpha.c (alpha_expand_block_move): Use get_insns rather than
	gen_sequence as argument to emit_no_conflict_block.

Fri Jun 18 07:02 1999  Bruce Korb <ddsinc09@ix.netcom.com>

	* fixinc/mkfixinc.sh: enable the fixincl program for DG/UX
	* fixinc/inclhack.def(dgux_int_varargs): script must end with \n
	*fixinc/fixincl.x: regen
	*fixinc/inclhack.sh: regen

Thu Jun 17 15:06:10 PDT 1999 Don Lindsay  <dlindsay@cygnus.com>

	* added support for -mpcrel (PC relative addressing for m68k)
	based on code done by Michael Tiemann  <tiemann@axon.cygnus.com>.
	* invoke.texi (m68000 options): Add documentation for -mpcrel flag.
	* m68k.c (print_operand_address): Handle 32-bit PIC case.
	(comments for general_src_operand): Add some explanation
	about EXTRA_CONSTRAINTS.
	(OVERRIDE_OPTIONS): Enable -fPIC in combination with -mpcrel.
	* m68kelf.h (OVERRIDE_OPTIONS): Ditto.
	(LEGITIMATE_PIC_OPERAND_P): Fix typo.
	(LEGITIMATE_PIC_OPERAND_P): Re-derive from m68k.h case.
	* m68k.h (LEGITIMATE_PIC_OPERAND_P): Fix delete-o.
	(INDIRECTABLE_1_ADDRESS): Delete spurious '/' at end of macro.
	(OVERRIDE_OPTIONS): Change behavior so that -mpcrel implies -fpic
	if not already set.
	(OVERRIDE_OPTIONS): Merge in changes from m68k.h.
	* m68k.h (TARGET_PCREL): New target flag.
	(TARGET_SWITCHES): Add "pcrel" as a recognized switch.
	(OVERRIDE_OPTIONS): Add checks for -mpcrel.
	(LEGITIMATE_PIC_OPERAND_P): Don't normally accept anything that
	contains a SYMBOL_REF.  Relax this constraint during reload, since
	we want to use the predicates, not reload's built-in concept of a
	valid memory address, to control what insns need reloading.
	(EXTRA_CONSTRAINT): Define constraints to accept pc-relative
	operands (essentially 'g', 'm', and 's' under normal circumstances).
	* m68k.c (print_operand): Cause printing of pc-relative addresses
 	to include pc register.
	(print_operand_address): Ditto.
	(general_src_operand): Accept operands that are not only
	general_operands, but are also valid when used as a pc-relative
	source.
	(nonimmediate_src_operand): Similar, for nonimmediate_operands.
	(memory_src_operand): Similar, for memory_operands.
	(pcrel_address): New predicate to accept the special case of a
	pc-relative address.
	* m68k.md (many patterns): Rewrite common SImode, HImode, and
	QImode insns to accept *_src_operand instead of *_operand where
	pc-relative operands can fit.  For example, a pc-relative operand
	can be used as a memory source operand for addsi3, but not as a
	memory destination.
	* hp320.h linux.h m68kv4.h (LEGITIMATE_PIC_OPERAND_P) as in m68k.h.

Fri Jun 18 09:11:07 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/telf.h (ASM_OUTPUT_DEF_FROM_DECLS): New Marco: USe
	.thumb_set pseudo op to mark aliases of thumb functions.

Wed Jun 16 18:19:13 1999  Nick Clifton  <nickc@cygnus.com>

	* varasm.c (assemble_alias): Use ASM_OUTPUT_DEF_FROM_DECLS in
	preference to ASM_OUTPUT_DEF, if it is defined.

	* tm.texi: Document new, optional target macro
	ASM_OUTPUT_DEF_FROM_DECLS.

Thu Jun 17 15:07 1999  Bruce Korb <ddsinc09@ix.netcom.com>

	* fixincludes: ISCNTL patch
	* fixinc/inclhack.def (ioctl_fix_ctrl): Fix the definition of [_]*ISCTRL().
	(dgux_int_varargs): new for DG/UX
	* fixinc/{fixincl.x,inclhack.sh}: Regenerated.

Thu Jun 17 21:34:24 1999  Jeff Law <law@cygnus.com>

	* invoke.texi (ia32 options): Fix typo.

Thu Jun 17 21:34:24 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* loop.c (strength_reduce): When doing biv->giv conversion, update
	reg note of NEXT->insn.

Thu Jun 17 14:25:08 1999  Jeffrey A Law  (law@cygnus.com)

	* loop.c (move_movables): Note issues with replacing REGs with
	SUBREGs.
	* mips.h (GO_IF_LEGITIMATE_ADDRESS): Handle SUBREGs properly.

Thu Jun 17 13:28:30 1999  David O'Brien <obrien@FreeBSD.org>

	* i386/freebsd-elf.h (LINK_SPEC): Fix typo.

	* i386/freebsd-elf.h (FUNCTION_PROFILER): labels are not needed and
	the reference to `mcount' was not correct for the ELF on FreeBSD.

Thu Jun 17 17:22:07 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* loop.c (strength_reduce): When doing biv->giv conversion, fix up
	reg_biv_class.

	(recombine_givs): Set ix field after sorting.

Thu Jun 17 02:54:30 1999  Jeffrey A Law  (law@cygnus.com)

	* emit-rtl.c (operand_subword): Tighten checks for when it is safe
	to safe to extract a subword out of a REG.

Thu Jun 17 01:45:24 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.md (mulsi3): Don't add a no-op move at the end.

Wed Jun 16 20:29:00 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* cse.c (cse_insn): Don't put hard register source into tables for
	the last insn of a libcall.

Wed Jun 16 19:44:33 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* loop.c (strength_reduce): Insert sets of derived givs at every
	biv increment, even if it's the only one.

Wed Jun 16 10:33:02 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* dwarfout.c (add_incomplete_type): New fn.
	(output_type): Call it.
	(retry_incomplete_types): New fn.
	(dwarfout_finish): Call it.

	From Eric Raskin <ehr@listworks.com>:
	(output_type): Output types for bases.

Tue Jun 15 12:51:23 1999  Alexandre Oliva  <oliva@dcc.unicamp.br>

	* mips.c (mips_output_conditional_branch): Add `break'
	between `default' label and `close braces'.

Tue Jun 15 01:55:20 1999  David O'Brien <obrien@FreeBSD.org>

	* i386/freebsd-elf.h (LINK_SPEC): clean up the linking library
	specifications and make it realistic.
	(LIB_SPEC): Likewise.

Mon Jun 14 15:38:43 1999  Jim Wilson  <wilson@cygnus.com>

	* config/mips/mips.c (mips_secondary_reload_class): Check for
	(PLUS (SP) (REG)) and return appropriate register class.
	* config/mips/mips.md (reload_insi): Delete predicate for operand 1.
	Handle (PLUS (SP) (REG)).
	(tablejump): In mips16 code, use emit_insn instead of emit_jump_insn.
	(tablejump_mips161, tablejump_mips162): Use emit_jump_insn instead
	of emit_insn for tablejump.

Mon Jun 14 17:26:40 1999  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.c (output_prolog): RS6000_CALL_GLUE must be
	asm_fprintf format string by itself.
	(output_function_profiler): Likewise.

Mon Jun 14 12:57:38 1999  David Mosberger  <davidm@hpl.hp.com>

	* combine.c (simplify_logical, case AND): Only call
	simplify_and_const_int if the mode is no wider than HOST_WIDE_INT
	or the constant is positive.

Mon Jun 14 11:43:41 1999  Nick Clifton  <nickc@cygnus.com>

	* configure.in: Fix typo in rs6000-ibm-aix4 case.
	* configure: Regenerate.

Mon Jun 14 03:55:40 1999  Jeffrey A Law  (law@cygnus.com)

	* configure.in (rs6000-ibm-aix4.3*, powerpc-ibm-aix4.3*): Do not
	require a sub-version #.
	* configure: Rebuilt.

1999-06-14  Robert Lipe  (robertlipe@usa.net)

	* svr4.h (DWARF2_DEBUGGING_INFO): Check for redefinition.

Mon Jun 14 10:30:52 BST 1999  Nathan Sidwell  <nathan@acm.org>

	* c-typeck.c (process_init_element): Detect excess elements in
	char array initializer.

1999-06-14  Andreas Jaeger  <aj@arthur.rhein-neckar.de>

	* gcc.texi: Mention gcc 2.96 instead of egcs 1.00.

Sat Jun 12 22:29:48 EDT 1999  Jerry Quinn <jquinn@nortelnetworks.com>

	* invoke.texi (Option Summary): Add -fpermissive flag.

Sat Jun 12 03:40:42 1999  Jeffrey A Law  (law@cygnus.com)

	* sparc.h (LEGITIMIZE_RELOAD_ADDRESS): Do nothing with operands
	that require PIC code sequences.

Wed Jun  9 16:29:01 1999  Nick Clifton  <nickc@cygnus.com>

	* configure.in: Add new target: thumb-elf.
	* configure: Regenerate.
	* config/arm/t-thumb-elf: New file: Makefile fragment for
	thumb-elf build.
	* config/arm/telf.h: New file: Header file for thumb-elf
	build.

Fri Jun 11 03:17:51 1999  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (libgcc2): Pass MAYBE_USE_COLLECT2 as an argument.
	* libgcc2.c (__CTOR_LIST, __DTOR_LIST); Do not provide
	initializers is some circumstances.

	* fixinc/inclhack.def (endif_label): Add additional selector for
	more bogus stuff after #endif statements.
	* fixinc/inclhack.sh, fixinc/fixincl.x: Rebuilt.

Thu Jun 10 20:44:36 1999  Mumit Khan  <khan@xraylith.wisc.edu>

	* i386/cygwin.h (SET_ASM_OP): Define.

Thu Jun 10 20:37:57 1999  Mumit Khan  <khan@xraylith.wisc.edu>

	* reg-stack.c (stack_reg_life_analysis): Find all the RETURN insns.

Thu Jun 10 19:23:00 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.h (TARGET_HARWARD, TARGET_HARVARD): Changed the former to the
	latter.

	* sh.md (ic_invalidate_line_i): Remove second alternative.

Thu Jun 10 06:55 1999  Bruce Korb <ddsinc09@ix.netcom.com>

	*fixinc/inclhack.def(sun_auth_proto): We do not know how to
	test for the presence of valid prototypes.  Delete bypass expr.
	(ioctl_fix_ctrl): Correct the selection expression.
	(no_double_slash): Correct quoting rules
	*fixinc/fixincl.x: regen
	*fixinc/inclhack.sh: regen

Thu Jun 10 15:08:15 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.c (struct all_cores): Add ARM920 and ARM920t.

Wed Jun  9 15:57:57 1999  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* rs6000.md (movsi_got_internal_mem): Delete.
	* rs6000.h (CONDITIONAL_REGISTER_USAGE): Mark PIC_OFFSET_TABLE_REGNUM.
	(GOT_TOC_REGNUM): Delete.
	(PIC_OFFSET_TABLE_REGNUM): Define.
	(FINALIZE_PIC): Disable.
	* rs6000.c (rs6000_got_register): New code for fixed pic register.
	(rs6000_replace_regno): Delete.
	(rs6000_finalize_pic): Likewise.
	(output_prolog): Handle PIC_OFFSET_TABLE_REGNUM.

Wed Jun  9 19:44:26 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* loop.c (loop_insn_first_p): Don't compare LUIDs when P
	is a note; use <= for the compare; advance P while it is
	a NOTE.

Wed Jun  9 13:12:24 1999  Jeffrey A Law  (law@cygnus.com)

	* fixinc/inclhack.def (no_double_slash): Fix quoting for test.
	* fixinc/inclhack.sh, fixinc/fixincl.x, fixinc/fixincl.sh; Rebuilt.

	* varasm.c (remove_from_pending_weak_list): Verify t->name
	is non-NULL before passing it to strcmp.

Wed Jun  9 06:50 1999  Bruce Korb <ddsinc09@ix.netcom.com>

	*fixinc/inclhack.def(sun_auth_proto): bypass the patch if
	the typed arguments are not part of a comment
	(ioctl_fix_ctrl): Added a purpose comment
	*fixinc/fixincl.x: regenerate
	*fixinc/inclhack.sh: regenerate

Wed Jun  9 22:57:02 1999  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* invoke.texi: Add C4x invocation docs.

Wed Jun  9 22:34:38 1999  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* config/c4x/c4x.h (TARGET_EXPOSE_LDP, LEGITIMIZE_RELOAD_ADDRESS):
	Define new macros.
	* config/c4x/c4x.c (c4x_emit_move_sequence, src_operand): Use
	TARGET_EXPOSE_LDP.
	(c4x_legitimize_reload_address): New function.
	* config/c4x/c4x.md: Update docs.

Wed Jun  9 04:14:48 1999  Jeffrey A Law  (law@cygnus.com)

	* fixincludes: Avoid removing '.'.
	* fixinc/fixinc.svr4: Likewise.
	* fixinc/fixinc.winnt: Likewise.
	* fixinc/inclhack.tpl: Likewise.
	* fixinc/fixincl.sh, fixinc/inclhack.sh: Rebuilt.

1999-06-09  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* fixinc/inclhack.def (sun_catmacro): Escape parens in the select
	pattern.
	* fixinc/fixincl.x, fixinc/inclhack.sh: Rebuilt.

Wed Jun  9 03:10:34 1999  Mumit Khan  <khan@xraylith.wisc.edu>

	* c-pragma.c (handle_pragma_token): Handle `#pragma pack()'
	correctly.

Tue Jun  8 13:06:15 1999  Jim Wilson  <wilson@cygnus.com>

	* configure.in (rs6000-ibm-aix4.[12]*): Change rx6000 to rs6000.
	* configure: Regenerate.

Tue Jun  8 05:47:48 1999  Richard Earnshaw (rearnsha@arm.com)

	* optabs.c (expand_cmplxdiv_wide): Use expand_abs to get the absolute
	values.

Mon Jun  7 22:30:37 1999  Jeffrey A Law  (law@cygnus.com)

	* fixinc/inclhack.def (avoid_bool): Also catch
	"typedef [unsigned] int bool".
	* fixinc/inclhack.sh, fixinc/fixincl.x, fixinc/fixincl.sh: Rebuilt.

	* m68k/x-hp3bsd44: Delete obsolete and incorrect file.
	* configure.in (m68k-hp-bsd4.4): No longer use x-hp3bsd44.
	* configure: Rebuilt.

Mon Jun  7 22:05:03 1999  Mark Kettenis  <kettenis@gnu.org>

	* config/i386/gnu.h: Include <gnu.h> right after <i386/linux.h>,
	such that we can override its definitions if necessary.
	(CPP_SPEC): New define.  Support processor specific predefines via
	%(cpp_cpu).
	(CC1_SPEC): New define.  Support processor specific compiler
	options via %(cc1_cpu).
	(STARTFILE_SPEC): New define.  Use crt0.o instead of crt1.o for
	-static.

1999-06-07  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* fixinc/inclhack.def (math_gcc_ifndefs): Insert whitespace
	between sed's -e flag, and the open-quote following it.
	* fixinc/fixincl.x, fixinc/fixincl.sh: Rebuilt.

Mon Jun  7 20:34:20 1999  Robert Lipe <robertlipe@usa.net>
	                  Jeffrey A Law  (law@cygnus.com)

	* varasm.c (assemble_start_function): Remove the function
	from the pending weak decls list when we define a function.
	(assemble_variable): Similarly for variables.
	(weak_finish): Ignore items on the list with a NULL name.
	(remove_from_ending_weak_list); New function to "remove" an item
	from the pending weak declarations list.

Mon Jun  7 19:27:07 1999  Jerry Quinn <jquinn@nortelnetworks.com>

	* pa.md (fmpyfadd, fmpynfadd, fnegabs): New patterns.

Mon Jun  7 14:07:39 1999  Dave Brolley  <brolley@cygnus.com>

	* c-lex.c (GETC): Redefine to call getch.
	(UNGETC): Redefine to call put_back.
	(putback_buffer): New structure type.
	(putback): New static structure.
	(getch): New function.
	(put_back): New function.
	(yylex): Replace unused bytes from bad multibyte character.

Mon Jun  7 13:33:39 1999  Dave Brolley  <brolley@cygnus.com>

	* cpplib.c (do_define): Cast `alloca' return value.
	(do_include, do_undef, do_pragma): Likewise.
	* cpphash.c (dump_definition): Cast `xstrdup' and `alloca' return
 	values.
	* cppfiles.c (initialize_input_buffer): Cast `xmalloc' return values.
	* gcc/cppspec.c (lang_specific_driver): Cast xmalloc return value.

Sun Jun  6 11:58:34 1999  Jakub Jelinek  <jj@ultra.linux.cz>

	* sparc.md (abstf2): This should be an expand.
	(split after abstf2_notv9): Fix mode.
	(abstf2_hq_v9): New pattern.
	(abstf2_v9): Only use when no hard quad.
	(absdf2_v9): Fix if target is not the same as source.
	(ashrsi3_extend, ashrsi3_extend2, lshrsi3_extend, lshrsi3_extend2):
	Add correct output constraints.

Sat Jun  5 17:04:16 1999  Craig Burley  <craig@jcb-sc.com>

	From Dave Love to egcs-patches on 20 May 1999 17:38:38 +0100:
	* invoke.texi: Clarify text vis-a-vis Intel CPUs.

Sat Jun  5 12:11:24 1999  Mark Mitchell  <mark@codesourcery.com>

	* mips.h (mips_output_conditional_branch): New function.
	(mips_adjust_insn_length): Likewise.
	(ASSEMBLER_SCRATCH_REGNUM): New macro.
	(ADJUST_INSN_LENGTH): Likewise.
	* mips.c (print_operand): Add `F' and `W' for floating-point
	comparison opcodes.
	(machine_dependent_reorg): Adjust MIPS16 code; instruction-lengths
	are now in bytes.
	(mips_adjust_insn_length): New function.
	(mips_output_conditional_branch): New function.
	* mips.md (length): Adjust attribute definition to handle
	conditional branches.  	Change lengths to bytes, rather than
	instructions throughout.  Remove length attribute from
	instructions whose length is four bytes, and rely on the default
	instead.
	(dslot): Fix typo in comment.
	Reword conditional branch patterns to use
	mips_output_conditional_branch.

Fri Jun  4 13:30:27 1999  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* alpha/osf.h (CPP_SUBTARGET_SPEC): Handle -threads.
	(LIB_SPEC): Likewise.
	Link with -lprof1_r for -g/-pg.

1999-06-04  Andreas Schwab  <schwab@issan.cs.uni-dortmund.de>

	* loop.c (check_dbra_loop): Fix change of Jan 19.

Fri Jun  4 00:12:40 1999  Marc Espie <espie@cvs.openbsd.org>

	* freebsd-elf.h (SWITCH_TAKES_ARG):  Redefine, not define.
	(STARTFILE_SPEC):  Define, override the svr4.h version.
	(ENDFILE_SPEC):  Likewise.

Thu Jun  3 23:58:55 1999  Jeffrey A Law  (law@cygnus.com)

	* fixinc/inclhack.def (limits_ifndefs): Also apply to sys/limits.h
	* fixinc/fixincl.x: Regenerated.
	* fixinc/inclhack.sh: Regenerated.

Fri Jun  4 05:42:23 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.c (barrier_align): Don't return early for normal branch/barrier
	when optimizing for SH2.

Thu Jun  3 22:27:50 1999  Robert Lipe  <robertlipe@usa.net>

	* i386/udk.h (LINK_SPEC): Correct linker search path for
	system libraries.

Fri Jun  4 03:20:40 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.c (fixup_addr_diff_vecs): Emit braf reference label.
	(braf_label_ref_operand): Delete.
	* sh.h (PREDICATE_CODES): Remove braf_label_ref_operand.
	* sh.md (casesi_jump_2): Operand1 is now the inside of a
	label_ref, and has no predicate.
	The patten has a predicate to guard against invalid substitutions.
	(dummy_jump): Delete.
	(casesi): Update use of casesi_jump_2.

Thu Jun 3 07:48 1999  Bruce Korb <ddsinc09@ix.netcom.com>

	*fixinc/inclhack.def(Io_Def_Quotes): corrected sed expression
	*fixinc/fixincl.x: regenerate
	*fixinc/inclhack.sh: regenerate

Thu Jun  3 02:15:07 1999  Jason Merrill  <jason@yorick.cygnus.com>

	* dwarf2out.c (add_incomplete_type): New fn.
	(gen_struct_or_union_type_die): Call it.
	(retry_incomplete_types): New fn.
	(dwarf2out_finish): Call it.

Thu Jun  3 01:19:03 1999  Jeffrey A Law  (law@cygnus.com)

	* gcse.c (insert_insn_end_bb): Correct placement of insns when the
	current block starts with a CODE_LABEL and ends with a CALL and
	we can not find all the argument setup instructions for the CALL.

Wed Jun  2 15:44:15 1999  Mark Mitchell <mark@codesourcery.com>

	Revert this change:
	* fold-const.c (fold): STRIP_NOPS when deciding whether or not
	something is a candidate for optimize_bit_field_compare.

Wed Jun  2 21:53:05 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.h (CONST_OK_FOR_I, CONST_OK_FOR_L): Cast VALUE to HOST_WIDE_INT.

Wed Jun  2 12:25:55 1999  Richard Henderson  <rth@cygnus.com>

	* alpha.c (override_options): Thinko in last patch.

	* alpha/osf.h (CPP_SUBTARGET_SPEC): Define.
	(LIB_SPEC): Recognize -pthread.

Wed Jun  2 08:42:55 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/tcoff.h (USER_LABEL_PREFIX): Synchronise with
	definition in config/arm/coff.h
	* config/arm/coff.h: Add comment about USER_LABEL_PREFIX.

Wed Jun  2 07:07 1999 Bruce Korb <ddsinc09@ix.netcom.com>

	* fixinc/fixincl.c(global def): Add FD_SHELL_SCRIPT to mark
	fixes that need "file=xxx\n" prepended before invocation
	(start_fixer - new): starting the fixer process is complex enough
	to warrent its own routine.  It prepends the "file=xxx\n" stuff.
	(process): uses the new routine; omit usage of putenv()
	* fixinc/fixincl.tpl: mark shell scripts with FD_SHELL_SCRIPT
	* fixinc/fixincl.x: regenerate

Wed Jun  2 02:29:07 1999  Jeffrey A Law  (law@cygnus.com)

	* README, configure.in, gcc.1, gcc.texi: Update name (egcs -> gcc)
	and version #s (1.1 -> 2.96) as needed.
	* README.g77: Kill way out of date file in the toplevel directory.

Wed Jun  2 00:52:34 1999  David O'Brien <obrien@FreeBSD.org>

	* configure.in (i[34567]86-*-freebsdelf): Don't include linux.h,
	i386/freebsd-elf.h no longer requires it.  Instead include svr4.h.
	* configure: Rebuilt.
	* i386/freebsd-elf.h (DEFAULT_VTABLE_THUNKS): Define.
	(ASM_COMMENT_START, ASM_APP_ON, ASM_APP_OFF, SET_ASM_OP): Likewise.
	(PREFERRED_DEBUGGING_TYPE, WCHAR_UNSIGNED): Likewise.
	(SWITCH_TAKES_ARG): Likewise.
	* i386/freebsd.h: Remove FREEBSD_NATIVE support.
	* config/t-freebsd: Moved from config/i386/ so it can used for all
	FreeBSD targets.

Mon May 31 02:22:55 1999  Philippe De Muyter  <phdm@macqel.be>

	* m68k/x-mot3300 (XCFLAGS): Fixed to match stb.o, not f/stb.o.

Wed Jun  2 00:08:34 1999  Robert Lipe  <robertlipe@usa.net>

	* configure.in (i[34567]86-*-udk*): Install headers with cpio.
	* configure: Rebuilt.

Tue Jun  1 19:06:22 1999  David Edelsohn  <edelsohn@gnu.org>

	* rs6000/aix41.h (RS6000_CALL_GLUE): Define.
	* rs6000/aix43.h (RS6000_CALL_GLUE): Likewise.
	* rs6000/rs6000.c (rs6000_file_start): Use putc.
	(rs6000_output_load_toc_table): Same.
	(output_prolog, output_mi_thunk): Same.
	* rs6000/rs6000.h (SELECT_SECTION): Formatting.
	(ASM_GLOBALIZE_LABEL): Use putc.

Mon May 31 15:23:23 1999  Richard Henderson  <rth@cygnus.com>

	* alpha.md (reload_*_help): New patterns and splitters.
	(reload_*): Use them.
	(mov[qh]i): Likewise.

Mon May 31 11:48:07 1999  Mark Mitchell  <mark@codesourcery.com>

	* cccp.c (handle_directive): Handle backslash-newlines in quoted
	strings correctly.

Mon May 31 09:36:11 1999  Cort Dougan  <cort@cs.nmt.edu>

	* rs6000/linux.h (LINK_SPEC): Use emulation elf32ppclinux.

Mon May 31 11:40:20 EDT 1999  John Wehle  (john@feith.com)

	* flow.c (mark_regs_live_at_end, insn_dead_p,
	mark_set_1, mark_used_regs): Only give FRAME_POINTER_REGNUM
	and HARD_FRAME_POINTER_REGNUM special treatment if reload
	hasn't run or the frame pointer is needed.
	* haifa-sched.c (attach_deaths): Likewise.
	* sched.c (attach_deaths): Likewise.

Mon May 31 00:46:17 1999  Jeffrey A Law  (law@cygnus.com)

	* jump.c (jump_optimize_1): Only set CAN_REACH_END if
	calculate_can_reach_end returns nonzero.

	* configure.in (native gas tests): Search for an assembler in the
	same manner that the installed compiler will.
	* configure: Rebuilt.
	* tm.texi (MD_EXEC_PREFIX): Note need to update configure.in too.

	* alias.c (find_base_term): Improve handling of addresses
	constructed from binary operations.

Sun May 30 14:29:17 1999  Eric Raskin (ehr@listworks.com)

	* dgux.h (STARTFILE_SPEC): Fix incorrectly matched curly-braces.

Sun May 30 14:19:13 1999  Jeffrey A Law  (law@cygnus.com)

	* function.h (cleanup_label, frame_offset): Declare.
	(tail_recursion_label, tail_recursion_reentry): Likewise.
	(arg_pointer_save_area, rtl_expr_chain): Likewise.
	* stmt.c (cleanup_label, frame_offset): Delete extern declarations.
	(tail_recursion_label, tail_recursion_reentry): Likewise.
	(arg_pointer_save_area, rtl_expr_chain): Likewise.

Sat May 29 19:08:10 1999  Philip Blundell  <philb@gnu.org>

	* config/arm/aout.h (ASM_OUTPUT_ALIGN): Only define if not already
	defined.
	* config/arm/elf.h (ASM_OUTPUT_ALIGN): Define.
	(MAX_OFILE_ALIGNMENT): Define.

Fri May 28 21:40 1999  Robert Lipe <robertlipe@usa.net>

	* fixincl.c: Replace local include scheme with #includes of
	gansidecl.h and system.h.
	* procopen.c:  Likewise.
	* server.c:  Likewise.

Fri May 28 03:47:03 1999  Eric Raskin (ehr@listworks.com)

	* i386/t-dgux (EXTRA_PARTS): Add crti.o
	(crti.o): Add build rule and dependencies.
	* fixinc/fixinc.dgux:  Use modified _int_varargs.h

Fri May 28 03:41:02 1999  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* rs6000/sysv4.h (CC1_SPEC): Add support for -profile
	(LIB_LINUX_SPEC): Likewise.
	(LIB_LINUX_SPEC): Add support for -pthread
	(CPP_OS_LINUX_SPEC): Likewise.
	(CPP_SYSV_SPEC): Avoid redefinitions if both -fpic and -fPIC are
	specified.

Thu May 27 13:04:52 1999  H.J. Lu  (hjl@gnu.org)

	* i386.c (output_fp_cc0_set): Don't check the JUMP_INSN code for
	conditional move.
	(notice_update_cc, output_float_compare): Enable TARGET_CMOVE support.
	(output_float_compare, output_fp_cc0_set): Fix the FLOAT comparison
	for IEEE math and CC_FCOMI.
	(put_jump_code): No IEEE if CC_FCOMI is set.

1999-05-27  Andreas Schwab  <schwab@issan.cs.uni-dortmund.de>

	* fold-const.c (fold_truthop): Make the field reference unsigned
	when converting a single bit compare.

Thu May 27 02:40:48 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* loop.c (strength_reduce): Don't do biv->giv conversion on constants.

Thu May 27 02:09:27 1999  Jeffrey A Law  (law@cygnus.com)

	* varasm.c (STRIP_NAME_ENCODING): Remove default definition.
	* output.h (STRIP_NAME_ENCODING): Strip '*' like the old varasm
	version did.

	* reload.c (push_reload): Do not call remove_address_replacements
	when presented with identical optional reloads.

Wed May 26 14:18:05 1999  Richard Henderson  <rth@cygnus.com>

	* alpha.h (MASK_FIX, TARGET_FIX): New.
	(MASK_*): Reorganize constants.
	(CPP_AM_FIX_SPEC): New.
	(TARGET_SWITCHES): Add FIX.
	(EXTRA_SPECS): Likewise.
	(CPP_CPU_EV6_SPEC): Use FIX, not CIX.
	(SECONDARY_MEMORY_NEEDED): Likewise.
	(REGISTER_MOVE_COST): Likewise.
	* alpha.c (override_options): Add FIX support.  Always use
	ALPHA_TP_PROG for ev6.
	* alpha.md (sqrt and mov[sd]i patterns): Use FIX, not CIX.
	* alpha/elf.h (ASM_FILE_START): Look at FIX too.
	* configure.in (target_cpu_default2) [ev6]: Use FIX, not CIX.

Wed May 26 09:53:05 1999  Mark Mitchell  <mark@codesourcery.com>

	* fold-const.c (fold): STRIP_NOPS when deciding whether or not
	something is a candidate for optimize_bit_field_compare.

Wed May 26 09:40:02 1999  Mark Mitchell  <mark@codesourcery.com>

	* gcc.texi (Passes): Document branch-shortening.
	* invoke.texi (Debugging Options): Document the fact that `-dp'
	outputs length information for instructions.

Wed May 26 08:49:31 1999  Nick Clifton  <nickc@cygnus.com>

	* flow.c: Revert previous delta.

Wed May 26 06:05:10 1999  Nick Clifton  <nickc@cygnus.com>

	* flow.c (insn_dead_p): Check against frame_pointer_rtx not
	FRAME_POINTER_REGNUM.
	(mark_set_1): Ditto.
	(mark_used_regs): Ditto.

Wed May 26 02:19:31 1999  Philip Blundell  <pb@nexus.co.uk>

	* arm.h (NEED_PLT_GOT): Fix mistake in last change.
	(GOT_PCREL): New macro.  Define to 1 if not already defined.
	* arm/elf.h (GOT_PCREL): Define to 0.
	* arm.c (arm_finalize_pic): Take into account the setting of
	GOT_PCREL.

Tue May 25 14:06:06 1999  Jeffrey A Law  (law@cygnus.com)

	* output.h (STRIP_NAME_ENCODING): Provide default definition.
	* dwarf2out.c (ASM_NAME_TO_STRING): Use STRIP_NAME_ENCODING.

	* flow.c (mark_set_1): Do not record BLKmode stores as dead
	store elimination candidates.

Tue May 25 08:55:57 1999  Gavin Romig-Koch  <gavin@cygnus.com>

	* config/mips/mips.h (ASM_OUTPUT_DOUBLE_INT) : Use 'dword' if
	TARGET_GAS.

Mon May 24 20:30:08 1999  Jim Wilson  <wilson@cygnus.com>

	* configure.in (rs6000-ibm-aix4.[12]*): Delete use of aix41-gld.h.
	Add use of x-aix41-gld.

Mon May 24 16:44:09 1999  Jakub Jelinek  <jj@ultra.linux.cz>

	* sparc/linux64.h (ASM_OUTPUT_CONSTRUCTOR): Define.
	(ASM_OUTPUT_DESTRUCTOR): Define.

Mon May 24 14:35:24 1999  Jeffrey A Law  (law@cygnus.com)

	* loop.c (strength_reduce): Do not clear NOT_EVERY_ITERATION at the
	last CODE_LABEL in a loop if we have previously passed a jump
	to the top of the loop.

Mon May 24 07:56:29 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.h (OUTPUT_INT_ADDR_CONST): Fix blunder made when
	applying Philip's patch.

Mon May 24 01:02:12 1999  Mark Mitchell  <mark@codesourcery.com>

	* stmt.c (expand_end_bindings): Ignore any elements of VARS that
	are not VAR_DECLs.

Sun May 23 20:31:16 1999  Jeffrey A Law  (law@cygnus.com)

	* loop.c (strength_reduce): Grow reg_single_usage as needed.

Sun May 23 10:13:20 1999  David O'Brien <obrien@FreeBSD.org>

	* i386/freebsd-elf.h (LINK_SPEC): Change -static to -Bstatic.
	Also remove a useless comment.

Sun May 23 10:05:23 1999  Jerry Quinn <jquinn@nortelnetworks.com>

	* pa.md (negdf2,negsf2):  Use fneg instead of fsub on pa 2.0.

Sat May 22 21:02:06 1999  David Edelsohn  <edelsohn@gnu.org>

	* collect2.c (main): Only generate import or export file and add
	to link arguments if non-empty.  Use xmalloc not alloca.
	(write_{export,import}_file): Delete.
	(write_aix_file): New function.
	(locatelib): Use xmalloc not malloc.
	(GCC_OK_SYMBOL): Do not check type if aix64.

Sat May 22 09:35:51 1999  Philip Blundell  <pb@nexus.co.uk>

	Based on patch by Scott Bambrough and Pat Beirne:
	* config/arm/arm.c (making_const_table): New variable.
	* config/arm/arm.h (making_const_table): Declare.
	(OUTPUT_INT_ADDR_CONST): Mark symbols as position independent if
	appropriate.
	* config/arm/arm.md (consttable_4, consttable_8, consttable_end):
	Keep track of when we are building the constant table.

Sat May 22 09:34:22 1999  Philip Blundell  <pb@nexus.co.uk>

	* config/arm/arm.c (arm_override_options): Fix erroneous warning
	message.

Sat May 22 09:06:33 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.h (NEED_PLT_GOT): Only define if not already
	defined.

Sat May 22 07:17:05 1999  Nick Clifton  <nickc@cygnus.com>

	* tm.texi (FUNCTION_ARG): Correct description of a stack element
	in a PARALLEL.

Sat May 22 01:27:49 1999  Mark Mitchell  <mark@codesourcery.com>

	* expr.h (lang_expand_constant): Guard with #ifdef TREE_CODE.

Fri May 21 21:19:02 1999  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* rs6000.c (output_mi_thunk): Enable full support again.

Fri May 21 20:09:52 1999  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.h (BRANCH_COST): Define.

Thu May 20 10:00:42 1999   Stephen L Moshier  <moshier@world.std.com>

	* Makefile.in (GCC_FOR_TARGET): Add -I$(build_tooldir)/include.

Thu May 20 09:58:57 1999  Jan Hubicka <hubicka@freesoft.cz>

	* function.c (assign_stack_local): Align stack slot propertly.
	(assign_outer_stack_local): Likewise.

Thu May 20 10:38:43 1999  Mark Mitchell  <mark@codesourcery.com>

	* expr.h (lang_expand_constant): Declare.
	* toplev.c (lang_expand_constant): Define it.
	* varasm.c (output_constant): Use it.

Thu May 20 11:28:53 1999  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* optabs.c (expand_cmplxdiv_straight, expand_cmplxdiv_wide):
	Change function definitions to K&R style.

Thu May 20 08:16:39 1999  Bruce Korb <ddsinc09@ix.netcom.com>

	* fixinc/fixincl.c: We must not ignore SIGCLD now.

Thu May 20 07:06:39 1999  Alexandre Oliva  <aoliva@acm.org>

	* fixinc/Makefile.in(gnu-regex.o): add $(INCLUDES) to compile options
	* fixinc/fixincl.c(wait_for_pid): K&R-ify arguments
	(several places): omit static initialization
	(process): use single fd, since only the read fd is used
	* fixinc/gnu-regex.c: define 'const' away, if not supported
	* fixinc/procopen.c(several places): omit static initialization
	* fixinc/server.c: define 'volitile' away, if not supported

1999-05-20  Andreas Schwab  <schwab@issan.cs.uni-dortmund.de>

	* config/dbxcoff.h (DBX_OUTPUT_MAIN_SOURCE_FILE_END): Use
	asm_fprintf and %L to generate the label name.
	* config/dbxelf.h (DBX_OUTPUT_MAIN_SOURCE_FILE_END): Likewise.
	(ASM_OUTPUT_SOURCE_LINE): Correct generation of internal labels.

Thu May 20 01:40:55 1999  Jeffrey A Law  (law@cygnus.com)

	* jump.c (can_reverse_comparison_p): Do not abort if the comparison
	insn for a conditional jump can not be found.

Wed May 19 23:58:58 1999  Jeffrey A Law  (law@cygnus.com)

	* mips.h (ENCODE_SECTION_INFO): Do not perform GP optimizations
	on variables in specific sections other than .sbss and .sdata.

Wed May 19 03:56:56 1999  Mark Mitchell  <mark@codesourcery.com>

	* stmt.c (expand_return): Call start_cleanup_deferral and
	end_cleanup_deferral around conditional code.

Wed May 19 08:40:08 1999  Bruce Korb <ddsinc09@ix.netcom.com>

	* fixinc/fixincl.tpl: Avoid depending on ANSI C features for
	filename lists.  Utilizes new "krstr" AutoGen function.
	* fixinc/fixincl.x: Rebuilt.

Wed May 19 02:47:11 1999  Jan Hubicka  (hubicka@freesoft.cz)

	* i386.c (output_float_compare): Avoid GNU-C extensions.

Wed May 19 00:34:40 1999  Jeffrey A Law  (law@cygnus.com)

	* version.c: Bump to distinguish mainline tree from the
	gcc-2.95 branch.

See ChangeLog.1 for earlier changes.

Local Variables:
add-log-time-format: current-time-string
End:
